<?php

use App\Service\Crypto;

$_ENV['APP_SECRET'] = 'a9cb07f5fe00bde78b322609c57533ae';
$autoloadFile = __DIR__ . '/../../vendor/';
$autoloadFile = realpath($autoloadFile).'/autoload.php';

if (true === file_exists($autoloadFile)) {
    require $autoloadFile;
}

function showBasicAuth() {
    header('WWW-Authenticate: Basic realm="phpMyAdmin"');
    header('HTTP/1.0 401 Unauthorized');
    exit;
}

function setSessionParameters($host, $userName, $password, $port = 3306) {
    $_SESSION['PMA_single_signon_host'] = $host;
    $_SESSION['PMA_single_signon_user'] = $userName;
    $_SESSION['PMA_single_signon_password'] = $password;
    $_SESSION['PMA_single_signon_port'] = $port;
    $_SESSION['PMA_single_signon_cfgupdate'] = ['verbose' => 'Signon'];
    if (false === isset($_SESSION['PMA_single_signon_token'])) {
        $_SESSION['PMA_single_signon_token'] = md5(uniqid(rand(), true));
    }
}

$host = (true === isset($_GET['host']) ? base64_decode(urldecode($_GET['host'])) : null);
$port = (true === isset($_GET['port']) ? (int)$_GET['port'] : 3306);
$httpsOn = (true === isset($_SERVER['HTTPS']) && 'on' == $_SERVER['HTTPS'] ? true : false);
$serverHost = $_SERVER['HTTP_HOST'] ?? '';
if (true === is_null($host)) {
    $redirectUrl = sprintf('%s://%s/pma', (true === $httpsOn ? 'https' : 'http'), $serverHost);
    header(sprintf('Location: %s', $redirectUrl));
    exit;
} else {
    session_set_cookie_params(0, '/', '', false);
    session_name('SignonSession');
    session_start();
    if (true === isset($_COOKIE['clp-pma']) && false === empty($_COOKIE['clp-pma'])) {
        $encryptedData = trim($_COOKIE['clp-pma']);
        $encryptedData = base64_decode($encryptedData);
        $decryptedData = Crypto::decrypt($encryptedData);
        $decryptedData = unserialize($decryptedData);
        if (false === empty($decryptedData)) {
            $host = $decryptedData['host'] ?? '';
            $userName = $decryptedData['userName'] ?? '';
            $password = $decryptedData['password'] ?? '';
            $port = $decryptedData['port'] ?? '';
            setSessionParameters($host, $userName, $password, $port);
        }
    } else {
        if ((false === isset($_SERVER['PHP_AUTH_USER']))) {
            showBasicAuth();
        } else {
            try {
                $userName = $_SERVER['PHP_AUTH_USER'] ?? 'null';
                $password = $_SERVER['PHP_AUTH_PW'] ?? 'null';
                $pdoOptions = [
                    \PDO::ATTR_TIMEOUT => 8,
                    \PDO::ATTR_ERRMODE => \PDO::ERRMODE_EXCEPTION
                ];
                $pdo = new \PDO(sprintf('mysql:host=%s;port=%s', $host, $port), $userName, $password, $pdoOptions);
                setSessionParameters($host, $userName, $password, $port);
            } catch (\Exception $e) {
                showBasicAuth();
            }
        }
    }
    session_write_close();
    header('Location: index.php');
    exit;
}
