<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\Validator\ValidatorInterface; use App\Command\Command as BaseCommand; use App\Entity\Database as DatabaseEntity; use App\System\CommandExecutor; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\System\Command\DeleteOldFilesRecursiveCommand; use App\System\Command\FindChmodCommand; use App\System\Command\ChownCommand; use App\Database\Exporter as DatabaseExporter; class DatabaseBackupCommand extends BaseCommand { private const RETENTION_PERIOD = 7; private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private CommandExecutor $commandExecutor; private ValidatorInterface $validator; private int $retentionPeriod = 0; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, ValidatorInterface $validator) { goto e44b9; eae0e: $this->validator = $validator; goto fc469; D44b1: $this->databaseEntityManager = $databaseEntityManager; goto Ecb70; Cff0f: $this->commandExecutor = new CommandExecutor(); goto eae0e; fc469: parent::__construct(); goto b2732; e44b9: $this->siteEntityManager = $siteEntityManager; goto D44b1; Ecb70: $this->databaseServerEntityManager = $databaseServerEntityManager; goto Cff0f; b2732: } protected function configure() : void { goto Ebab2; Ebab2: $this->setName("\144\x62\x3a\142\x61\x63\153\x75\x70"); goto E049a; B1682: $this->addOption("\x72\x65\x74\145\x6e\164\151\157\x6e\x50\x65\162\x69\157\x64", null, InputOption::VALUE_OPTIONAL, '', self::RETENTION_PERIOD); goto a4f41; Cb4e0: $this->addOption("\151\x67\x6e\x6f\x72\x65\104\141\164\x61\x62\141\x73\145\163", null, InputOption::VALUE_OPTIONAL); goto B1682; E049a: $this->setDescription("\x63\154\x70\x63\164\154\x20\144\x62\x3a\x62\x61\x63\153\165\x70\x20\55\55\151\x67\156\x6f\x72\x65\104\141\x74\141\x62\x61\163\145\163\x3d\47\x64\x62\61\54\144\142\x32\47\x20\55\55\162\x65\x74\145\x6e\164\x69\x6f\x6e\x50\x65\162\151\157\x64\75\x37"); goto Cb4e0; a4f41: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto f0498; d8930: a3985: goto a13d0; f9367: $ignoredDatabases = explode("\54", $input->getOption("\x69\x67\156\x6f\162\145\104\141\x74\141\142\141\x73\x65\x73")); goto Db1e2; Db1e2: $this->retentionPeriod = (int) $input->getOption("\x72\145\164\145\x6e\x74\151\157\x6e\x50\145\162\151\x6f\x64"); goto Ce950; Ce950: $siteEntities = $this->siteEntityManager->findAll(); goto E8b3c; a13d0: return BaseCommand::SUCCESS; goto D9353; f0498: $this->validateInput($input); goto f9367; Ef8ba: foreach ($siteEntities as $siteEntity) { goto Bc4c4; e750b: d2fb7: goto Ac232; Ac8ae: foreach ($databaseEntities as $databaseEntity) { goto ed8a0; Bfe1d: B5c50: goto B4669; D9df8: b469a: goto Bfe1d; B5286: if (!(false === in_array($databaseName, $ignoredDatabases))) { goto b469a; } goto Ee247; ed8a0: $databaseName = $databaseEntity->getName(); goto B5286; Ee247: $this->createDatabaseDump($databaseEntity); goto D9df8; B4669: } goto d5e84; d5e84: f456e: goto e750b; Bc4c4: $databaseEntities = $siteEntity->getDatabases(); goto a77df; Ac232: F9c78: goto F0ea7; a77df: if (!count($databaseEntities)) { goto d2fb7; } goto Ac8ae; F0ea7: } goto E98ce; E98ce: F0228: goto d8930; E8b3c: if (!count($siteEntities)) { goto a3985; } goto Ef8ba; D9353: } catch (\Exception $e) { goto e83b4; e83b4: $errorMessage = $e->getMessage(); goto dda4f; dda4f: $output->writeln(sprintf("\74\145\162\162\157\x72\x3e\x25\x73\74\x2f\x65\162\x72\x6f\x72\x3e", $errorMessage)); goto b6ced; b6ced: return BaseCommand::FAILURE; goto Ee18e; Ee18e: } } private function createDatabaseDump(DatabaseEntity $databaseEntity) : void { try { goto f7082; D7308: $databaseExporter->export(); goto Fc717; aa209: $backupDirectory = sprintf("\x2f\x68\157\155\x65\x2f\x25\x73\57\x62\141\x63\153\x75\x70\163\57\x64\x61\164\141\142\141\163\x65\x73\57", $siteUser); goto Da3c0; d7fae: $databaseExporter->setFile($outputFile); goto bda78; b5459: $outputFile = sprintf("\45\163\57\45\163", rtrim($outputDirectory, "\57"), sprintf("\45\x73\x5f\45\x73\x2e\x73\161\154\56\147\x7a", $databaseName, $dateTime->getTimestamp())); goto c9179; c9179: $databaseExporter = new DatabaseExporter($databaseEntity); goto d7fae; Da3c0: $outputDirectory = sprintf("\45\x73\57\x25\x73\x2f\x25\163\57", rtrim($backupDirectory, "\57"), $databaseName, $dateTime->format("\x59\x2d\x6d\55\x64")); goto b5459; Fc717: $this->resetPermissions($databaseEntity); goto b86a1; c803a: $databaseName = $databaseEntity->getName(); goto aa209; b86a1: $this->cleanUpBackups($databaseEntity); goto Afdab; Dc8a0: $siteUser = $siteEntity->getUser(); goto c803a; E2967: $siteEntity = $databaseEntity->getSite(); goto Dc8a0; bda78: $databaseExporter->createOutputDirectory(); goto D7308; f7082: $dateTime = new \DateTime("\x6e\x6f\167", new \DateTimeZone("\125\124\103")); goto E2967; Afdab: } catch (\Exception $e) { $logger = $this->getLogger(); $logger->exception($e); } } private function resetPermissions(DatabaseEntity $databaseEntity) { goto Bbaa0; cc978: $backupDirectoryChmodCommand = new FindChmodCommand(); goto ac77e; f262b: $this->commandExecutor->execute($backupDirectoryChmodCommand); goto C2859; db367: $siteUser = $siteEntity->getUser(); goto c8665; Dd5e7: $backupDirectoryChownCommand->setUser($siteUser); goto e6316; ac77e: $backupDirectoryChmodCommand->setFile($backupDirectory); goto Fbee5; Fbee5: $backupDirectoryChmodCommand->setDirectoryChmod(750); goto bfa62; bfa62: $backupDirectoryChmodCommand->setFileChmod(760); goto ca0d5; A947d: $backupDirectoryChownCommand->setFile($backupDirectory); goto a4d3b; Bbaa0: $siteEntity = $databaseEntity->getSite(); goto db367; e6316: $backupDirectoryChownCommand->setGroup($siteUser); goto cc978; ca0d5: $this->commandExecutor->execute($backupDirectoryChownCommand); goto f262b; a4d3b: $backupDirectoryChownCommand->setRecursive(true); goto Dd5e7; c8665: $backupDirectory = sprintf("\x2f\150\157\x6d\145\57\x25\x73\x2f\x62\141\143\153\165\x70\x73\57\144\x61\164\141\x62\141\163\145\163\x2f", $siteUser); goto f8812; f8812: $backupDirectoryChownCommand = new ChownCommand(); goto A947d; C2859: } private function cleanUpBackups(DatabaseEntity $databaseEntity) { goto b2210; E3240: $this->commandExecutor->execute($deleteOldBackupsCommand, 360); goto D1268; C882b: $siteUser = $siteEntity->getUser(); goto C0097; b2210: $siteEntity = $databaseEntity->getSite(); goto C882b; E643b: $deleteOldBackupsCommand = new DeleteOldFilesRecursiveCommand(); goto A454e; C0097: $databaseBackupDirectory = sprintf("\x2f\150\x6f\155\x65\x2f\45\x73\x2f\x62\141\143\153\165\160\x73\57\144\x61\164\141\x62\141\x73\145\163\x2f", $siteUser); goto E643b; A454e: $deleteOldBackupsCommand->setDirectory($databaseBackupDirectory); goto e608f; e608f: $deleteOldBackupsCommand->setRetentionPeriod($this->retentionPeriod); goto E3240; D1268: } }
