<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use App\Command\Command as BaseCommand; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Database\Importer as DatabaseImporter; use App\System\Command\CheckIfFileExistsCommand; use App\System\CommandExecutor; class DatabaseImportCommand extends BaseCommand { const SYSTEM_USER_ROOT = "\x72\157\x6f\164"; private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private CommandExecutor $commandExecutor; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseServerEntityManager $databaseServerEntityManager) { goto d439d; C4e59: $this->commandExecutor = new CommandExecutor(); goto Fada9; d439d: $this->siteEntityManager = $siteEntityManager; goto F4047; Fada9: parent::__construct(); goto Ee0fb; F4047: $this->databaseEntityManager = $databaseEntityManager; goto c5bea; c5bea: $this->databaseServerEntityManager = $databaseServerEntityManager; goto C4e59; Ee0fb: } protected function configure() : void { goto F8404; D67cf: $this->setDescription("\x63\154\x70\143\164\x6c\40\144\x62\x3a\151\155\x70\157\162\x74\40\x2d\x2d\144\x61\x74\x61\142\x61\163\x65\116\141\155\x65\x3d\155\171\x2d\144\x61\164\141\x62\x61\x73\145\x20\x2d\x2d\x66\x69\x6c\x65\x3d\144\165\155\160\x2e\x73\x71\x6c\x2e\147\172"); goto cc0a5; cc0a5: $this->addOption("\144\x61\164\141\x62\x61\x73\145\x4e\x61\155\x65", null, InputOption::VALUE_REQUIRED); goto Ce13b; F8404: $this->setName("\144\x62\72\151\155\160\157\162\x74"); goto D67cf; Ce13b: $this->addOption("\x66\x69\154\x65", null, InputOption::VALUE_REQUIRED); goto e39fb; e39fb: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto ae81a; F928d: $userIsAllowedToExport = true === $isSuperUser || true === $userBelongsToASite; goto fbc3c; Ab463: $databaseEntity = $this->databaseEntityManager->findOneByName($databaseName); goto f78bb; b3f64: if (!(true === $isSuperUser || $siteEntity === $databaseEntity->getSite())) { goto d2209; } goto e61f5; C5231: return BaseCommand::FAILURE; goto C7310; e28e3: $systemUserName = $_SERVER["\x53\x55\x44\x4f\x5f\x55\123\105\122"] ?? ''; goto Cb5d4; E667e: Ba6ce: goto C5231; dbeed: throw new \Exception(sprintf("\104\141\x74\x61\x62\x61\x73\x65\40\42\45\163\x22\x20\x64\x6f\x65\x73\x20\x6e\x6f\164\40\145\170\x69\163\x74\x2e", $databaseName)); goto ff163; f6600: $importFile = $input->getOption("\146\x69\x6c\x65"); goto e28e3; Cbfb7: $databaseName = $input->getOption("\x64\x61\164\x61\x62\x61\163\x65\x4e\x61\x6d\145"); goto f6600; Ccc6b: c9050: goto Dea06; ae81a: $this->validateInput($input); goto Cbfb7; Cb5d4: if (!("\144\145\166" == $_ENV["\x41\x50\x50\x5f\105\x4e\x56"])) { goto D6bec; } goto A5138; fbc3c: if (!(true === $userIsAllowedToExport)) { goto Ba6ce; } goto Ab463; Dea06: $this->checkIfFileExists($importFile); goto D6bea; Ef233: $output->writeln(sprintf("\74\151\x6e\x66\x6f\x3e\x49\155\x70\x6f\x72\164\40\x69\x6e\164\x6f\40\x64\x61\164\x61\x62\141\x73\x65\x3c\57\x69\156\146\157\76\40\x3c\143\157\155\x6d\145\x6e\164\x3e\45\x73\x3c\57\x63\x6f\155\155\145\x6e\x74\76\40\74\151\x6e\x66\157\x3e\167\x61\163\x20\163\165\x63\x63\145\163\x73\146\x75\154\56\x3c\57\151\x6e\146\x6f\x3e", $databaseName)); goto A9fe4; d8f11: $userBelongsToASite = false === is_null($siteEntity); goto e0eab; a98ac: d2b90: goto E667e; ff163: goto d2b90; goto A7972; e0eab: $isSuperUser = self::SYSTEM_USER_ROOT == $systemUserName; goto F928d; A7972: cd447: goto b3f64; A9fe4: return BaseCommand::SUCCESS; goto fb9ce; C25f9: if (!(false === str_contains($importFile, "\57"))) { goto c9050; } goto d4a4e; fb9ce: d2209: goto a98ac; e61f5: $databaseImporter = new DatabaseImporter($databaseEntity); goto Dfe2a; A5138: $systemUserName = self::SYSTEM_USER_ROOT; goto Be029; f78bb: if (false === is_null($databaseEntity)) { goto cd447; } goto dbeed; d4a4e: $importFile = sprintf("\x25\x73\x2f\45\163", rtrim(getcwd(), "\x2f"), $importFile); goto Ccc6b; Be029: D6bec: goto C25f9; D6bea: $siteEntity = $this->siteEntityManager->findOneByUser($systemUserName); goto d8f11; Dfe2a: $databaseImporter->import($importFile); goto Ef233; C7310: } catch (\Exception $e) { goto D40ae; D40ae: $errorMessage = $e->getMessage(); goto C2152; D5b59: return BaseCommand::FAILURE; goto B0817; C2152: $output->writeln(sprintf("\x3c\145\x72\x72\157\162\76\45\163\74\57\x65\x72\162\x6f\162\76", $errorMessage)); goto D5b59; B0817: } } private function checkIfFileExists(string $importFile) { try { goto d7186; d7186: $checkIfFileExistsCommand = new CheckIfFileExistsCommand(); goto e3150; e3150: $checkIfFileExistsCommand->setFile($importFile); goto Ceb0e; Ceb0e: $this->commandExecutor->execute($checkIfFileExistsCommand); goto A0081; A0081: } catch (\Exception $e) { throw new \Exception(sprintf("\106\151\x6c\145\x20\42\45\163\42\x20\x64\x6f\x65\163\40\x6e\x6f\164\x20\x65\x78\151\x73\164\x2e", $importFile)); } } }
