<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use App\Command\SiteCommand as SiteCommand; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\PrivateKey; use App\Site\Ssl\LetsEncryptClient; use App\Site\Ssl\LetsEncrypt\DomainValidationException; use App\Entity\Certificate as CertificateEntity; use App\Entity\Notification; use App\Notification\NotificationQueue; class LetsEncryptRenewCertificatesCommand extends SiteCommand { const RENEW_DAYS_BEFORE_EXPIRATION = 7; protected function configure() : void { $this->setName("\154\145\x74\x73\x2d\145\156\x63\162\x79\x70\x74\72\162\145\156\x65\x77\72\x63\145\162\x74\x69\146\151\143\141\x74\145\x73"); $this->setDescription("\143\x6c\160\143\x74\154\40\x6c\145\x74\163\x2d\x65\x6e\143\x72\171\160\x74\x3a\162\x65\156\145\x77\x3a\x63\x65\162\164\x69\146\151\143\x61\164\145\163"); } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto F6887; F1dfe: return SiteCommand::SUCCESS; goto A11aa; F6887: $siteEntities = $this->siteEntityManager->findAll(); goto b8c44; aedbf: Ecec0: goto a3e9f; b8c44: if (!count($siteEntities)) { goto a4588; } goto d00a2; a3e9f: a4588: goto F1dfe; d00a2: foreach ($siteEntities as $siteEntity) { goto bd123; bd123: $certificateEntity = $siteEntity->getCertificate(); goto A0504; A0504: if (!(CertificateEntity::TYPE_LETS_ENCRYPT == $certificateEntity->getType())) { goto E749c; } goto f7cd9; f7cd9: $this->renewCertificate($output, $certificateEntity); goto Bca00; Bca00: E749c: goto Bc26a; Bc26a: A268e: goto A2c5a; A2c5a: } goto aedbf; A11aa: } catch (\Exception $e) { goto f58e2; C5cac: return SiteCommand::FAILURE; goto de801; f58e2: $errorMessage = $e->getMessage(); goto d0b31; d0b31: $output->writeln(sprintf("\74\x65\162\162\157\x72\x3e\x25\163\74\x2f\145\162\x72\157\162\76", $errorMessage)); goto C5cac; de801: } } private function renewCertificate(OutputInterface $output, CertificateEntity $certificateEntity) { goto Daf41; Daf41: $now = new \DateTime("\156\x6f\167"); goto a9827; f2446: if (!($daysToExpire <= self::RENEW_DAYS_BEFORE_EXPIRATION)) { goto A9939; } goto fd78b; e294e: $daysToExpire = round(($expiresAt->getTimestamp() - $now->getTimestamp()) / 86400, 0); goto f2446; a9827: $expiresAt = $certificateEntity->getExpiresAt(); goto e294e; fd78b: try { goto B9e9f; Ff12e: $certificateEntity->setPrivateKey($certificate->getPrivateKey()); goto ac574; c4938: throw $domainValidationException; goto B8df0; ea990: $certificateEntity->setCertificateChain($certificate->getCertificateChain()); goto Fb433; C6a61: $renewingSuccessMessage = sprintf("\103\x65\x72\164\x69\146\x69\143\x61\x74\x65\x20\162\x65\156\145\167\151\156\147\x20\146\x6f\162\x20\164\150\x65\40\144\157\155\141\x69\156\40\42\45\163\x22\x20\x77\141\x73\x20\163\165\x63\x63\x65\x73\163\146\165\x6c\56", $domainName); goto Bd273; e5cad: $letsEncryptPrivateKey = $this->getConfigValue("\x6c\145\137\x70\162\151\166\141\x74\145\137\153\145\x79"); goto a8357; f6aee: $domainValidationException->setValidationErrors($validationErrors); goto c4938; B9e9f: $siteEntity = $certificateEntity->getSite(); goto e0156; C8500: $this->siteEntityManager->updateEntity($siteEntity); goto C6a61; C385e: a07fa: goto e679e; e41d0: $csr = $csrGenerator->generate(); goto C6ca6; C46c5: $distinguishedNameDomains = $domains; goto Fa33e; Cc272: $letsEncryptClient = new LetsEncryptClient($privateKey); goto d8248; Dd4a8: Dbcb5: goto C46c5; ccdd5: $siteUpdater = $this->getSiteUpdater($site); goto a08e2; F7928: $validationErrors = $letsEncryptClient->validateDomains($certificateOrder); goto fcd35; A1386: $certificateEntity->setCsr($certificate->getCsr()); goto Ff12e; bea5a: $site = $this->getSite($domainName); goto Ed8b4; fcd35: if (true === empty($validationErrors)) { goto Dbcb5; } goto fd180; dece3: $siteEntity->setCertificate($certificateEntity); goto C8500; a08e2: $siteUpdater->deleteLetsEncryptChallengeDirectory(); goto c73da; ad479: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto e41d0; e0156: $domainName = $siteEntity->getDomainName(); goto bea5a; Fb433: $siteUpdater->installCertificate($certificateEntity); goto dece3; Fdf36: $certificateOrder = $letsEncryptClient->requestOrder($domains); goto ccdd5; C6ca6: $certificate = $letsEncryptClient->finalizeOrder($certificateOrder, $privateKey, $csr); goto A1386; d8248: $letsEncryptClient->registerAccount(); goto Fdf36; a8357: $privateKey = new PrivateKey($letsEncryptPrivateKey); goto Cc272; eb81a: $distinguishedName = new DistinguishedName($commonName, $distinguishedNameDomains); goto C8b23; ac574: $certificateEntity->setCertificate($certificate->getCertificate()); goto ea990; B8df0: goto a07fa; goto Dd4a8; Ed8b4: $domains = $certificateEntity->getDomains(); goto e5cad; c73da: $siteUpdater->createLetsEncryptChallengeFiles($certificateOrder); goto F7928; Bd273: $output->writeln(sprintf("\74\x69\156\x66\157\76\45\x73\74\57\151\x6e\x66\157\76", $renewingSuccessMessage)); goto C385e; Fa33e: $commonName = array_shift($distinguishedNameDomains); goto eb81a; C8b23: $rsaKeyGenerator = new RsaKeyGenerator(); goto c76d2; fd180: $domainValidationException = new DomainValidationException("\104\157\x6d\x61\151\156\40\166\x61\154\151\x64\x61\164\x69\x6f\156\x20\x66\141\151\154\x65\144"); goto f6aee; c76d2: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto ad479; e679e: } catch (\Exception|DomainValidationException $e) { goto F3d95; f5a46: $this->addNotification($subject, $errorMessage); goto F0018; C9bb8: C5bc2: goto F8904; Fe401: $errorMessage = $e->getMessage(); goto D08e5; eaa59: b568a: goto Fce81; F3d95: if ($e instanceof DomainValidationException) { goto b568a; } goto Fe401; b5948: foreach ($e->getValidationErrors() as $domainName => $validationError) { $validationErrors[] = sprintf("\x25\163\72\40\x25\x73", $domainName, $validationError); Ffc5a: } goto Cd18c; F8904: $subject = sprintf("\x4c\145\164\x27\x73\x20\x45\x6e\x63\x72\x79\160\x74\40\x43\x65\162\x74\151\x66\151\x63\x61\164\x65\x20\x72\145\x6e\x65\167\40\146\x61\x69\x6c\x65\x64\x3a\x20\45\163\56", $domainName); goto f5a46; Fce81: $validationErrors = []; goto b5948; cd25a: $errorMessage = implode("\54\x20", $validationErrors); goto C9bb8; Cd18c: E1614: goto cd25a; D08e5: goto C5bc2; goto eaa59; F0018: } finally { if (!(true === isset($siteUpdater))) { goto C787a; } $siteUpdater->deleteLetsEncryptChallengeDirectory(); C787a: } goto Bf653; Bf653: A9939: goto F6555; F6555: } private function addNotification(string $subject, string $errorMessage) : void { goto fa904; c6b91: $notification->setMessage($errorMessage); goto ba7a6; dce56: NotificationQueue::addNotification($notification); goto f1ffe; d611c: $notification->setSubject($subject); goto c6b91; fa904: $notification = new Notification(); goto d611c; ba7a6: $notification->setSeverity(Notification::SEVERITY_CRITICAL); goto dce56; f1ffe: } }
