<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\SiteCommand as SiteCommand; use App\Entity\Site as SiteEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\NodejsSettings as NodejsSettingsEntity; use App\Site\NodejsSite; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\Util\Openssl; use App\Site\Nginx\Vhost\NodejsTemplate as NodejsVhostTemplate; use App\Site\Creator\NodejsSite as NodejsSiteCreator; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; class SiteAddNodejsCommand extends SiteCommand { private const VHOST_TEMPLATE_NAME = "\x4e\157\x64\x65\x6a\x73"; protected function configure() : void { goto F7fa2; bc404: $this->setComment("\101\x64\x64\151\156\147\40\x61\x20\x4e\x6f\144\x65\152\x73\x20\123\151\164\x65"); goto Fe50c; Be596: $this->addOption("\141\x70\160\x50\x6f\162\164", null, InputOption::VALUE_REQUIRED); goto Bff77; B0bf7: $this->setDescription("\x63\154\x70\143\164\154\x20\x73\151\x74\x65\72\141\144\x64\x3a\156\157\144\x65\152\x73\x20\55\55\144\157\x6d\141\x69\x6e\116\x61\x6d\145\x3d\167\167\x77\x2e\x64\157\x6d\141\151\156\56\x63\x6f\155\40\55\x2d\x6e\x6f\x64\145\152\163\x56\145\x72\x73\x69\157\156\75\61\x36\x20\x2d\55\x61\x70\160\x50\x6f\x72\164\x3d\x33\60\60\x30\x20\55\x2d\163\151\x74\145\x55\x73\x65\162\x3d\x6a\x6f\150\x6e\40\55\x2d\163\x69\164\145\x55\163\145\x72\120\x61\x73\x73\167\x6f\x72\144\x3d\x27\x21\x73\x65\143\162\145\164\x50\x61\x73\163\x77\x6f\162\x64\x21\47"); goto bc404; Fe50c: $this->addOption("\x64\x6f\x6d\141\151\x6e\116\141\155\145", null, InputOption::VALUE_REQUIRED); goto bd015; cfae0: $this->addOption("\163\151\x74\x65\x55\163\x65\162\x50\x61\163\163\x77\157\x72\144", null, InputOption::VALUE_REQUIRED); goto D06c6; Bff77: $this->addOption("\x73\151\164\145\x55\x73\145\162", null, InputOption::VALUE_REQUIRED); goto cfae0; bd015: $this->addOption("\x6e\157\x64\x65\x6a\x73\126\x65\162\x73\x69\x6f\x6e", null, InputOption::VALUE_REQUIRED); goto Be596; F7fa2: $this->setName("\163\x69\x74\145\x3a\141\144\x64\72\156\x6f\144\145\x6a\x73"); goto B0bf7; D06c6: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto cac7e; e102f: $vhostTemplate->resetProcessors(); goto aee55; B0015: $subdomain = false === empty($subdomain) ? $subdomain : null; goto F93ee; F93ee: $vhostTemplateEntity = $this->vhostTemplateEntityManager->findOneByName($vhostTemplate); goto E211a; A557d: $vhostTemplate->addProcessor(new RedirectServerNameProcessor()); goto dd242; cd489: $this->siteEntityManager->updateEntity($siteEntity); goto cfcb2; ac469: $nodejsSiteCreator->reloadNginxService(); goto a1c15; cfcb2: $output->writeln(sprintf("\74\x69\x6e\x66\157\x3e\123\x69\164\x65\74\57\151\x6e\x66\157\76\40\74\143\x6f\155\155\x65\x6e\164\x3e\x25\x73\74\x2f\143\157\x6d\x6d\x65\156\x74\76\40\74\151\156\146\x6f\x3e\x68\x61\x73\40\x62\x65\145\156\x20\x61\x64\x64\145\144\x2e\x3c\57\151\156\146\x6f\76", $domainName)); goto Fcbc3; f09fc: $appPort = (int) $input->getOption("\x61\160\160\120\x6f\x72\164"); goto Dfbfd; F65cb: if (!(false === is_null($subdomain) && "\x77\167\167" == $subdomain)) { goto E957c; } goto Cece6; a1c15: $nodejsSiteCreator->resetPermissions(); goto D83ac; Fd9bf: $certificateEntity->setSite($siteEntity); goto ffa80; c015e: $nodejsSettingsEntity->setSite($siteEntity); goto E17bd; f8fd8: if (0 == count($siteConstraints) && 0 == count($nodejsSettingsConstraints)) { goto c740d; } goto Ce4c0; E8896: $nodejsSite->setRegistrableDomain($registrableDomain); goto A4656; caedc: $redirectionVhostTemplate = file_get_contents($redirectionVhostTemplateFile); goto Adbb0; Baad0: $domainName = trim($input->getOption("\x64\157\155\x61\151\x6e\116\x61\155\145")); goto C192a; ba5b7: $siteEntity->setVhostTemplate($vhostTemplate); goto C2500; Bcd0b: $csr = $csrGenerator->generate(); goto F334a; F334a: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto Fd922; Bce53: $siteEntity->setCertificate($certificateEntity); goto Fc1fc; ab248: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\57\x2e\56\x2f\56\x2e\57\x72\145\163\x6f\x75\x72\143\145\x73\57\x6e\x67\x69\x6e\170\57\166\150\x6f\163\x74\137\164\x65\155\x70\154\141\164\145\57\162\145\x64\x69\162\x65\x63\164"); goto caedc; d8a5f: $siteEntity->setVhostTemplate($vhostTemplate->getContent()); goto F04b3; faa73: $siteEntity = $this->siteEntityManager->createEntity(); goto a992e; Ce4c0: $constraints = new ConstraintViolationList(); goto ccde9; Adbb0: if (!(false === empty($redirectionVhostTemplate))) { goto C6cff; } goto ff001; Fcbc3: return SiteCommand::SUCCESS; goto f4d00; Dfbfd: $siteUser = trim($input->getOption("\163\x69\164\145\125\163\145\162")); goto B4f46; B3ec7: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto c2721; d85ce: $nodejsSite->setVhostTemplate($siteEntity->getVhostTemplate()); goto a1364; a992e: $siteEntity->setType(SiteEntity::TYPE_NODEJS); goto fce24; ae7b6: goto Acc8a; goto daed1; Fafa1: $siteEntity->setRootDirectory($rootDirectory); goto e58fd; E5d22: $nodejsSite->setDomainName($domainName); goto E8896; F04b3: $siteEntity->setApplication($vhostTemplateEntity->getName()); goto cd489; A9768: $nodejsSite->setRootDirectory($siteEntity->getRootDirectory()); goto Eeee4; b92ca: $nodejsSiteCreator->createNvmDirectory(); goto e4d7e; e2e1e: $vhostTemplate->setContent($siteEntity->getVhostTemplate()); goto e102f; e8b4e: $siteEntity->setNodejsSettings($nodejsSettingsEntity); goto Edad0; b13ea: $subjectAlternativeNames[] = sprintf("\167\167\167\56\x25\x73", $domainName); goto A013e; B5118: $vhostTemplate->build(); goto d8a5f; daed1: Addb2: goto a8a8a; E17bd: $siteConstraints = $this->validator->validate($siteEntity); goto eade8; Ce0f1: $nodejsSite->setUser($siteEntity->getUser()); goto eba52; deef3: $certificateEntity->setPrivateKey($privateKey->getPEM()); goto D5077; E211a: if (false === is_null($vhostTemplateEntity)) { goto Addb2; } goto cef9b; fce24: $siteEntity->setDomainName($domainName); goto Fafa1; Aa4cd: $nodejsSiteCreator->createNginxVhost(); goto ac469; cac7e: $this->validateInput($input); goto Baad0; db48b: $certificateEntity->setType(CertificateEntity::TYPE_SELF_SIGNED); goto d4a32; cef96: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto a22e0; B921e: $nodejsSiteCreator->createPrivateKeyAndCertificate(); goto Aa4cd; D51db: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto Bcd0b; F5874: Da5f3: goto ba5b7; da8f0: if (!(true === is_null($subdomain) || "\x77\x77\x77" == $subdomain)) { goto Da5f3; } goto ab248; ccde9: $constraints->addAll($siteConstraints); goto ed86d; aee55: $vhostTemplate->addProcessor(new ServerNameProcessor()); goto A557d; be9f8: Acc8a: goto A1d56; Cece6: $subjectAlternativeNames[] = $registrableDomain; goto Dfc3f; B4f46: $siteUserPassword = trim($input->getOption("\163\151\x74\145\x55\x73\145\x72\x50\x61\163\163\167\x6f\x72\x64")); goto cef96; f4d00: F8c83: goto be9f8; F46e8: goto F8c83; goto A6c4c; befef: C6cff: goto F5874; eade8: $nodejsSettingsConstraints = $this->validator->validate($nodejsSettingsEntity); goto f8fd8; C2500: $nodejsSettingsEntity = new NodejsSettingsEntity(); goto e8b4e; F01ce: $subdomain = $resolvedDomainName->subDomain()->toString(); goto B0015; E828b: if (!(true === is_null($subdomain))) { goto b7d84; } goto b13ea; Fd922: $certificateEntity->setDefaultCertificate(true); goto db48b; b81c1: $nodejsSiteCreator->createRootDirectory(); goto Dab85; cef9b: throw new \Exception(sprintf("\126\x68\x6f\x73\164\x20\x54\145\x6d\x70\154\x61\x74\145\x20\42\x25\x73\42\x20\x64\x6f\145\x73\40\156\157\x74\40\145\x78\x69\x73\164\56", $vhostTemplate)); goto ae7b6; ed86d: $constraints->addAll($nodejsSettingsConstraints); goto A3a27; A4656: $nodejsSite->setSubdomain($subdomain); goto A9768; Cd9ab: $certificateEntity = $this->certificateEntityManager->createEntity(); goto Fd9bf; dd242: $vhostTemplate->addProcessor(new RedirectDomainProcessor()); goto B5118; c2721: $subjectAlternativeNames = []; goto E828b; d4a32: $certificateEntity->setCsr($csr); goto deef3; aa231: $nodejsSiteCreator->createUser(); goto b81c1; a8a8a: $vhostTemplate = $vhostTemplateEntity->getTemplate(); goto faa73; Dab85: $nodejsSiteCreator->createLogrotateFile(); goto b92ca; A6c4c: c740d: goto Cd9ab; ce0c1: $nodejsSettingsEntity->setPort($appPort); goto c015e; D83ac: $vhostTemplate = new NodejsVhostTemplate($nodejsSite); goto e2e1e; e020b: $nodejsVersion = (int) $input->getOption("\x6e\x6f\144\x65\152\x73\126\x65\162\163\x69\157\x6e"); goto f09fc; C192a: $vhostTemplate = self::VHOST_TEMPLATE_NAME; goto B19f8; E6e1a: $distinguishedName = new DistinguishedName($domainName, $subjectAlternativeNames); goto D51db; Eeee4: $nodejsSite->setNodejsSettings($nodejsSettingsEntity); goto D5fcc; ff001: $vhostTemplate = sprintf("\45\x73\x25\163", $redirectionVhostTemplate, $vhostTemplate); goto befef; eba52: $nodejsSite->setUserPassword($siteEntity->getUserPassword()); goto E5d22; A013e: b7d84: goto F65cb; Dfc3f: E957c: goto E6e1a; D5fcc: $nodejsSite->setCertificate($certificateEntity); goto d85ce; e58fd: $siteEntity->setUser($siteUser); goto f2690; Edad0: $nodejsSettingsEntity->setNodejsVersion($nodejsVersion); goto ce0c1; a1364: $nodejsSiteCreator = new NodejsSiteCreator($nodejsSite); goto aa231; B19f8: $rootDirectory = $domainName; goto e020b; Fc1fc: $nodejsSite = new NodejsSite(); goto Ce0f1; a22e0: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto F01ce; D5077: $certificateEntity->setCertificate($selfSignedCertificate); goto Bce53; ffa80: $rsaKeyGenerator = new RsaKeyGenerator(); goto B3ec7; A3a27: return $this->renderConstraints($constraints, $output); goto F46e8; f2690: $siteEntity->setUserPassword($siteUserPassword); goto da8f0; e4d7e: $nodejsSiteCreator->installNodejs(); goto B921e; A1d56: } catch (\Exception $e) { goto Ff13a; Fcc06: $output->writeln(sprintf("\x3c\x65\x72\x72\157\x72\76\45\163\74\57\145\x72\x72\x6f\x72\x3e", $errorMessage)); goto bc0b3; Ff13a: $errorMessage = $e->getMessage(); goto Fcc06; bc0b3: return SiteCommand::FAILURE; goto a613b; a613b: } } }
