<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\SiteCommand as SiteCommand; use App\Entity\Site as SiteEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\PythonSettings as PythonSettingsEntity; use App\Site\PythonSite; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\Util\Openssl; use App\Site\Nginx\Vhost\PythonTemplate as PythonVhostTemplate; use App\Site\Creator\PythonSite as PythonSiteCreator; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; class SiteAddPythonCommand extends SiteCommand { private const VHOST_TEMPLATE_NAME = "\x50\171\x74\x68\x6f\x6e"; protected function configure() : void { goto B6e6f; Df1ce: $this->addOption("\160\x79\x74\x68\x6f\x6e\126\145\x72\x73\151\x6f\156", null, InputOption::VALUE_REQUIRED); goto a113e; cfb4e: $this->addOption("\x73\151\x74\x65\x55\x73\x65\162", null, InputOption::VALUE_REQUIRED); goto e25ab; a113e: $this->addOption("\141\160\160\120\x6f\x72\164", null, InputOption::VALUE_REQUIRED); goto cfb4e; e25ab: $this->addOption("\x73\x69\164\145\125\x73\145\x72\120\x61\x73\163\x77\157\162\x64", null, InputOption::VALUE_REQUIRED); goto Ed591; B896b: $this->setDescription("\143\154\160\143\164\x6c\x20\x73\151\164\145\72\141\144\x64\72\x70\171\164\150\157\156\x20\x2d\x2d\x64\x6f\x6d\141\x69\x6e\116\x61\x6d\x65\75\x77\x77\x77\56\144\x6f\x6d\x61\x69\156\x2e\x63\x6f\155\x20\55\55\160\x79\164\x68\157\x6e\x56\x65\x72\163\151\157\156\x3d\x33\x2e\x39\40\x2d\x2d\141\160\x70\x50\157\162\164\75\x38\60\x38\60\40\x2d\55\163\x69\164\145\125\x73\x65\162\x3d\x6a\157\150\x6e\40\55\55\x73\x69\164\145\x55\x73\x65\162\120\141\163\163\167\x6f\162\x64\x3d\x27\x21\x73\145\x63\x72\x65\x74\x50\x61\x73\x73\167\x6f\162\x64\x21\x27"); goto bbe50; bbe50: $this->setComment("\x41\x64\144\151\156\x67\40\x61\40\x50\x79\164\150\157\156\40\123\151\164\145"); goto Faf20; Faf20: $this->addOption("\144\157\x6d\141\x69\156\116\x61\155\145", null, InputOption::VALUE_REQUIRED); goto Df1ce; B6e6f: $this->setName("\x73\x69\164\145\72\141\144\144\x3a\x70\x79\x74\x68\157\x6e"); goto B896b; Ed591: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto B3f45; A9293: if (!(false === is_null($subdomain) && "\167\167\x77" == $subdomain)) { goto D2027; } goto b7177; Cee8f: $pythonSiteCreator->reloadNginxService(); goto A5dd2; c2919: b4d8c: goto D254b; F4b01: $siteConstraints = $this->validator->validate($siteEntity); goto Cc0da; C1776: $certificateEntity->setType(CertificateEntity::TYPE_SELF_SIGNED); goto d541d; Eafde: $pythonSiteCreator->createNginxVhost(); goto Cee8f; D9b28: $siteUserPassword = trim($input->getOption("\x73\151\x74\x65\x55\163\x65\162\x50\x61\x73\x73\167\x6f\x72\x64")); goto aa637; D254b: e4ef9: goto f965c; f4283: throw new \Exception(sprintf("\x56\150\157\x73\x74\40\124\x65\x6d\x70\x6c\x61\x74\145\40\42\x25\x73\42\40\144\157\145\x73\x20\x6e\157\164\40\x65\x78\151\163\x74\x2e", $vhostTemplate)); goto e2695; Cea00: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\x2f\56\56\57\56\56\57\x72\145\163\x6f\165\x72\143\x65\x73\57\156\x67\x69\x6e\170\57\x76\x68\157\163\x74\x5f\164\x65\155\x70\x6c\141\164\145\57\x72\x65\144\x69\x72\145\x63\164"); goto Cdf25; Cc536: A7a3b: goto E825a; e307a: e1b2d: goto f565f; c1eba: $pythonSiteCreator = new PythonSiteCreator($pythonSite); goto ff5d7; fe290: if (!(true === is_null($subdomain) || "\x77\167\x77" == $subdomain)) { goto e4ef9; } goto Cea00; Af90a: $pythonSite->setRootDirectory($siteEntity->getRootDirectory()); goto C69bc; B25f1: $pythonSettingsEntity->setSite($siteEntity); goto F4b01; Dded1: $pythonSite = new PythonSite(); goto A9358; b6c36: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto Ad8d8; C69bc: $pythonSite->setPythonSettings($pythonSettingsEntity); goto D40ad; da8b4: $siteEntity->setApplication($vhostTemplateEntity->getName()); goto C8460; D2c63: $certificateEntity->setPrivateKey($privateKey->getPEM()); goto a0692; F0b86: $pythonSiteCreator->writePythonVersionFile(); goto E71e4; ae2ae: $constraints->addAll($pythonSettingsConstraints); goto Cc39d; e4855: $pythonSite->setVhostTemplate($siteEntity->getVhostTemplate()); goto c1eba; f3fdc: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto B7515; ecbc9: $distinguishedName = new DistinguishedName($domainName, $subjectAlternativeNames); goto b4e78; D40ad: $pythonSite->setCertificate($certificateEntity); goto e4855; b7177: $subjectAlternativeNames[] = $registrableDomain; goto bd0d9; Df8f4: $appPort = (int) $input->getOption("\141\x70\160\120\x6f\162\x74"); goto b873f; f565f: $certificateEntity = $this->certificateEntityManager->createEntity(); goto A9702; fafce: $rsaKeyGenerator = new RsaKeyGenerator(); goto E4aa2; B7515: $certificateEntity->setDefaultCertificate(true); goto C1776; c286f: $pythonSettingsEntity->setPort($appPort); goto B25f1; f965c: $siteEntity->setVhostTemplate($vhostTemplate); goto C5c49; D5f2f: $vhostTemplate = self::VHOST_TEMPLATE_NAME; goto b95a1; e5cfa: $siteEntity->setUser($siteUser); goto cc33e; B62ba: return SiteCommand::SUCCESS; goto E94c7; B161c: $subdomain = false === empty($subdomain) ? $subdomain : null; goto f2606; D9256: $vhostTemplate = $vhostTemplateEntity->getTemplate(); goto c1674; C91a0: $output->writeln(sprintf("\x3c\x69\156\146\x6f\x3e\x53\x69\x74\x65\x3c\x2f\x69\x6e\146\157\76\x20\x3c\143\157\155\155\x65\156\x74\76\45\x73\74\57\143\157\x6d\x6d\x65\x6e\x74\76\40\x3c\x69\x6e\146\x6f\x3e\150\x61\163\40\x62\x65\x65\x6e\40\x61\144\144\145\144\56\x3c\x2f\151\156\x66\157\76", $domainName)); goto B62ba; Ed28e: F3198: goto A9293; E0cc5: $pythonSite->setDomainName($domainName); goto de3cc; E4aa2: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto Be5f5; b873f: $siteUser = trim($input->getOption("\163\x69\x74\145\125\x73\x65\x72")); goto D9b28; bd0d9: D2027: goto ecbc9; E71e4: $pythonSiteCreator->createPrivateKeyAndCertificate(); goto Eafde; fa544: if (!(true === is_null($subdomain))) { goto F3198; } goto B41d6; e2695: goto A7a3b; goto c4a59; D1ede: $vhostTemplate->build(); goto a0a6f; Ea0cf: $pythonSettingsEntity->setPythonVersion($pythonVersion); goto c286f; ae877: $vhostTemplate->addProcessor(new ServerNameProcessor()); goto A0ced; d541d: $certificateEntity->setCsr($csr); goto D2c63; B3ab4: goto cf210; goto e307a; Be5f5: $subjectAlternativeNames = []; goto fa544; a0692: $certificateEntity->setCertificate($selfSignedCertificate); goto B90f0; E0379: $siteEntity->setRootDirectory($rootDirectory); goto e5cfa; Cc39d: return $this->renderConstraints($constraints, $output); goto B3ab4; B14e2: $pythonSiteCreator->createRootDirectory(); goto F153d; F3b68: $vhostTemplate = sprintf("\45\x73\x25\163", $redirectionVhostTemplate, $vhostTemplate); goto c2919; A5dd2: $pythonSiteCreator->resetPermissions(); goto Cc286; A0ced: $vhostTemplate->addProcessor(new RedirectServerNameProcessor()); goto D8cbe; aa637: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto b6c36; C5c49: $pythonSettingsEntity = new PythonSettingsEntity(); goto af341; Cc0da: $pythonSettingsConstraints = $this->validator->validate($pythonSettingsEntity); goto d902d; d4e57: $siteEntity->setType(SiteEntity::TYPE_PYTHON); goto C4a2c; A2a7a: if (false === is_null($vhostTemplateEntity)) { goto C9f32; } goto f4283; A9702: $certificateEntity->setSite($siteEntity); goto fafce; e4e9f: $pythonVersion = $input->getOption("\x70\x79\164\x68\x6f\156\126\145\x72\x73\x69\157\156"); goto Df8f4; A9358: $pythonSite->setUser($siteEntity->getUser()); goto a85c7; E94c7: cf210: goto Cc536; af341: $siteEntity->setPythonSettings($pythonSettingsEntity); goto Ea0cf; ff5d7: $pythonSiteCreator->createUser(); goto B14e2; Ad8d8: $subdomain = $resolvedDomainName->subDomain()->toString(); goto B161c; cc33e: $siteEntity->setUserPassword($siteUserPassword); goto fe290; a4146: $constraints = new ConstraintViolationList(); goto B8612; B9fcf: $domainName = trim($input->getOption("\x64\157\155\x61\x69\156\116\x61\155\x65")); goto D5f2f; d902d: if (0 == count($siteConstraints) && 0 == count($pythonSettingsConstraints)) { goto e1b2d; } goto a4146; D8cbe: $vhostTemplate->addProcessor(new RedirectDomainProcessor()); goto D1ede; a0a6f: $siteEntity->setVhostTemplate($vhostTemplate->getContent()); goto da8b4; ca3b3: $vhostTemplate->resetProcessors(); goto ae877; ed2a2: $pythonSite->setSubdomain($subdomain); goto Af90a; C4a2c: $siteEntity->setDomainName($domainName); goto E0379; B3f45: $this->validateInput($input); goto B9fcf; Bfb3b: $csr = $csrGenerator->generate(); goto f3fdc; B90f0: $siteEntity->setCertificate($certificateEntity); goto Dded1; A77be: $vhostTemplate->setContent($siteEntity->getVhostTemplate()); goto ca3b3; b95a1: $rootDirectory = $domainName; goto e4e9f; a85c7: $pythonSite->setUserPassword($siteEntity->getUserPassword()); goto E0cc5; Cc286: $vhostTemplate = new PythonVhostTemplate($pythonSite); goto A77be; c6ea5: if (!(false === empty($redirectionVhostTemplate))) { goto b4d8c; } goto F3b68; b4e78: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto Bfb3b; de3cc: $pythonSite->setRegistrableDomain($registrableDomain); goto ed2a2; B8612: $constraints->addAll($siteConstraints); goto ae2ae; c1674: $siteEntity = $this->siteEntityManager->createEntity(); goto d4e57; C8460: $this->siteEntityManager->updateEntity($siteEntity); goto C91a0; c4a59: C9f32: goto D9256; F153d: $pythonSiteCreator->createLogrotateFile(); goto F0b86; f2606: $vhostTemplateEntity = $this->vhostTemplateEntityManager->findOneByName($vhostTemplate); goto A2a7a; Cdf25: $redirectionVhostTemplate = file_get_contents($redirectionVhostTemplateFile); goto c6ea5; B41d6: $subjectAlternativeNames[] = sprintf("\167\167\x77\x2e\45\163", $domainName); goto Ed28e; E825a: } catch (\Exception $e) { goto A8efb; D005a: return SiteCommand::FAILURE; goto f1ad5; C1906: $output->writeln(sprintf("\x3c\x65\x72\x72\157\162\76\x25\x73\x3c\57\x65\162\x72\x6f\162\x3e", $errorMessage)); goto D005a; A8efb: $errorMessage = $e->getMessage(); goto C1906; f1ad5: } } }
