<?php
 namespace App\Command; use Symfony\Component\Validator\Validator\ValidatorInterface; use Symfony\Component\Validator\ConstraintViolationList; use Doctrine\Common\Collections\ArrayCollection; use App\Command\Command as BaseCommand; use App\Entity\Site as SiteEntity; use App\Site\Site; use App\Site\NodejsSite; use App\Site\StaticSite; use App\Site\PhpSite; use App\Site\PythonSite; use App\Site\Deleter as SiteDeleter; use App\Site\Updater as SiteUpdater; use App\Site\Updater\NodejsSite as NodejsSiteUpdater; use App\Site\Updater\StaticSite as StaticSiteUpdater; use App\Site\Updater\PhpSite as PhpSiteUpdater; use App\Site\Updater\PythonSite as PythonSiteUpdater; use App\Site\Deleter\NodejsSite as NodejsSiteDeleter; use App\Site\Deleter\StaticSite as StaticSiteDeleter; use App\Site\Deleter\PhpSite as PhpSiteDeleter; use App\Site\Deleter\PythonSite as PythonSiteDeleter; use App\Site\Parser\DomainName as DomainNameParser; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\CertificateManager as CertificateEntityManager; use App\Entity\Manager\VhostTemplateManager as VhostTemplateEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; class SiteCommand extends BaseCommand { protected DomainNameParser $domainNameParser; protected SiteEntityManager $siteEntityManager; protected CertificateEntityManager $certificateEntityManager; protected DatabaseServerEntityManager $databaseServerEntityManager; protected VhostTemplateEntityManager $vhostTemplateEntityManager; protected ValidatorInterface $validator; public function __construct(DomainNameParser $domainNameParser, SiteEntityManager $siteEntityManager, CertificateEntityManager $certificateEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, VhostTemplateEntityManager $vhostTemplateEntityManager, ValidatorInterface $validator) { goto A592a; e882a: $this->validator = $validator; goto a339e; d97c3: $this->vhostTemplateEntityManager = $vhostTemplateEntityManager; goto e882a; A592a: $this->domainNameParser = $domainNameParser; goto D804f; a339e: parent::__construct(); goto Cce02; C81cd: $this->certificateEntityManager = $certificateEntityManager; goto a8d21; D804f: $this->siteEntityManager = $siteEntityManager; goto C81cd; a8d21: $this->databaseServerEntityManager = $databaseServerEntityManager; goto d97c3; Cce02: } protected function configure() : void { $this->setName("\163\151\x74\145\x3a\x74\x6d\x70"); } protected function getSite(string $domainName) : ?Site { goto D54dc; ec08f: $site->setDatabases($siteDatabases); goto a8db1; E835a: a6f45: goto A8d98; A225f: return $site; goto d97e1; e7bf8: $site->setPageSpeedSettings($siteEntity->getPageSpeedSettings()); goto E835a; eca02: throw new \Exception(sprintf("\x53\151\164\145\40\x22\45\163\x22\x20\144\157\145\163\40\156\x6f\x74\40\x65\170\151\x73\x74\x2e", $domainName)); goto df1ac; D54dc: $site = null; goto e9c33; c03de: $site->setSshUsers($siteEntity->getSshUsers()); goto b2353; D2376: $site->setBlockedIps($siteEntity->getBlockedIps()); goto Def11; cb187: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto D4273; e1051: goto adc12; goto Aa963; D4273: $site = new NodejsSite(); goto Bc1fc; Bc1fc: $site->setNodejsSettings($siteEntity->getNodejsSettings()); goto e1051; Aa963: case SiteEntity::TYPE_STATIC: $site = new StaticSite(); goto adc12; case SiteEntity::TYPE_PHP: goto ad519; ad519: $site = new PhpSite(); goto d3389; d3389: $site->setPhpSettings($siteEntity->getPhpSettings()); goto fd845; fd845: goto adc12; goto A2366; A2366: case SiteEntity::TYPE_PYTHON: goto affe4; D0fd1: goto adc12; goto e0f77; E4f61: $site->setPythonSettings($siteEntity->getPythonSettings()); goto D0fd1; affe4: $site = new PythonSite(); goto E4f61; e0f77: } goto A83db; A38c9: adc12: goto F3b32; d863d: $site->setPageSpeedEnabled($siteEntity->getPageSpeedEnabled()); goto e7bf8; D80de: $site->setDomainName($siteEntity->getDomainName()); goto e1cb6; A83db: ea993: goto A38c9; e606e: $siteDatabases = $this->getSiteDatabases($siteEntity); goto ae7fa; B9340: $site->setFtpUsers($siteEntity->getFtpUsers()); goto c03de; B99d8: $siteType = $siteEntity->getType(); goto cb187; F08e3: $site->setAllowTrafficFromCloudflareOnly($siteEntity->allowTrafficFromCloudflareOnly()); goto d863d; ba1e5: $site->setCronJobs($siteEntity->getCronJobs()); goto B9340; E33ca: $site->setSubdomain($subdomain); goto c7743; df1ac: goto Faf12; goto Da292; ae7fa: $site->setUser($siteEntity->getUser()); goto D80de; Bb287: $site->setBlockedBots($siteEntity->getBlockedBots()); goto D2376; c7743: $site->setRootDirectory($siteEntity->getRootDirectory()); goto ec08f; Def11: $site->setCertificate($siteEntity->getCertificate()); goto F62ff; e9c33: $siteEntity = $this->getSiteEntity($domainName); goto E71fc; be0a6: $subdomain = $resolvedDomainName->subDomain()->toString(); goto e69cf; b2353: $site->setVhostTemplate($siteEntity->getVhostTemplate()); goto F08e3; B4159: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto be0a6; Da292: ec946: goto B99d8; e69cf: $subdomain = false === empty($subdomain) ? $subdomain : null; goto e606e; E71fc: if (false === is_null($siteEntity)) { goto ec946; } goto eca02; b7522: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto B4159; e1cb6: $site->setRegistrableDomain($registrableDomain); goto E33ca; F62ff: $site->setCertificates($siteEntity->getCertificates()); goto ba1e5; F3b32: if (!(false === is_null($site))) { goto a6f45; } goto b7522; a8db1: $site->setBasicAuth($siteEntity->getBasicAuth()); goto Bb287; A8d98: Faf12: goto A225f; d97e1: } private function getSiteDatabases(SiteEntity $siteEntity) : ?ArrayCollection { goto dbec2; e94c2: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto C1ed2; A826b: foreach ($databaseEntities as $databaseEntity) { goto cf058; ceceb: Fba41: goto b161a; Ac813: if (!($databaseServerEntity->getId() == $activeDatabaseServerEntity->getId())) { goto Fba41; } goto e11bd; cf058: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto Ac813; e11bd: $siteDatabases->add($databaseEntity); goto ceceb; b161a: A71ae: goto e09df; e09df: } goto F2825; F2825: a5e61: goto a9ddc; dbec2: $siteDatabases = new ArrayCollection(); goto e94c2; a9ddc: return $siteDatabases; goto C3c80; C1ed2: $databaseEntities = $siteEntity->getDatabases(); goto A826b; C3c80: } protected function getSiteDeleter(Site $site) : ?SiteDeleter { goto d97f3; d52e9: $siteType = $site->getType(); goto B1f42; B1f42: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteDeleter = new NodejsSiteDeleter($site); goto b8bb6; case SiteEntity::TYPE_STATIC: $siteDeleter = new StaticSiteDeleter($site); goto b8bb6; case SiteEntity::TYPE_PHP: $siteDeleter = new PhpSiteDeleter($site); goto b8bb6; case SiteEntity::TYPE_PYTHON: $siteDeleter = new PythonSiteDeleter($site); goto b8bb6; } goto cf4d8; E8c62: return $siteDeleter; goto fd0fc; Ed982: b8bb6: goto E8c62; cf4d8: ddbcb: goto Ed982; d97f3: $siteDeleter = null; goto d52e9; fd0fc: } protected function getSiteUpdater(Site $site) : ?SiteUpdater { goto e4136; e4136: $siteUpdater = null; goto b7786; D06fb: af73e: goto f1a75; f1a75: return $siteUpdater; goto Cd411; Cb1bd: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteUpdater = new NodejsSiteUpdater($site); goto af73e; case SiteEntity::TYPE_STATIC: $siteUpdater = new StaticSiteUpdater($site); goto af73e; case SiteEntity::TYPE_PHP: $siteUpdater = new PhpSiteUpdater($site); goto af73e; case SiteEntity::TYPE_PYTHON: $siteUpdater = new PythonSiteUpdater($site); goto af73e; } goto Cc944; b7786: $siteType = $site->getType(); goto Cb1bd; Cc944: a98e3: goto D06fb; Cd411: } protected function getSiteEntity(string $domainName) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByDomainName($domainName); return $siteEntity; } protected function prepareConstraints(ConstraintViolationList $constraints) : void { $this->changePropertyPath("\165\163\x65\162", "\x73\x69\x74\x65\x55\163\x65\x72", $constraints); $this->changePropertyPath("\x75\x73\x65\x72\120\141\163\163\x77\157\162\x64", "\x73\151\x74\145\x55\163\145\162\120\141\x73\163\x77\157\x72\x64", $constraints); } }
