<?php
 namespace App\Controller\Admin; use Symfony\Component\Form\FormError; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Component\Form\Extension\Core\Type\SubmitType; use Symfony\Contracts\Translation\TranslatorInterface; use Symfony\Component\Form\Form; use App\Controller\Controller; use App\Event\EventQueue; use App\Service\Crypto; use App\Service\Logger; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Database\Connection as DatabaseConnection; use App\Entity\Manager\ConfigManager; use App\Entity\Certificate as CertificateEntity; use App\Entity\DatabaseServer as DatabaseServerEntity; use App\Security\Admin\CustomDomain as AdminCustomDomain; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\PrivateKey; use App\Site\Ssl\Certificate; use App\Site\Ssl\LetsEncryptClient; use App\Site\Ssl\Util\Openssl; class SettingsController extends Controller { private ConfigManager $configManager; private DatabaseServerEntityManager $databaseServerEntityManager; public function __construct(ConfigManager $configManager, DatabaseServerEntityManager $databaseServerEntityManager, TranslatorInterface $translator, Logger $logger) { goto Cf530; f0d07: $this->databaseServerEntityManager = $databaseServerEntityManager; goto B9e17; Cf530: $this->configManager = $configManager; goto f0d07; B9e17: parent::__construct($translator, $logger); goto fd0a5; fd0a5: } public function settings(Request $request) : Response { goto d7bf6; f8246: Dcde8: goto Fa08b; aa949: if (!(false === is_null($response))) { goto Dcde8; } goto d5b72; d7bf6: $customDomainName = $this->configManager->get("\143\165\x73\164\x6f\x6d\137\144\157\x6d\x61\151\156"); goto e5785; ac4bf: $response = $this->render("\x41\x64\155\151\x6e\57\x53\145\x74\164\x69\156\x67\163\x2f\x69\x6e\144\145\x78\56\150\x74\x6d\154\56\x74\x77\x69\147", ["\x63\165\x73\x74\157\x6d\104\x6f\x6d\x61\151\x6e\106\157\162\155" => $customDomainForm->createView(), "\146\x6f\162\x6d\x45\x72\x72\x6f\162\163" => $this->formErrors]); goto b1efe; fb1d1: $customDomainForm = $this->createCustomDomainForm($customDomainData); goto cf8ca; e5785: $customDomainData = ["\x64\x6f\155\141\x69\x6e\116\x61\155\145" => false === is_null($customDomainName) ? $customDomainName : '']; goto fb1d1; d5b72: return $response; goto f8246; C4b6d: ef9f2: goto ac4bf; b1efe: return $response; goto f4318; D8877: $customDomainForm->handleRequest($request); goto d0af8; d0af8: if (!(true === $customDomainForm->isSubmitted())) { goto cef9d; } goto d702d; cf8ca: if (!(true === $request->isMethod("\x50\117\x53\x54"))) { goto ef9f2; } goto D8877; d702d: $response = $this->handleCustomDomainForm($request, $customDomainForm); goto aa949; Fa08b: cef9d: goto C4b6d; f4318: } private function createCustomDomainForm(array $data) : Form { goto C0760; C0760: $form = $this->createForm("\x41\x70\x70\x5c\x46\x6f\x72\x6d\134\x41\144\155\151\x6e\x43\x75\163\x74\157\155\104\157\155\141\151\156\123\145\x74\164\151\x6e\x67\x73\124\171\160\145", $data, ["\x61\143\164\x69\x6f\156" => $this->generateUrl("\x63\154\x70\137\141\x64\155\151\x6e\137\163\x65\164\x74\x69\156\x67\163"), "\155\145\x74\150\x6f\144" => "\120\x4f\x53\x54", "\141\x74\x74\162" => []]); goto ba379; ba379: $form->add("\x73\165\142\155\x69\164", SubmitType::class, ["\x61\x74\x74\x72" => ["\x63\154\141\163\x73" => "\x62\164\x6e\x20\x62\x74\x6e\x2d\x62\x6c\165\x65\40\142\x74\156\55\154\147"], "\x6c\141\x62\x65\x6c" => "\123\141\166\x65"]); goto F4e73; F4e73: return $form; goto dd5c2; dd5c2: } private function handleCustomDomainForm(Request $request, Form $form) { goto e298f; D7c5c: try { goto e44a7; Bd108: $session = $request->getSession(); goto C52ed; C52ed: $domainName = $form->get("\x64\157\x6d\141\x69\156\116\x61\155\145")->getData(); goto Bd9e1; ebf7d: $domains = [$domainName]; goto Ea0ae; abe81: $adminCustomDomain->deleteLetsEncryptChallengeFiles(); goto d9052; f3a27: $certificate = $letsEncryptClient->finalizeOrder($certificateOrder, $privateKey, $csr); goto c6157; Ebebf: $certificateOrder = $letsEncryptClient->requestOrder($domains); goto d0d33; A6f02: $adminCustomDomain->writeVhostFile($domainName, $vhostTemplate); goto aa071; e61d9: $session->getFlashBag()->set("\163\165\143\x63\x65\163\x73", $this->translator->trans("\x43\154\x6f\165\144\120\141\x6e\145\x6c\x20\103\165\163\x74\157\x6d\40\x44\x6f\x6d\141\151\156\x20\150\141\163\40\x62\145\145\156\40\163\x61\x76\x65\144\56")); goto A5216; b9af7: $this->configManager->delete("\x63\x75\x73\x74\157\155\137\144\157\155\141\x69\x6e"); goto E76d6; b0c19: if (true === empty($validationErrors)) { goto e699b; } goto C2639; Ea0ae: $letsEncryptPrivateKey = $this->configManager->get("\x6c\x65\137\160\x72\x69\166\x61\x74\x65\x5f\x6b\x65\x79"); goto e8c41; a7ab7: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto db8a2; d0d33: $vhostTemplateFile = realpath(dirname(__FILE__) . "\57\56\56\x2f\x2e\x2e\x2f\x2e\x2e\57\x72\x65\163\157\165\162\143\145\x73\x2f\156\147\x69\156\170\x2f\x76\x68\157\163\x74\x5f\x74\145\155\x70\154\141\x74\x65\57\x63\165\163\164\x6f\x6d\x2d\x64\157\x6d\x61\151\x6e"); goto ba4b6; F2972: $adminCustomDomain->reloadNginx(); goto c4038; e44a7: $user = $this->getUser(); goto Bd108; c4038: $this->configManager->set("\143\165\x73\x74\157\155\x5f\144\x6f\x6d\x61\x69\x6e", $domainName); goto b7d1b; c618f: goto ee7af; goto Ada1c; fc329: C0a6d: goto ebf56; D844e: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto aec45; E64a3: EventQueue::addEvent(EventQueue::EVENT_ADMIN_CUSTOM_DOMAIN_ENABLE, $user, $eventData, $request); goto b85ba; C2639: $adminCustomDomain = new AdminCustomDomain(); goto Fcd8a; f86ac: $adminCustomDomain->delete(); goto b9af7; d9052: $adminCustomDomain->createLetsEncryptChallengeFiles($certificateOrder); goto e99a0; Ff0d8: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\141\144\155\x69\x6e\137\x73\x65\164\164\151\156\147\163")); goto e9d7b; E76d6: EventQueue::addEvent(EventQueue::EVENT_ADMIN_CUSTOM_DOMAIN_DISABLE, $user, [], $request); goto e61d9; f2310: $certificate->setPrivateKey($privateKey->getPEM()); goto d35e7; C3dad: a5369: goto a1520; f7ee4: $adminCustomDomain->writeVhostFile($domainName, $vhostTemplate); goto F2972; Ada1c: C0216: goto ebf7d; f9864: goto C0a6d; goto A9d98; e8c41: $privateKey = new PrivateKey($letsEncryptPrivateKey); goto B967b; Eeeb4: $validationErrors = $letsEncryptClient->validateDomains($certificateOrder); goto b0c19; e9d7b: return $response; goto fc329; db8a2: $certificate = new Certificate(); goto f2310; Bd9e1: $adminCustomDomain = new AdminCustomDomain(); goto A620f; aec45: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto F3504; A57a5: foreach ($validationErrors as $domain => $validationErrorMessage) { $form->addError(new FormError(sprintf("\45\x73\x3a\40\45\163", $domain, $validationErrorMessage))); B6191: } goto C3dad; d5159: return $response; goto c618f; B967b: $letsEncryptClient = new LetsEncryptClient($privateKey); goto Cbbc9; A9d98: e699b: goto f3a27; d35e7: $certificate->setCertificate($selfSignedCertificate); goto abe81; b85ba: $session->getFlashBag()->set("\x73\165\143\x63\x65\163\163", $this->translator->trans("\103\154\x6f\165\x64\x50\141\x6e\x65\154\x20\x43\165\163\164\157\155\x20\104\x6f\155\141\x69\x6e\x20\150\x61\163\x20\142\x65\x65\156\40\163\141\166\x65\x64\56")); goto Ff0d8; Bc88f: $adminCustomDomain = new AdminCustomDomain(); goto f86ac; Bf8ae: $commonName = array_shift($distinguishedNameDomains); goto D2ff5; Fc646: $distinguishedNameDomains = $domains; goto Bf8ae; c6157: $adminCustomDomain->writePrivateKeyAndCertificate($certificate); goto f7ee4; D2ff5: $distinguishedName = new DistinguishedName($commonName, $distinguishedNameDomains); goto ef557; F3504: $csr = $csrGenerator->generate(); goto a7ab7; Fcd8a: $adminCustomDomain->delete(); goto A57a5; b7d1b: $eventData = ["\144\x6f\155\141\151\156\116\x61\155\x65" => $domainName]; goto E64a3; ef557: $rsaKeyGenerator = new RsaKeyGenerator(); goto D844e; Cbbc9: $letsEncryptClient->registerAccount(); goto Ebebf; a1520: $this->formErrors = $this->getErrorMessages($form); goto f9864; A620f: if (false === empty($domainName)) { goto C0216; } goto Bc88f; aa071: $adminCustomDomain->reloadNginx(); goto Eeeb4; A5216: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x61\144\155\x69\156\x5f\163\145\x74\164\151\156\147\163")); goto d5159; ba4b6: $vhostTemplate = file_get_contents($vhostTemplateFile); goto Fc646; e99a0: $adminCustomDomain->writePrivateKeyAndCertificate($certificate); goto A6f02; ebf56: ee7af: goto E1e89; E1e89: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\x65\162", $this->translator->trans("\x41\156\x20\145\162\162\157\162\40\x68\x61\163\40\x6f\x63\143\165\162\x72\x65\x64\54\40\x65\x72\162\x6f\x72\40\x6d\x65\x73\x73\141\147\x65\72\x20\x25\145\x72\162\x6f\162\x4d\x65\163\163\141\147\145\45", ["\45\x65\162\162\157\162\x4d\145\x73\163\x61\147\x65\45" => $e->getMessage()])); } finally { if (!(true === isset($adminCustomDomain))) { goto B3959; } $adminCustomDomain->deleteLetsEncryptChallengeFiles(); B3959: } goto a2eb1; e298f: if (true === $form->isValid()) { goto Ec834; } goto e6b95; d5d4a: Ec834: goto D7c5c; D9855: goto F9c90; goto d5d4a; a2eb1: F9c90: goto f617c; e6b95: $this->formErrors = $this->getErrorMessages($form); goto D9855; f617c: } public function databaseServers(Request $request) : Response { goto d7473; d7473: $databaseServers = $this->databaseServerEntityManager->findAll([], ["\x68\x6f\x73\x74" => "\101\123\x43"]); goto fb322; Ffa05: return $response; goto c5947; fb322: $response = $this->render("\101\144\155\151\156\x2f\x53\x65\x74\164\x69\x6e\x67\163\57\104\141\164\x61\142\x61\163\145\55\x53\145\x72\166\x65\162\x73\x2f\x69\156\144\145\x78\56\150\x74\155\x6c\x2e\x74\167\151\x67", ["\x64\141\164\x61\x62\x61\163\x65\123\145\162\x76\x65\162\163" => $databaseServers]); goto Ffa05; c5947: } public function addDatabaseServer(Request $request) : Response { goto Cd09e; Fefa5: if (!(false === is_null($response))) { goto Daaaa; } goto bc21b; a94eb: $form->handleRequest($request); goto d49e6; b829a: Ba2a8: goto Bb43b; aa032: Daaaa: goto b829a; fccc8: $response = $this->render("\x41\144\x6d\151\x6e\x2f\x53\145\164\164\x69\x6e\147\163\57\x44\x61\x74\x61\142\141\x73\145\x2d\123\145\162\x76\x65\x72\163\57\x61\144\x64\56\150\x74\x6d\154\56\x74\x77\x69\147", ["\146\x6f\162\x6d" => $form->createView(), "\146\157\x72\155\105\x72\x72\157\x72\163" => $this->formErrors]); goto C2c7f; bb2c3: $response = $this->handleDatabaseServerForm($request, $form); goto Fefa5; Cd09e: $databaseServerEntity = $this->databaseServerEntityManager->createEntity(); goto f78f0; Bb43b: fc61c: goto fccc8; bc21b: return $response; goto aa032; Eca84: if (!(true === $request->isMethod("\120\117\123\x54"))) { goto fc61c; } goto a94eb; d49e6: if (!(true === $form->isSubmitted())) { goto Ba2a8; } goto bb2c3; C2c7f: return $response; goto f242b; f78f0: $form = $this->createDatabaseServerForm($databaseServerEntity); goto Eca84; f242b: } private function createDatabaseServerForm(DatabaseServerEntity $databaseServerEntity) : Form { goto a3693; a3693: $form = $this->createForm("\x41\x70\160\x5c\106\157\x72\155\x5c\x41\x64\155\x69\x6e\x44\141\164\141\142\141\x73\x65\123\x65\x72\166\x65\x72\124\171\160\x65", $databaseServerEntity, ["\x61\143\x74\151\x6f\x6e" => $this->generateUrl("\143\154\x70\137\141\x64\x6d\x69\156\x5f\144\x61\164\141\142\x61\163\x65\x5f\x73\x65\162\x76\145\162\137\141\144\x64"), "\x6d\145\164\150\157\x64" => "\120\117\x53\124", "\141\164\164\x72" => []]); goto D64a5; c81e6: return $form; goto ea668; D64a5: $form->add("\x73\165\x62\155\x69\164", SubmitType::class, ["\141\x74\164\162" => ["\143\154\141\x73\x73" => "\142\164\x6e\x20\x62\x74\156\55\x62\154\165\x65\40\x62\164\x6e\55\x6c\x67"], "\154\141\x62\145\x6c" => "\x41\144\144\40\x44\x61\x74\141\x62\x61\163\145\x20\x53\145\162\x76\145\162"]); goto c81e6; ea668: } private function handleDatabaseServerForm(Request $request, Form $form) { goto ece7d; ea827: edf31: goto e8cd0; f31e5: $this->formErrors = $this->getErrorMessages($form); goto e59d6; C4100: f7c77: goto A57da; ece7d: if (true === $form->isValid()) { goto f7c77; } goto f31e5; e59d6: goto edf31; goto C4100; A57da: try { goto d99ab; db25d: return $response; goto F2411; cd189: $session = $request->getSession(); goto Cc87c; A4767: $encryptedPassword = Crypto::encrypt($password); goto dbf34; F6f67: EventQueue::addEvent(EventQueue::EVENT_DATABASE_SERVER_ADD, $user, $eventData, $request); goto B6cf4; ceddb: $password = $databaseServerEntity->getPassword(); goto A4767; Cc87c: $databaseServerEntity = $form->getData(); goto ceddb; a0429: $version = $databaseConnection->getVersion(); goto be44d; dbf34: $databaseServerEntity->setPassword($encryptedPassword); goto a1d69; Dcd91: $engine = $databaseConnection->getEngine(); goto a0429; ea178: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x61\x64\x6d\151\x6e\x5f\144\141\164\141\142\141\x73\x65\137\163\x65\x72\166\x65\162\x73")); goto db25d; B6cf4: $this->databaseServerEntityManager->updateEntity($databaseServerEntity); goto D9c68; a1d69: $databaseConnection = new DatabaseConnection($databaseServerEntity); goto Dcd91; f3b82: $eventData = ["\150\x6f\163\164" => $databaseServerEntity->getHost(), "\165\163\x65\162\x4e\141\155\145" => $databaseServerEntity->getUserName(), "\x70\157\162\164" => $databaseServerEntity->getPort(), "\145\x6e\x67\x69\x6e\145" => $engine, "\x76\145\162\x73\151\157\156" => $version]; goto F6f67; d99ab: $user = $this->getUser(); goto cd189; D9c68: $session->getFlashBag()->set("\x73\x75\x63\x63\145\163\x73", $this->translator->trans("\x44\141\x74\141\x62\141\163\x65\x20\123\x65\x72\x76\x65\x72\40\150\141\163\40\142\145\x65\x6e\40\x61\144\144\145\x64\56")); goto ea178; be44d: $databaseServerEntity->setEngine($engine); goto D2302; D2302: $databaseServerEntity->setVersion($version); goto De74b; De74b: $databaseServerEntity->setIsDefault(false); goto f3b82; F2411: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\156\147\145\x72", $this->translator->trans("\x41\156\40\145\162\x72\x6f\x72\x20\x68\x61\x73\40\157\143\143\165\162\162\x65\x64\54\x20\145\x72\x72\x6f\162\x20\155\x65\163\x73\x61\147\145\72\x20\45\x65\x72\x72\x6f\162\x4d\x65\x73\x73\141\147\145\45", ["\45\x65\x72\x72\x6f\x72\x4d\x65\x73\x73\141\x67\x65\45" => $e->getMessage()])); } goto ea827; e8cd0: } public function editDatabaseServer(Request $request) : Response { goto D6ab4; b1b25: ce25c: goto fcbce; ec0d6: if (true === is_null($databaseServerEntity)) { goto C76ba; } goto ecb9b; Fab9b: if (!(true === $request->isMethod("\120\x4f\x53\124"))) { goto dd2ca; } goto E1b9e; A02cf: if (!(true === $form->isSubmitted())) { goto a4589; } goto b64f3; fc9df: return $response; goto Cd999; B735f: $response = $this->render("\101\144\155\151\156\x2f\123\145\164\x74\x69\156\147\163\x2f\x44\x61\164\141\x62\x61\x73\145\x2d\123\x65\162\166\145\x72\x73\57\145\144\151\x74\56\x68\164\155\x6c\56\x74\167\x69\147", ["\x64\141\164\x61\142\x61\x73\x65\x53\145\x72\x76\145\x72" => $databaseServerEntity, "\x66\157\162\x6d" => $form->createView(), "\x66\x6f\162\155\105\162\162\157\162\163" => $this->formErrors]); goto C24cb; b2c24: dd2ca: goto B735f; Cd999: d78ac: goto D7a5a; D6ab4: $id = (int) $request->get("\151\144"); goto fc37f; b64f3: $response = $this->handleDatabaseServerEditForm($request, $form); goto F4a3c; F2667: return $response; goto b1b25; c6dc6: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\141\x64\155\x69\156\137\x64\x61\x74\141\x62\x61\x73\145\x5f\163\145\162\x76\x65\162\163")); goto fc9df; fcbce: a4589: goto b2c24; fc37f: $databaseServerEntity = $this->databaseServerEntityManager->findOneById($id); goto ec0d6; C24cb: return $response; goto D6f26; F4a3c: if (!(false === is_null($response))) { goto ce25c; } goto F2667; ecb9b: $databaseServerEntity->setPassword(''); goto a2ad0; cb77e: C76ba: goto c6dc6; a2ad0: $form = $this->createDatabaseServerEditForm($databaseServerEntity); goto Fab9b; E1b9e: $form->handleRequest($request); goto A02cf; D6f26: goto d78ac; goto cb77e; D7a5a: } private function createDatabaseServerEditForm(DatabaseServerEntity $databaseServerEntity) : Form { goto Be9f8; Be9f8: $form = $this->createForm("\x41\160\x70\134\106\157\162\155\134\x41\x64\155\x69\156\104\141\x74\141\x62\x61\x73\x65\x53\x65\162\x76\x65\x72\x45\144\151\164\124\x79\160\x65", $databaseServerEntity, ["\141\x63\x74\151\157\156" => $this->generateUrl("\x63\154\x70\137\x61\144\x6d\x69\x6e\x5f\144\141\x74\141\142\x61\163\145\137\163\x65\162\x76\x65\162\137\145\x64\151\x74", ["\151\144" => $databaseServerEntity->getId()]), "\x6d\x65\x74\x68\x6f\144" => "\x50\117\x53\124", "\141\164\x74\x72" => []]); goto E3ae1; F2cb8: return $form; goto aa98c; E3ae1: $form->add("\x73\x75\142\155\x69\x74", SubmitType::class, ["\x61\164\x74\x72" => ["\x63\154\141\163\163" => "\x62\x74\156\x20\142\164\x6e\55\142\x6c\165\x65\40\142\x74\x6e\55\154\147"], "\154\141\x62\145\x6c" => "\123\x61\x76\x65"]); goto F2cb8; aa98c: } private function handleDatabaseServerEditForm(Request $request, Form $form) { goto d3895; a7326: b1822: goto Dbdb8; A7ceb: goto b1822; goto E464f; E464f: E85e6: goto B30e5; Bbfe7: $this->formErrors = $this->getErrorMessages($form); goto A7ceb; d3895: if (true === $form->isValid()) { goto E85e6; } goto Bbfe7; B30e5: try { goto e433f; A1180: $databaseServerEntity->setVersion($version); goto Aa03f; Fb0e8: EventQueue::addEvent(EventQueue::EVENT_DATABASE_SERVER_EDIT, $user, $eventData, $request); goto f9b35; A860f: $session->getFlashBag()->set("\163\x75\143\x63\x65\x73\x73", $this->translator->trans("\x44\141\164\141\142\141\163\x65\40\123\145\162\166\145\x72\x20\150\141\163\x20\142\145\x65\156\x20\165\160\x64\x61\x74\x65\144\56")); goto D04ea; Bc556: $databaseServerEntity = $form->getData(); goto E13ca; bd9bd: $eventData = ["\150\x6f\x73\164" => $databaseServerEntity->getHost(), "\165\163\x65\162\x4e\141\155\x65" => $databaseServerEntity->getUserName(), "\160\x6f\162\164" => $databaseServerEntity->getPort(), "\145\156\x67\x69\156\145" => $engine, "\166\x65\x72\163\x69\x6f\x6e" => $version]; goto Fb0e8; E6dd3: $session = $request->getSession(); goto Bc556; F6742: $version = $databaseConnection->getVersion(); goto E5e28; Cf9ce: return $response; goto A15cf; E5e28: $databaseServerEntity->setEngine($engine); goto A1180; d15a1: $engine = $databaseConnection->getEngine(); goto F6742; f9b35: $this->databaseServerEntityManager->updateEntity($databaseServerEntity); goto A860f; Aa03f: $databaseServerEntity->setIsDefault(false); goto bd9bd; F6515: $databaseConnection = new DatabaseConnection($databaseServerEntity); goto d15a1; Ed353: $encryptedPassword = Crypto::encrypt($password); goto A87dc; E13ca: $password = $databaseServerEntity->getPassword(); goto Ed353; A87dc: $databaseServerEntity->setPassword($encryptedPassword); goto F6515; e433f: $user = $this->getUser(); goto E6dd3; D04ea: $response = $this->redirect($this->generateUrl("\143\154\160\137\x61\x64\155\151\156\137\144\x61\x74\x61\142\141\163\x65\137\x73\145\162\166\145\162\x73")); goto Cf9ce; A15cf: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\147\x65\x72", $this->translator->trans("\x41\x6e\x20\x65\162\x72\157\x72\40\150\141\x73\40\157\143\x63\165\162\x72\145\x64\x2c\x20\x65\162\162\x6f\162\40\x6d\x65\x73\x73\x61\x67\x65\72\40\45\145\162\162\157\x72\115\x65\x73\x73\141\x67\x65\x25", ["\x25\145\x72\162\157\162\115\145\x73\163\x61\147\x65\45" => $e->getMessage()])); } goto a7326; Dbdb8: } public function setDatabaseServerActive(Request $request) : Response { goto F5e97; a9baf: try { goto c5f27; A507f: $databaseServerEntity->setIsActive(true); goto adb4b; c572d: $this->databaseServerEntityManager->updateEntity($databaseServerEntity); goto a2bac; c5f27: $user = $this->getUser(); goto c9689; C1aac: EventQueue::addEvent(EventQueue::EVENT_DATABASE_SERVER_CHANGE, $user, $eventData, $request); goto C5d0d; bc891: $eventData = ["\157\x6c\x64\110\x6f\163\x74" => $activeDatabaseServerEntity->getHost(), "\157\x6c\144\x55\x73\x65\162\x4e\x61\155\x65" => $activeDatabaseServerEntity->getUserName(), "\156\145\167\x48\157\163\164" => $databaseServerEntity->getHost(), "\156\145\x77\125\x73\145\162\x4e\141\155\145" => $databaseServerEntity->getUserName()]; goto C1aac; adb4b: $activeDatabaseServerEntity->setIsActive(false); goto c572d; a2bac: $this->databaseServerEntityManager->updateEntity($activeDatabaseServerEntity); goto bc891; C5d0d: $session->getFlashBag()->set("\x73\x75\143\x63\145\x73\163", $this->translator->trans("\104\x61\x74\141\142\x61\x73\145\40\123\x65\x72\166\145\x72\40\150\x61\163\40\142\145\145\156\40\x63\x68\x61\x6e\147\x65\144\x2e")); goto c825e; c9689: $session = $request->getSession(); goto A507f; c825e: } catch (\Exception $e) { $session->getFlashBag()->set("\144\141\x6e\x67\x65\162", $this->translator->trans("\x44\141\164\141\x62\x61\x73\x65\x20\123\x65\x72\166\145\162\x20\x63\x72\x65\144\x65\x6e\164\151\141\154\x73\40\141\162\x65\x20\156\157\x74\x20\x76\x61\154\151\x64\x2e")); } goto a04e3; A4278: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto D5249; F5e97: $id = (int) $request->get("\151\144"); goto F0c4a; F0c4a: $databaseServerEntity = $this->databaseServerEntityManager->findOneById($id); goto E5f2c; ed886: Ca800: goto b0200; a04e3: Fdd96: goto ed886; b0200: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x61\x64\x6d\x69\x6e\137\x64\x61\x74\141\x62\141\163\145\x5f\163\145\162\166\x65\x72\163")); goto ab821; E5f2c: if (!(false === is_null($databaseServerEntity))) { goto Ca800; } goto A4278; ab821: return $response; goto edee0; D5249: if (!($databaseServerEntity->getId() != $activeDatabaseServerEntity->getId())) { goto Fdd96; } goto a9baf; edee0: } public function deleteDatabaseServer(Request $request) : Response { goto cbd8c; F4aee: A82da: goto d29ee; fa83a: return $response; goto E12b6; d29ee: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\141\x64\155\151\x6e\137\x64\141\x74\141\x62\141\x73\145\137\x73\x65\162\166\x65\x72\x73")); goto fa83a; E442b: $databaseServerEntity = $this->databaseServerEntityManager->findOneById($id); goto b2941; cbd8c: $id = (int) $request->get("\151\x64"); goto E442b; E504f: try { goto F0e24; f9771: $session = $request->getSession(); goto c1328; D29a0: $eventData = ["\150\x6f\163\164" => $databaseServerEntity->getHost(), "\x75\163\x65\x72\116\141\x6d\145" => $databaseServerEntity->getUserName()]; goto ffedb; F0e24: $user = $this->getUser(); goto f9771; ffedb: EventQueue::addEvent(EventQueue::EVENT_DATABASE_SERVER_DELETE, $user, $eventData, $request); goto e6582; c1328: $this->databaseServerEntityManager->deleteEntity($databaseServerEntity); goto D29a0; e6582: $session->getFlashBag()->set("\x73\x75\143\143\x65\x73\x73", $this->translator->trans("\104\x61\x74\141\x62\141\x73\145\40\123\145\162\166\x65\x72\40\150\x61\x73\40\142\145\145\x6e\x20\144\145\154\145\x74\x65\144\56")); goto db474; db474: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\x65\x72", $this->translator->trans("\x41\156\x20\145\x72\x72\x6f\162\40\150\x61\163\40\157\143\143\165\162\162\x65\144\54\40\x65\x72\x72\157\x72\40\155\x65\163\163\x61\147\x65\x3a\x20\45\x65\x72\162\157\x72\x4d\145\163\163\x61\147\145\x25", ["\45\x65\x72\x72\157\x72\x4d\145\x73\x73\141\x67\x65\x25" => $e->getMessage()])); } goto F4aee; b2941: if (!(false === is_null($databaseServerEntity) && false === $databaseServerEntity->isDefault() && false === $databaseServerEntity->isActive())) { goto A82da; } goto E504f; E12b6: } }
