<?php
 namespace App\Controller\Admin; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Component\Form\Extension\Core\Type\SubmitType; use Symfony\Component\Form\Form; use App\Controller\Controller; use Symfony\Contracts\Translation\TranslatorInterface; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\UserManager as UserEntityManager; use App\Entity\Manager\TimezoneManager as TimezoneEntityManager; use App\Entity\User as UserEntity; use App\Event\EventQueue; use App\Service\Logger; class UserController extends Controller { private UserEntityManager $userEntityManager; private SiteEntityManager $siteEntityManager; private TimezoneEntityManager $timezoneEntityManager; public function __construct(UserEntityManager $userEntityManager, SiteEntityManager $siteEntityManager, TimezoneEntityManager $timezoneEntityManager, TranslatorInterface $translator, Logger $logger) { goto F0266; ebb39: $this->timezoneEntityManager = $timezoneEntityManager; goto da33c; da33c: parent::__construct($translator, $logger); goto e61bf; C2b5d: $this->siteEntityManager = $siteEntityManager; goto ebb39; F0266: $this->userEntityManager = $userEntityManager; goto C2b5d; e61bf: } public function index(Request $request) : Response { goto bd350; F6166: $response = $this->render("\101\144\155\151\x6e\57\125\163\145\x72\57\x69\x6e\x64\145\170\x2e\x68\164\x6d\x6c\x2e\x74\167\x69\147", ["\x75\163\x65\162\163" => $users]); goto b9319; a0c8e: $users = array_filter($users, function ($user) use($currentUser) { return $currentUser->getId() != $user->getId(); }); goto F6166; b9319: return $response; goto a8ea6; d221d: $users = $this->userEntityManager->findAll([], ["\x75\x73\x65\162\x4e\x61\155\145" => "\141\163\143"]); goto a0c8e; bd350: $currentUser = $this->getUser(); goto d221d; a8ea6: } public function new(Request $request) : Response { goto e10ac; faa2a: $defaultTimezone = $this->timezoneEntityManager->findOneByName(UserEntity::DEFAULT_TIMEZONE); goto ef1dd; Ad54e: if (!(false === is_null($response))) { goto ac430; } goto D121a; F225d: if (!(true === $form->isSubmitted())) { goto c578f; } goto ec05a; ec05a: $response = $this->handleUserForm($request, $form); goto Ad54e; B96ac: $form->handleRequest($request); goto F225d; Eea87: ac430: goto Aa836; D121a: return $response; goto Eea87; be425: $userEntity->setTimezone($defaultTimezone); goto Ba2fb; ef1dd: $sites = $this->siteEntityManager->findAll([], ["\144\157\x6d\141\x69\x6e\116\141\x6d\x65" => "\x41\123\x43"]); goto be425; Ba2fb: $form = $this->createUserForm($userEntity); goto ff726; e10ac: $userEntity = $this->userEntityManager->createEntity(); goto faa2a; a1bc9: Af5d6: goto b43e8; Fe595: return $response; goto B1551; ff726: if (!(true === $request->isMethod("\x50\117\123\124"))) { goto Af5d6; } goto B96ac; Aa836: c578f: goto a1bc9; b43e8: $response = $this->render("\101\x64\x6d\151\156\57\125\x73\145\x72\57\156\145\x77\x2e\150\x74\x6d\x6c\x2e\164\x77\x69\147", ["\x75\163\x65\162" => $userEntity, "\x73\x69\x74\145\x73" => $sites, "\146\x6f\x72\155" => $form->createView(), "\146\157\162\155\x45\x72\162\x6f\x72\x73" => $this->formErrors]); goto Fe595; B1551: } private function createUserForm(UserEntity $userEntity) : Form { goto a85dd; F7fc9: return $form; goto c1653; cd97e: $form->add("\163\x75\x62\155\151\x74", SubmitType::class, ["\x61\x74\x74\162" => ["\143\x6c\x61\163\163" => "\x62\x74\156\40\142\164\156\x2d\x62\154\x75\145\40\x62\164\156\55\154\147"], "\x6c\x61\142\145\154" => "\x41\144\x64\40\125\x73\145\x72"]); goto F7fc9; a85dd: $form = $this->createForm("\x41\x70\160\134\106\157\162\155\x5c\x41\144\x6d\x69\156\125\x73\145\x72\x54\171\160\145", $userEntity, ["\x61\143\x74\151\x6f\x6e" => $this->generateUrl("\143\154\x70\x5f\x61\144\155\x69\x6e\x5f\165\x73\145\162\137\156\x65\x77"), "\x6d\145\x74\x68\x6f\x64" => "\x50\x4f\x53\x54", "\141\164\x74\162" => []]); goto cd97e; c1653: } private function handleUserForm(Request $request, Form $form) { goto A1e79; ff86c: goto Ae81b; goto D4bf6; ad766: try { goto Aa3bf; c8dd8: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\141\x64\x6d\x69\156\x5f\x75\x73\145\x72\x73")); goto B1c81; f5a84: $eventData = ["\165\x73\145\162\x4e\141\155\145" => $userEntity->getUserName(), "\146\151\x72\163\164\116\141\155\x65" => $userEntity->getFirstName(), "\x6c\x61\x73\x74\x4e\x61\155\145" => $userEntity->getLastName(), "\x65\x6d\141\151\x6c" => $userEntity->getEMail(), "\x72\157\x6c\145" => $userEntity->getRole(), "\x73\151\164\x65\x73" => implode("\x2c\x20", $domainNames)]; goto f459c; Bbe1f: if (!(count($sites) && UserEntity::ROLE_USER == $userEntity->getRole())) { goto c322e; } goto aaac7; B1c81: return $response; goto c0f95; Aa3bf: $currentUser = $this->getUser(); goto f65d1; d329e: sort($domainNames); goto be153; f65d1: $session = $request->getSession(); goto Ad1f5; f459c: EventQueue::addEvent(EventQueue::EVENT_ADMIN_USER_ADD, $currentUser, $eventData, $request); goto d209a; dfd30: c322e: goto d329e; be153: $this->userEntityManager->updateUser($userEntity); goto f5a84; Ad1f5: $userEntity = $form->getData(); goto F74ba; d209a: $session->getFlashBag()->set("\163\165\143\143\145\163\x73", $this->translator->trans("\125\163\145\162\x20\x68\141\163\x20\x62\x65\x65\x6e\40\x61\x64\144\x65\x64\x2e")); goto c8dd8; bd321: $domainNames = []; goto Bbe1f; F74ba: $sites = $userEntity->getSites(); goto bd321; D7d19: C7b19: goto dfd30; aaac7: foreach ($sites as $site) { $domainNames[] = $site->getDomainName(); F6e83: } goto D7d19; c0f95: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\147\145\x72", $this->translator->trans("\101\156\40\145\x72\162\157\162\x20\150\141\x73\x20\x6f\x63\x63\x75\x72\162\x65\x64\x2c\x20\145\x72\x72\x6f\162\40\155\145\x73\x73\x61\147\145\x3a\x20\x25\145\x72\x72\x6f\162\x4d\x65\163\163\141\147\145\45", ["\x25\x65\162\162\x6f\x72\x4d\x65\x73\163\141\x67\x65\45" => $e->getMessage()])); } goto fe574; D4bf6: feca9: goto ad766; fe574: Ae81b: goto B2df0; A1e79: if (true === $form->isValid()) { goto feca9; } goto cc35a; cc35a: $this->formErrors = $this->getErrorMessages($form); goto ff86c; B2df0: } public function edit(Request $request) : Response { goto C609e; C4f22: if (!(true === $request->isMethod("\120\117\x53\124"))) { goto F416c; } goto fdf74; B5af7: if (!(false === is_null($response))) { goto e213b; } goto C5f83; C5f83: return $response; goto fea65; fea65: e213b: goto b039e; fff6c: $response = $this->render("\101\144\x6d\x69\x6e\x2f\125\163\145\162\x2f\x65\144\x69\164\56\x68\164\x6d\x6c\x2e\164\x77\x69\x67", ["\x75\x73\x65\162" => $userEntity, "\163\x69\x74\145\163" => $sites, "\146\x6f\x72\x6d" => $form->createView(), "\146\157\162\155\105\162\x72\157\x72\x73" => $this->formErrors]); goto F1d8f; b039e: a5bba: goto f02d0; f826b: $form = $this->createUserEditForm($userEntity); goto C4f22; Ceb9d: $response = $this->handleUserEditForm($request, $form); goto B5af7; fdf74: $form->handleRequest($request); goto Fcb2d; e85ca: $sites = $this->siteEntityManager->findAll([], ["\144\x6f\155\141\151\156\116\x61\155\x65" => "\101\x53\103"]); goto f826b; f5ca1: $userEntity = $this->userEntityManager->findOneById($id); goto d5971; fa2d7: goto a06a9; goto Bcef7; f02d0: F416c: goto fff6c; F1d8f: a06a9: goto ccc4c; d5971: if (false === is_null($userEntity)) { goto eafac; } goto Ec3fe; Ec3fe: $response = $this->redirect($this->generateUrl("\x63\154\160\137\141\144\x6d\x69\156\x5f\165\x73\x65\162\x73")); goto fa2d7; C609e: $id = (int) $request->get("\x69\x64"); goto f5ca1; ccc4c: return $response; goto b6386; Fcb2d: if (!(true === $form->isSubmitted())) { goto a5bba; } goto Ceb9d; Bcef7: eafac: goto e85ca; b6386: } private function createUserEditForm(UserEntity $userEntity) : Form { goto B03f9; B1ece: return $form; goto b1753; B03f9: $form = $this->createForm("\101\160\x70\x5c\x46\x6f\x72\x6d\x5c\x41\x64\155\x69\x6e\x55\163\x65\x72\105\x64\x69\x74\x54\x79\160\x65", $userEntity, ["\x61\x63\x74\151\157\x6e" => $this->generateUrl("\143\x6c\x70\x5f\141\144\x6d\x69\x6e\x5f\x75\163\145\x72\137\x65\x64\151\164", ["\151\x64" => $userEntity->getId()]), "\x6d\x65\x74\x68\157\x64" => "\120\117\123\124", "\x61\x74\x74\x72" => []]); goto b871e; b871e: $form->add("\x73\x75\142\x6d\x69\x74", SubmitType::class, ["\141\164\x74\x72" => ["\143\154\x61\x73\x73" => "\x62\164\156\x20\x62\x74\x6e\55\x62\x6c\x75\145\x20\142\x74\156\x2d\x6c\x67"], "\154\x61\142\145\x6c" => "\x53\141\x76\x65"]); goto B1ece; b1753: } private function handleUserEditForm(Request $request, Form $form) { goto efd94; B266f: goto F14c9; goto Cc3b7; a64c4: try { goto b7e58; B5167: f3c3e: goto C7010; C67d2: foreach ($sites as $site) { $domainNames[] = $site->getDomainName(); Fc1ba: } goto Dc1e9; a80d2: if (false === empty($plainPassword)) { goto f3c3e; } goto ff74c; ab2b1: $eventData = ["\165\x73\145\x72\x4e\141\155\x65" => $userEntity->getUserName(), "\x66\151\162\x73\x74\116\x61\155\145" => $userEntity->getFirstName(), "\154\x61\x73\x74\116\141\x6d\x65" => $userEntity->getLastName(), "\145\x6d\x61\151\x6c" => $userEntity->getEMail(), "\162\x6f\x6c\x65" => $userEntity->getRole(), "\163\x74\141\164\x75\163" => (int) $userEntity->getStatus(), "\163\151\164\145\x73" => implode("\x2c\x20", $domainNames)]; goto F56b6; ff74c: $this->userEntityManager->updateUser($userEntity); goto e83df; Ada86: C44fe: goto ab2b1; e83df: goto C44fe; goto B5167; Dc1e9: C2a5d: goto B5b00; Eae27: $userEntity = $form->getData(); goto Bfca0; F56b6: EventQueue::addEvent(EventQueue::EVENT_ADMIN_USER_UPDATE, $currentUser, $eventData, $request); goto E5ef2; Cc753: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x61\x64\x6d\x69\156\137\165\x73\x65\162\137\145\144\x69\164", ["\151\x64" => $userEntity->getId()])); goto D1d3d; dbefb: $sites = $userEntity->getSites(); goto A235d; b7e58: $currentUser = $this->getUser(); goto B67b7; B67b7: $session = $request->getSession(); goto Eae27; b78c7: sort($domainNames); goto a80d2; C7010: $this->userEntityManager->updateUser($userEntity, true, true); goto Ada86; D1d3d: return $response; goto da21c; A235d: $domainNames = []; goto E966c; B5b00: aab00: goto b78c7; E966c: if (!(count($sites) && UserEntity::ROLE_USER == $userEntity->getRole())) { goto aab00; } goto C67d2; E5ef2: $session->getFlashBag()->set("\x73\165\x63\x63\145\163\163", $this->translator->trans("\x55\163\x65\x72\x20\150\x61\163\x20\142\145\145\156\x20\x75\160\x64\x61\x74\145\144\56")); goto Cc753; Bfca0: $plainPassword = $userEntity->getPlainPassword(); goto dbefb; da21c: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\145\162", $this->translator->trans("\x41\x6e\40\x65\162\162\x6f\162\40\x68\x61\163\x20\x6f\x63\143\165\x72\x72\x65\x64\54\x20\145\162\x72\157\x72\x20\155\145\163\x73\x61\147\145\72\40\x25\145\x72\x72\x6f\x72\x4d\x65\163\163\x61\x67\145\x25", ["\45\145\162\x72\x6f\x72\115\145\163\x73\x61\x67\x65\45" => $e->getMessage()])); } goto fbf93; Cc3b7: A89e7: goto a64c4; Dbb9a: $this->formErrors = $this->getErrorMessages($form); goto B266f; efd94: if (true === $form->isValid()) { goto A89e7; } goto Dbb9a; fbf93: F14c9: goto F91d9; F91d9: } public function delete(Request $request) : Response { goto C1c81; A8424: EventQueue::addEvent(EventQueue::EVENT_ADMIN_USER_DELETE, $currentUser, $eventData, $request); goto bce7a; A83c4: $session->getFlashBag()->set("\x73\x75\143\143\145\x73\x73", $this->translator->trans("\x55\x73\x65\162\x20\150\x61\x73\x20\142\145\x65\x6e\40\x64\145\154\x65\164\x65\144\56")); goto B33cc; bb5b0: $userEntity = $this->userEntityManager->findOneById($id); goto Edb1e; b3133: return $response; goto e7cd9; B33cc: a327e: goto D74e1; bce7a: $this->userEntityManager->deleteUser($userEntity); goto A83c4; Ae511: $eventData = ["\165\163\x65\162\x4e\x61\x6d\145" => $userEntity->getUserName(), "\x66\151\x72\x73\164\116\x61\x6d\x65" => $userEntity->getFirstName(), "\x6c\141\163\x74\x4e\x61\x6d\145" => $userEntity->getLastName(), "\145\x6d\141\x69\x6c" => $userEntity->getEMail(), "\x72\157\x6c\x65" => $userEntity->getRole()]; goto A8424; ad5a1: if (!(true === isset($id) && $id != $currentUser->getId())) { goto c515a; } goto bb5b0; Edb1e: if (!(false === is_null($userEntity))) { goto a327e; } goto Ec6ab; C1c81: $currentUser = $this->getUser(); goto c28ea; D74e1: c515a: goto f0f76; Ec6ab: $session = $request->getSession(); goto Ae511; c28ea: $id = (int) $request->get("\x69\x64"); goto ad5a1; f0f76: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\141\x64\x6d\x69\156\137\165\x73\x65\x72\x73")); goto b3133; e7cd9: } }
