<?php
 namespace App\Controller\Frontend; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Contracts\Translation\TranslatorInterface; use App\Controller\Controller; use App\Entity\Manager\InstanceCpuManager as InstanceCpuEntityManager; use App\Entity\Manager\InstanceMemoryManager as InstanceMemoryEntityManager; use App\Entity\Manager\InstanceDiskUsageManager as InstanceDiskUsageEntityManager; use App\Entity\Manager\InstanceLoadAverageManager as InstanceLoadAverageEntityManager; use App\System\CommandExecutor; use App\System\Command\MemoryInformationCommand; use App\System\Command\ProcessorCoresCommand; use App\Entity\InstanceDiskUsage as InstanceDiskUsageEntity; use App\Entity\InstanceLoadAverage as InstanceLoadAverageEntity; use App\Monitoring\Chart; use App\Monitoring\LoadAverageChart; use App\Util\HumanFileSize as HumanFileSizeUtil; use App\Util\Time as TimeUtil; use App\Service\Logger; use App\Entity\User; class DashboardController extends Controller { public const TIME_RANGE_LAST_THIRTY_MINUTES = 1; public const TIME_RANGE_LAST_HOUR = 2; public const TIME_RANGE_LAST_THREE_HOURS = 3; public const TIME_RANGE_LAST_SIX_HOURS = 4; public const TIME_RANGE_LAST_TWELVE_HOURS = 5; private static array $timeRanges = [self::TIME_RANGE_LAST_THIRTY_MINUTES, self::TIME_RANGE_LAST_HOUR, self::TIME_RANGE_LAST_THREE_HOURS, self::TIME_RANGE_LAST_SIX_HOURS, self::TIME_RANGE_LAST_TWELVE_HOURS]; private InstanceCpuEntityManager $instanceCpuEntityManager; private InstanceMemoryEntityManager $instanceMemoryEntityManager; private InstanceDiskUsageEntityManager $instanceDiskUsageEntityManager; private InstanceLoadAverageEntityManager $instanceLoadAverageEntityManager; public function __construct(InstanceCpuEntityManager $instanceCpuEntityManager, InstanceMemoryEntityManager $instanceMemoryEntityManager, InstanceDiskUsageEntityManager $instanceDiskUsageEntityManager, InstanceLoadAverageEntityManager $instanceLoadAverageEntityManager, TranslatorInterface $translator, Logger $logger) { goto d7f1d; d7f1d: $this->instanceCpuEntityManager = $instanceCpuEntityManager; goto Adac5; Adac5: $this->instanceMemoryEntityManager = $instanceMemoryEntityManager; goto d0531; Eda70: parent::__construct($translator, $logger); goto B1c44; b84a5: $this->instanceLoadAverageEntityManager = $instanceLoadAverageEntityManager; goto Eda70; d0531: $this->instanceDiskUsageEntityManager = $instanceDiskUsageEntityManager; goto b84a5; B1c44: } public function index(Request $request) : Response { goto d6cb8; f3a1c: $cpuChart->setInformation($cpuInformation); goto c8b1a; c14cf: $loadAverageChart = new LoadAverageChart("\114\x6f\141\x64\40\101\x76\145\x72\x61\147\145"); goto a8136; Aeed5: $timeRange = $request->get("\164\x69\155\145\x52\x61\x6e\147\x65"); goto cf4fe; cf763: $environment = $instance->getEnvironment(); goto Defcf; e35f9: $homeDiskSizeInBytes = disk_total_space(InstanceDiskUsageEntity::DISK_HOME); goto E0500; Fc269: try { goto f127e; Ad2d0: $commandExecutor->execute($memoryInformationCommand); goto f273a; e4ff9: $commandExecutor->execute($processorCoresCommand); goto f7f25; B6e24: $totalMemory = HumanFileSizeUtil::convert($totalMemoryInBytes, "\x47\x42", 0); goto C8ef7; ba7e5: $memoryInformationCommand = new MemoryInformationCommand(); goto Ad2d0; f7f25: $numberOfProcessorCores = $processorCoresCommand->getNumberOfProcessorCores(); goto a65b1; f127e: $commandExecutor = new CommandExecutor(); goto ba7e5; C8ef7: $processorCoresCommand = new ProcessorCoresCommand(); goto e4ff9; f273a: $totalMemoryInBytes = $memoryInformationCommand->getTotalMemoryInBytes(); goto B6e24; a65b1: } catch (\Exception $e) { $this->logger->exception($e); } goto Bf068; eacf7: $diskData = [["\x6e\x61\x6d\x65" => sprintf("\57\x20\x28\x25\x73\x29", $rootDiskSize), "\143\157\x6c\157\162" => "\x23\67\x33\142\x66\x34\143", "\144\141\164\141" => $diskData["\x72\x6f\x6f\164"] ?: []]]; goto Efb9c; Dcd17: $diskChart->setCategories($categories); goto d47db; dc2e9: $cpuChart->setCategories($categories); goto Fbf88; d4c5e: $cpuInformation = sprintf("\45\163\40\x43\x6f\162\145", $numberOfProcessorCores); goto bf93d; Fd769: $dateTime = new \DateTime(); goto B2f35; d14b8: goto f901c; goto f0155; caeef: $loadAverageChartInformation = sprintf("\x25\x73\40\x43\157\x72\x65\x73", $numberOfProcessorCores); goto Be1f2; cf4fe: $timeRange = true === is_null($timeRange) ? self::TIME_RANGE_LAST_THIRTY_MINUTES : (true === in_array($timeRange, self::$timeRanges) ? $timeRange : self::TIME_RANGE_LAST_THIRTY_MINUTES); goto f3ea9; f8752: c7fe8: goto c14cf; dba09: $loadAverageData = [["\156\141\155\x65" => $this->translator->trans("\61\40\115\x69\156\165\x74\145"), "\143\x6f\x6c\x6f\x72" => "\x23\x37\67\64\141\x61\x34", "\x64\x61\x74\141" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_ONE_MINUTE] ?? []], ["\156\141\x6d\x65" => $this->translator->trans("\65\40\115\151\156\165\164\145\163"), "\x63\x6f\154\x6f\162" => "\x23\x65\x62\x35\70\x36\143", "\144\141\164\x61" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_FIVE_MINUTES] ?? []], ["\156\141\x6d\145" => $this->translator->trans("\x31\x35\40\115\151\156\165\164\x65\163"), "\x63\157\x6c\157\162" => "\x23\x30\x30\67\70\144\64", "\x64\x61\x74\x61" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_FIVETEEN_MINUTES] ?? []]]; goto c7063; c2a21: $response = $this->render("\106\x72\157\156\164\145\156\144\57\104\x61\163\150\x62\x6f\141\x72\144\57\x69\156\144\x65\170\56\150\164\155\x6c\x2e\x74\x77\151\147", ["\x63\x6c\157\165\144" => $cloud, "\x69\x6e\163\x74\141\x6e\x63\x65" => $instance, "\165\x73\145\x72" => $user, "\164\151\155\x65\122\x61\x6e\x67\145" => $timeRange, "\x63\160\x75\x43\150\141\162\x74" => $cpuChart, "\155\x65\155\x6f\162\x79\x43\x68\141\x72\164" => $memoryChart, "\144\x69\x73\153\103\150\141\x72\x74" => $diskChart, "\154\157\141\x64\101\x76\145\162\x61\147\x65\103\x68\141\162\x74" => $loadAverageChart]); goto Fe37b; a3f19: $loadAverageChartInformation = sprintf("\x25\x73\40\x43\x6f\162\145", $numberOfProcessorCores); goto f8752; d3d71: $memoryChart->setData($memoryData); goto e7d6f; Fbf88: $memoryChart = new Chart("\115\x65\x6d\x6f\162\171\x20\x55\163\x61\x67\145"); goto B7fae; Ea018: $cpuInformation = sprintf("\x25\163\40\x43\x6f\x72\145\x73", $numberOfProcessorCores); goto d14b8; b9a44: E5885: goto cc408; cc408: $loadAverageRawData = $this->getLoadAverageDataForTimeRange($startTime, $endTime, $minuteInterval); goto dba09; Fe37b: return $response; goto D0206; Efb9c: goto E5885; goto e505e; f0155: a0c41: goto d4c5e; E0ada: $diskData = $this->getDiskDataForTimeRange($startTime, $endTime, $minuteInterval); goto D4b32; f3ea9: $totalMemory = ''; goto E7e28; cf2b4: $diskChart->setData($diskData); goto Dcd17; Bfdb7: $memoryData = $this->getMemoryDataForTimeRange($startTime, $endTime, $minuteInterval); goto E0ada; c7063: if ($numberOfProcessorCores == 1) { goto a0c41; } goto Ea018; f9d3f: $rootDiskSize = HumanFileSizeUtil::convert($rootDiskSizeInBytes, "\x47\102", 0); goto e35f9; F1008: $cpuData = $this->getCpuDataForTimeRange($startTime, $endTime, $minuteInterval); goto Bfdb7; B7fae: $memoryChart->setInformation($totalMemory); goto d3d71; c8b1a: $cpuChart->setData($cpuData); goto dc2e9; Defcf: $cloud = $environment->getCloudProvider(); goto Aeed5; f8e21: switch ($timeRange) { case self::TIME_RANGE_LAST_THIRTY_MINUTES: goto ab387; cf4d3: $startTime = (clone $endTime)->modify("\x2d\x33\x30\x20\x6d\151\156\x75\164\145\163"); goto bd824; ab387: $minuteInterval = 5; goto cf4d3; bd824: goto dfb1e; goto daef1; daef1: case self::TIME_RANGE_LAST_HOUR: goto cc71c; cc71c: $minuteInterval = 10; goto dfd4d; E6109: goto dfb1e; goto Fc555; dfd4d: $startTime = (clone $endTime)->modify("\x2d\61\40\150\x6f\165\162"); goto E6109; Fc555: case self::TIME_RANGE_LAST_THREE_HOURS: goto c6e33; b2a41: goto dfb1e; goto E47d5; Fd8c7: $startTime = (clone $dateTime)->modify("\x2d\63\40\150\157\165\162\x73"); goto b2a41; c6e33: $minuteInterval = 30; goto Fd8c7; E47d5: case self::TIME_RANGE_LAST_SIX_HOURS: goto B7d86; B7d86: $minuteInterval = 60; goto Bf906; E989a: goto dfb1e; goto E33c4; Bf906: $startTime = (clone $dateTime)->modify("\55\66\x20\x68\x6f\x75\x72\x73"); goto E989a; E33c4: case self::TIME_RANGE_LAST_TWELVE_HOURS: goto d8c24; f56ae: $startTime = (clone $dateTime)->modify("\55\x31\x32\x20\150\157\x75\x72\x73"); goto bc8a2; d8c24: $minuteInterval = 120; goto f56ae; bc8a2: goto dfb1e; goto f2719; f2719: } goto e4691; Eb8dc: $categories = $this->getCategoriesForTimeRange($user, $startTime, $endTime, $minuteInterval); goto F1008; E0500: $homeDiskSize = HumanFileSizeUtil::convert($homeDiskSizeInBytes, "\x47\102", 0); goto Fd769; d47db: if ($numberOfProcessorCores == 1) { goto D6312; } goto caeef; B4646: D6312: goto a3f19; F94e6: dfb1e: goto Eb8dc; bf93d: f901c: goto bfba5; Bf068: $rootDiskSizeInBytes = disk_total_space(InstanceDiskUsageEntity::DISK_ROOT); goto f9d3f; C7870: $loadAverageChart->setCategories($categories); goto c2a21; d5824: $instance = $request->attributes->get("\x69\156\163\164\141\156\143\145"); goto cf763; a8136: $loadAverageChart->setInformation($loadAverageChartInformation); goto a8aab; B31c2: $diskChart = new Chart("\104\151\x73\153\x20\125\x73\141\147\145"); goto cf2b4; e7d6f: $memoryChart->setCategories($categories); goto B31c2; e4691: B6de0: goto F94e6; B2f35: $endTime = TimeUtil::roundToNearestMinuteInterval($dateTime, 5); goto f8e21; a8aab: $loadAverageChart->setData($loadAverageData); goto C7870; D4b32: if ($homeDiskSize != $rootDiskSize) { goto c22c1; } goto eacf7; e505e: c22c1: goto ab48b; Be1f2: goto c7fe8; goto B4646; d6cb8: $user = $this->getUser(); goto d5824; E7e28: $numberOfProcessorCores = 0; goto Fc269; bfba5: $cpuChart = new Chart("\x43\120\125\40\125\163\x61\x67\x65"); goto f3a1c; ab48b: $diskData = [["\156\141\155\145" => sprintf("\x2f\40\x28\x25\163\x29", $rootDiskSize), "\x63\157\x6c\157\x72" => "\x23\67\63\x62\x66\x34\x63", "\144\x61\164\141" => $diskData["\x72\157\157\164"] ?: []], ["\x6e\x61\x6d\145" => sprintf("\x2f\x68\x6f\x6d\x65\40\50\x25\x73\x29", $homeDiskSize), "\143\x6f\x6c\x6f\162" => "\x23\146\x33\142\146\60\x30", "\144\141\x74\141" => $diskData["\150\x6f\x6d\145"] ?: []]]; goto b9a44; D0206: } private function getCategoriesForTimeRange(User $user, \DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto ff10d; Ed785: $categoryDateTime->setTimezone(new \DateTimeZone($user->getTimezone())); goto c054c; Bf1f7: f48cf: goto Fb0e5; Bfc29: $endDataDate->modify(sprintf("\x2b\45\x30\x35\x64\x20\x6d\x69\156\x75\164\145\163", $minuteInterval)); goto b4457; fe545: c3ed7: goto e1eb6; Ec604: $endDataDate = clone $startTime; goto fe545; c054c: $categories[] = $categoryDateTime->format("\x48\x3a\151"); goto b58d2; A861a: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\x25\60\65\x64\x20\155\x69\156\165\164\145\x73", $minuteInterval)); goto Ec604; A83e8: $categoryDateTime = clone $endDataDate; goto Ed785; Fb0e5: return $categories; goto B27f4; e1eb6: if (!($endDataDate <= $endTime)) { goto f48cf; } goto A83e8; ff10d: $categories = []; goto A861a; b4457: goto c3ed7; goto Bf1f7; b58d2: $startDataDate->modify(sprintf("\53\45\60\x35\x64\x20\155\151\x6e\x75\164\x65\x73", $minuteInterval)); goto Bfc29; B27f4: } private function getCpuDataForTimeRange(\DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto Ba615; f2f5c: return $cpuData; goto Acc80; Fc7a8: c4433: goto f2f5c; Fe197: d5096: goto fbc78; a0d33: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\x25\x30\x35\144\40\x6d\x69\156\x75\x74\145\x73", $minuteInterval)); goto A33d9; B54aa: goto d5096; goto Fc7a8; ff59e: $cpuData[] = $averageCpuValue; goto f0b12; bf0df: $endDataDate->modify(sprintf("\53\45\x30\65\x64\40\155\x69\156\165\x74\x65\x73", $minuteInterval)); goto B54aa; fbc78: if (!($endDataDate <= $endTime)) { goto c4433; } goto dd1b7; A33d9: $endDataDate = clone $startTime; goto Fe197; Ba615: $cpuData = []; goto a0d33; f0b12: $startDataDate->modify(sprintf("\53\45\60\65\144\x20\155\x69\156\165\164\145\163", $minuteInterval)); goto bf0df; dd1b7: $averageCpuValue = $this->instanceCpuEntityManager->getAverageCpuValue($startDataDate, $endDataDate); goto ff59e; Acc80: } private function getMemoryDataForTimeRange(\DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto C2dc5; dfbcf: $startDataDate->modify(sprintf("\x2b\45\x30\x35\144\40\x6d\151\156\x75\x74\145\x73", $minuteInterval)); goto c4533; Fed99: if (!($endDataDate <= $endTime)) { goto E4e98; } goto a0702; bfce1: $memoryData[] = (int) $averageMemoryValue; goto dfbcf; B061f: E4e98: goto e3bfc; c4533: $endDataDate->modify(sprintf("\53\x25\60\65\144\40\155\x69\156\x75\x74\145\163", $minuteInterval)); goto c01db; a0702: $averageMemoryValue = $this->instanceMemoryEntityManager->getAverageMemoryValue($startDataDate, $endDataDate); goto bfce1; e3bfc: return $memoryData; goto d4072; F2b11: b5481: goto Fed99; Ede60: $startDataDate = (clone $startTime)->modify(sprintf("\55\45\60\x35\x64\40\x6d\151\156\165\164\145\163", $minuteInterval)); goto Aeada; c01db: goto b5481; goto B061f; C2dc5: $memoryData = []; goto Ede60; Aeada: $endDataDate = clone $startTime; goto F2b11; d4072: } private function getDiskDataForTimeRange($startTime, $endTime, $minuteInterval) : array { goto f1250; ce7bd: if (!($endDataDate <= $endTime)) { goto fb797; } goto Ee216; Ee216: foreach (["\x2f", "\x2f\x68\157\x6d\145"] as $disk) { goto f729b; f729b: $averageDiskSizeValue = (int) $this->instanceDiskUsageEntityManager->getAverageDiskSizeValue($disk, $startDataDate, $endDataDate); goto b6187; dab51: $diskData["\150\157\x6d\x65"][] = (int) $averageDiskSizeValue; goto d33e0; d33e0: goto Ba050; goto E407c; b6187: if ("\x2f" == $disk) { goto f6d5d; } goto dab51; E407c: f6d5d: goto fb466; e1c31: f0694: goto b1454; fb466: $diskData["\162\x6f\x6f\x74"][] = (int) $averageDiskSizeValue; goto f12a8; f12a8: Ba050: goto e1c31; b1454: } goto cb406; c85c3: goto eab28; goto A68c0; C838e: return $diskData; goto f23d6; F93ad: $endDataDate = clone $startTime; goto a140a; Af0af: $endDataDate->modify(sprintf("\x2b\x25\60\x35\x64\x20\155\x69\x6e\165\164\x65\163", $minuteInterval)); goto c85c3; f1250: $diskData = []; goto Fbfba; A68c0: fb797: goto C838e; cb406: d80e8: goto f987c; a140a: eab28: goto ce7bd; f987c: $startDataDate->modify(sprintf("\x2b\45\x30\65\x64\40\x6d\151\156\x75\x74\145\163", $minuteInterval)); goto Af0af; Fbfba: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\45\60\65\144\40\x6d\151\156\x75\164\145\x73", $minuteInterval)); goto F93ad; f23d6: } private function getLoadAverageDataForTimeRange($startTime, $endTime, $minuteInterval) : array { goto F5d66; E3ab9: $startDataDate->modify(sprintf("\x2b\x25\60\65\x64\x20\155\151\x6e\x75\164\145\163", $minuteInterval)); goto ce77f; eade9: $endDataDate = clone $startTime; goto Ccf60; Ccf60: bd339: goto dd420; D8377: return $loadAverageData; goto d88bb; ce77f: $endDataDate->modify(sprintf("\53\45\60\65\x64\40\155\x69\x6e\165\164\145\x73", $minuteInterval)); goto ba410; F5d66: $loadAverageData = []; goto B3efd; B3efd: $startDataDate = (clone $startTime)->modify(sprintf("\55\x25\x30\x35\x64\40\155\x69\156\165\164\x65\x73", $minuteInterval)); goto eade9; E0f96: add84: goto E3ab9; dd420: if (!($endDataDate <= $endTime)) { goto ac1e1; } goto f1410; E8898: ac1e1: goto D8377; ba410: goto bd339; goto E8898; f1410: foreach ([InstanceLoadAverageEntity::PERIOD_ONE_MINUTE, InstanceLoadAverageEntity::PERIOD_FIVE_MINUTES, InstanceLoadAverageEntity::PERIOD_FIVETEEN_MINUTES] as $period) { goto F16c6; F16c6: $loadAverageValue = $this->instanceLoadAverageEntityManager->getLoadAverageValue($period, $startDataDate, $endDataDate); goto deab6; deab6: $loadAverageData[$period][] = round($loadAverageValue, 2); goto E605c; E605c: Cfc05: goto Ce926; Ce926: } goto E0f96; d88bb: } }
