<?php
 namespace App\Controller\Frontend; use Symfony\Component\Form\FormError; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Component\HttpFoundation\RedirectResponse; use Symfony\Component\Form\Extension\Core\Type\ButtonType; use Symfony\Component\Form\Extension\Core\Type\SubmitType; use Symfony\Contracts\Translation\TranslatorInterface; use Symfony\Component\HttpFoundation\Cookie; use Symfony\Component\Form\Form; use Twig\Environment as Twig; use Doctrine\Common\Collections\ArrayCollection; use App\Controller\Controller; use App\Event\EventQueue; use App\Service\Crypto; use App\Service\Logger; use App\Site\Site; use App\Site\NodejsSite; use App\Site\StaticSite; use App\Site\PhpSite; use App\Site\PythonSite; use App\Entity\Site as SiteEntity; use App\Entity\NodejsSettings; use App\Entity\PhpSettings; use App\Entity\PythonSettings; use App\Entity\BasicAuth as BasicAuthEntity; use App\Entity\BlockedBot as BlockedBotEntity; use App\Entity\BlockedIp as BlockedIpEntity; use App\Entity\Database as DatabaseEntity; use App\Entity\DatabaseUser as DatabaseUserEntity; use App\Entity\User as UserEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\CronJob as CronJobEntity; use App\Entity\FtpUser as FtpUserEntity; use App\Entity\SshUser as SshUserEntity; use App\Site\Updater as SiteUpdater; use App\Site\Updater\NodejsSite as NodejsSiteUpdater; use App\Site\Updater\StaticSite as StaticSiteUpdater; use App\Site\Updater\PhpSite as PhpSiteUpdater; use App\Site\Updater\PythonSite as PythonSiteUpdater; use App\Site\Deleter as SiteDeleter; use App\Site\Deleter\NodejsSite as NodejsSiteDeleter; use App\Site\Deleter\StaticSite as StaticSiteDeleter; use App\Site\Deleter\PhpSite as PhpSiteDeleter; use App\Site\Deleter\PythonSite as PythonSiteDeleter; use App\Database\Manager as DatabaseManager; use App\Entity\Manager\ConfigManager; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\BasicAuthManager as BasicAuthEntityManager; use App\Entity\Manager\BlockedIpManager as BlockedIpEntityManager; use App\Entity\Manager\BlockedBotManager as BlockedBotEntityManager; use App\Entity\Manager\CertificateManager as CertificateEntityManager; use App\Entity\Manager\CronJobManager as CronJobEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseUserManager as DatabaseUserEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Entity\Manager\NodejsSettingsManager as NodejsSettingsEntityManager; use App\Entity\Manager\FtpUserManager as FtpUserEntityManager; use App\Entity\Manager\SshUserManager as SshUserEntityManager; use App\Log\LogfileReader; use App\Log\LogsFinder; use App\Log\Parser\NginxAccessLogParser; use App\Log\Parser\NginxErrorLogParser; use App\Log\Parser\PhpFpmErrorLogParser; use App\Site\Parser\DomainName as DomainNameParser; use App\Site\Nginx\Exception\InvalidVhostException; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\PrivateKey; use App\Site\Ssl\LetsEncryptClient; class SitesController extends Controller { private const FILE_MANAGER_COOKIE_EXPIRATION = 3; private ConfigManager $configManager; private SiteEntityManager $siteEntityManager; private BasicAuthEntityManager $basicAuthEntityManager; private BlockedIpEntityManager $blockedIpEntityManager; private BlockedBotEntityManager $blockedBotEntityManager; private CertificateEntityManager $certificateEntityManager; private CronJobEntityManager $cronJobEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseUserEntityManager $databaseUserEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private NodejsSettingsEntityManager $nodejsSettingsEntityManager; private FtpUserEntityManager $ftpUserEntityManager; private SshUserEntityManager $sshUserEntityManager; private DomainNameParser $domainNameParser; public function __construct(ConfigManager $configManager, SiteEntityManager $siteEntityManager, BasicAuthEntityManager $basicAuthEntityManager, BlockedIpEntityManager $blockedIpEntityManager, BlockedBotEntityManager $blockedBotEntityManager, CertificateEntityManager $certificateEntityManager, CronJobEntityManager $cronJobEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseUserEntityManager $databaseUserEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, NodejsSettingsEntityManager $nodejsSettingsEntityManager, FtpUserEntityManager $ftpUserEntityManager, SshUserEntityManager $sshUserEntityManager, DomainNameParser $domainNameParser, TranslatorInterface $translator, Logger $logger) { goto fed06; df3d0: $this->siteEntityManager = $siteEntityManager; goto b9ccc; f92c0: $this->databaseServerEntityManager = $databaseServerEntityManager; goto b6379; d805e: $this->ftpUserEntityManager = $ftpUserEntityManager; goto F8fc0; C4522: $this->blockedIpEntityManager = $blockedIpEntityManager; goto d39c1; F8fc0: $this->sshUserEntityManager = $sshUserEntityManager; goto E37ac; b6379: $this->nodejsSettingsEntityManager = $nodejsSettingsEntityManager; goto d805e; F4dbf: $this->cronJobEntityManager = $cronJobEntityManager; goto De00b; A10f2: $this->certificateEntityManager = $certificateEntityManager; goto F4dbf; F8576: $this->databaseUserEntityManager = $databaseUserEntityManager; goto f92c0; fed06: $this->configManager = $configManager; goto df3d0; d39c1: $this->blockedBotEntityManager = $blockedBotEntityManager; goto A10f2; b9ccc: $this->basicAuthEntityManager = $basicAuthEntityManager; goto C4522; d9bdb: parent::__construct($translator, $logger); goto c49dd; E37ac: $this->domainNameParser = $domainNameParser; goto d9bdb; De00b: $this->databaseEntityManager = $databaseEntityManager; goto F8576; c49dd: } public function index(Request $request) : Response { goto d49e5; d49e5: $user = $this->getUser(); goto A7e1a; C64b2: $response = $this->render("\x46\162\x6f\x6e\164\145\156\x64\x2f\x53\x69\164\x65\x2f\x69\x6e\144\x65\x78\56\x68\164\155\154\x2e\164\x77\151\x67", ["\165\x73\145\162" => $user, "\163\x69\164\145\163" => $sites]); goto Dffca; Dffca: return $response; goto aac51; A7e1a: $sites = $this->siteEntityManager->getUserSites($user, ["\144\157\x6d\x61\151\x6e\116\x61\155\x65" => "\x61\163\143"]); goto C64b2; aac51: } public function fileManager(Request $request) : Response { goto cf450; Ac9ba: $data = serialize($data); goto B805a; D2aea: $locale = $request->getLocale(); goto cbdf3; e0029: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\x73\x69\164\x65\x73")); goto c8efc; D0c1d: $data = ["\165\163\x65\162" => $siteUser, "\154\157\143\141\154\x65" => $locale]; goto Ac9ba; E9f57: $siteUser = $site->getUser(); goto D2aea; c8efc: goto f9aa8; goto e5a76; F7a4d: f9aa8: goto F3060; B805a: $encryptedData = Crypto::encrypt($data); goto b4286; F3060: return $response; goto D2bab; cc0e8: $response = $this->render("\106\x72\157\x6e\164\145\156\x64\57\x53\151\x74\x65\x2f\146\151\154\x65\x2d\x6d\x61\156\141\x67\x65\x72\x2e\150\x74\x6d\x6c\x2e\x74\x77\151\x67", ["\163\x69\x74\145" => $site, "\146\x69\x6c\x65\115\141\x6e\141\x67\x65\162\125\x72\154" => $fileManagerUrl, "\146\x6f\x72\x6d\x45\x72\162\x6f\162\x73" => $this->formErrors]); goto E96b0; e5a76: Ac9c1: goto E9f57; cbdf3: $cookieExpirationDate = new \DateTime("\156\x6f\167"); goto C653f; cf450: $site = $this->getSite($request); goto da112; b4286: $encryptedData = trim(base64_encode($encryptedData)); goto D4f9f; cb157: $fileManagerUrl = sprintf("\45\x73\57\146\151\154\x65\x2d\x6d\141\x6e\141\147\x65\x72\57", rtrim($request->getSchemeAndHttpHost(), "\57")); goto cc0e8; da112: if (false === is_null($site)) { goto Ac9c1; } goto e0029; D4f9f: $cookie = new Cookie("\143\154\160\x2d\x66\155", $encryptedData, $cookieExpirationDate); goto cb157; E96b0: $response->headers->setCookie($cookie); goto F7a4d; C653f: $cookieExpirationDate->modify(sprintf("\x2b\x25\x73\40\x68\157\165\x72\x73", self::FILE_MANAGER_COOKIE_EXPIRATION)); goto D0c1d; D2bab: } public function view(Request $request) : Response { goto F4ed9; Bfd01: return $response; goto dac6c; E82de: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\x73\x69\x74\x65\x5f\163\145\x74\x74\151\x6e\x67\x73", ["\x64\x6f\155\141\151\156\116\x61\x6d\x65" => $domainName])); goto Bfd01; F4ed9: $domainName = $request->get("\144\x6f\x6d\141\151\156\x4e\x61\x6d\x65"); goto E82de; dac6c: } public function logs(Request $request) : Response { goto Aa156; ddc47: $form = $this->createLogsForm($siteEntity); goto D260d; Ed3f5: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto ddc47; Ac37a: goto F1f4e; goto b3cee; fc5b4: if (false === is_null($site)) { goto f8502; } goto Ce718; D260d: $response = $this->render("\106\162\x6f\x6e\164\x65\x6e\x64\57\123\x69\164\145\x2f\x6c\157\x67\163\56\150\x74\x6d\154\56\164\167\151\147", ["\163\x69\164\x65" => $site, "\x66\157\x72\x6d\x45\x72\x72\x6f\x72\163" => $this->formErrors, "\x66\x6f\x72\155" => $form->createView()]); goto C42e2; b3cee: f8502: goto Ed3f5; Ce718: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\x69\x74\x65\x73")); goto Ac37a; Aa156: $site = $this->getSite($request); goto fc5b4; d2135: return $response; goto Aef3d; C42e2: F1f4e: goto d2135; Aef3d: } private function createLogsForm(SiteEntity $siteEntity) : Form { goto D50d8; Daf3a: return $form; goto c971c; D50d8: $form = $this->createForm("\101\x70\x70\x5c\106\x6f\x72\155\134\x53\151\x74\x65\x4c\157\x67\163\x54\x79\160\145", [], ["\x61\143\x74\151\x6f\156" => $this->generateUrl("\x63\x6c\160\x5f\x73\151\164\x65\x5f\154\157\x67\163", ["\144\x6f\155\x61\151\156\116\141\155\145" => $siteEntity->getDomainName()]), "\155\145\x74\x68\x6f\x64" => "\120\117\x53\124", "\x61\x74\164\162" => []]); goto Ed41a; Ed41a: $form->add("\165\x70\x64\x61\x74\x65", ButtonType::class, ["\x61\164\x74\x72" => ["\143\x6c\141\x73\163" => "\142\164\156\x20\142\164\156\55\154\x67\x20\142\164\x6e\x2d\x62\x6c\x75\x65\40\x62\164\x6e\55\165\x70\144\141\x74\145"], "\154\x61\x62\145\154" => "\125\x70\x64\x61\164\x65"]); goto Daf3a; c971c: } public function logFileContent(Request $request, Twig $twig) : Response { goto c117f; a4c41: f3f58: goto D2924; Fe9bd: $logfileName = trim($request->get("\x6c\157\147\106\151\x6c\145")); goto ee012; B0b2b: E8a9a: goto a4c41; A2357: $site = $this->getSite($request); goto c1548; c1548: if (!(false === is_null($site))) { goto f3f58; } goto F5384; ee012: $numberOfLines = (int) $request->get("\x6e\x75\x6d\x62\x65\162\x4f\146\x4c\x69\156\x65\163"); goto b1e4c; F5384: $service = trim($request->get("\x73\145\x72\x76\151\143\x65")); goto Fe9bd; D2924: $response = $this->json($data); goto fdaf4; fdaf4: return $response; goto bf243; bd438: try { goto F0601; fa9a1: $logMessages = $nginxAccessLogParser->parse(); goto e8036; D15ac: $data["\x6c\157\147\x4d\145\x73\x73\141\x67\145\163\110\x74\x6d\x6c"] = $logMessagesHtml; goto B5eb2; C4001: $userTimezone = $user->getTimezone(); goto c9065; fd2fa: $logMessages = $phpFpmErrorLogParser->parse(); goto Ca6a4; c9065: if ("\141\143\x63\x65\x73\163\56\154\x6f\x67" == substr($logfileName, 0, 10)) { goto c033f; } goto B3b7b; ceb39: $logMessagesHtml = ''; goto ee6f3; Ad75c: Ab2ec: goto A816f; cb590: $logMessages = $nginxErrorLogParser->parse(); goto Ade85; Fe034: $nginxAccessLogParser->setTimezone($userTimezone->getName()); goto fa9a1; e8036: $logMessagesHtml = $twig->render("\106\x72\157\156\x74\x65\156\144\57\123\151\x74\x65\57\114\x6f\147\x73\57\156\147\151\156\170\x2d\x61\143\x63\145\163\x73\55\154\x6f\x67\x2d\x6d\145\x73\163\x61\147\x65\163\56\x68\x74\x6d\x6c\x2e\x74\167\151\x67", ["\154\157\x67\x4d\145\163\x73\x61\x67\145\x73" => $logMessages]); goto Ad75c; b6c01: c25f0: goto D15ac; Ade85: $logMessagesHtml = $twig->render("\x46\x72\157\x6e\x74\145\x6e\144\57\x53\151\164\x65\x2f\114\x6f\x67\163\x2f\156\x67\151\x6e\170\x2d\x65\x72\162\157\162\x2d\x6c\157\147\55\x6d\145\x73\163\141\x67\x65\163\x2e\x68\164\x6d\154\x2e\164\x77\151\147", ["\x6c\157\x67\x4d\x65\163\x73\x61\x67\145\163" => $logMessages]); goto C1ea0; Adb24: if (!("\x70\150\160" == $service)) { goto c25f0; } goto Aaf29; Bc7f9: $nginxAccessLogParser = new NginxAccessLogParser($logLines); goto Fe034; ee6f3: $user = $this->getUser(); goto f1c78; B3b7b: $nginxErrorLogParser = new NginxErrorLogParser($logLines); goto cb590; Aaf29: $phpFpmErrorLogParser = new PhpFpmErrorLogParser($logLines); goto fd2fa; b8746: c033f: goto Bc7f9; F0601: $logfile = sprintf("\57\x68\x6f\155\x65\57\45\163\x2f\154\x6f\x67\163\x2f\45\163\x2f\45\163", $site->getUser(), $service, $logfileName); goto e254c; f1c78: if (!("\x6e\147\151\156\x78" == $service)) { goto d5bd9; } goto C4001; C1ea0: goto Ab2ec; goto b8746; A816f: d5bd9: goto Adb24; Ca6a4: $logMessagesHtml = $twig->render("\106\x72\157\156\164\x65\156\144\57\x53\151\x74\x65\57\114\157\147\163\57\160\150\x70\x2d\146\x70\155\55\x65\162\162\157\x72\x2d\154\157\147\x2d\x6d\x65\163\163\x61\147\145\x73\x2e\150\164\155\154\56\x74\x77\151\x67", ["\154\x6f\147\x4d\x65\163\163\141\147\x65\x73" => $logMessages]); goto b6c01; e254c: $logfileReader = new LogfileReader($logfile); goto Dd62f; Dd62f: $logLines = $logfileReader->getLines($numberOfLines); goto ceb39; B5eb2: } catch (\Exception $e) { $this->logger->exception($e); } goto B0b2b; b1e4c: if (!(false === empty($service) && false === empty($logfileName))) { goto E8a9a; } goto bd438; c117f: $data = []; goto A2357; bf243: } public function loadLogfilesForService(Request $request) : Response { goto F8861; A2956: bf02f: goto ebe1b; ebe1b: c4ed8: goto c47f7; A7833: $site = $this->getSite($request); goto f4384; c47f7: $response = $this->json($data); goto ae40c; adb9b: try { goto e5751; b05a9: Ff7db: goto B6c1d; e5751: $logfilesDirectory = sprintf("\x2f\x68\x6f\x6d\145\x2f\x25\x73\57\x6c\x6f\x67\x73\x2f\x25\163\x2f", $site->getUser(), $service); goto b4c6b; f707a: $data["\154\x6f\147\146\151\x6c\145\163"] = $logfiles; goto b05a9; ec134: if (!(false === empty($logfiles))) { goto Ff7db; } goto f707a; bd822: $logfiles = $logsFinder->getLogfiles(); goto ec134; b4c6b: $logsFinder = new LogsFinder($logfilesDirectory); goto bd822; B6c1d: } catch (\Exception $e) { $this->logger->exception($e); } goto A2956; f4384: if (!(false === is_null($site))) { goto c4ed8; } goto C26e2; C26e2: $service = trim($request->get("\x73\x65\x72\x76\151\x63\x65")); goto Ed65f; F8861: $data = []; goto A7833; Ed65f: if (!(false === empty($service))) { goto bf02f; } goto adb9b; ae40c: return $response; goto A232b; A232b: } public function cronJobs(Request $request) : Response { goto f92fe; C8cc3: return $response; goto F1b3f; D06a1: if (false === is_null($site)) { goto B4da4; } goto db7e6; Fdd10: B4da4: goto b6949; db7e6: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\x69\x74\145\x73")); goto f14cb; f14cb: goto D6ce3; goto Fdd10; D415b: D6ce3: goto C8cc3; f92fe: $site = $this->getSite($request); goto D06a1; b6949: $response = $this->render("\x46\x72\x6f\x6e\164\x65\156\144\57\x53\151\x74\x65\x2f\143\x72\157\156\x2d\152\157\x62\163\x2e\x68\x74\155\x6c\x2e\164\x77\151\147", ["\x73\151\x74\145" => $site, "\146\x6f\162\x6d\105\162\x72\157\162\163" => $this->formErrors]); goto D415b; F1b3f: } public function newCronJob(Request $request) : Response { goto Cd419; a2691: $response = $this->render("\106\x72\x6f\156\x74\x65\156\144\57\123\x69\164\x65\57\156\145\167\x2d\143\x72\x6f\156\x2d\152\x6f\142\x2e\150\x74\155\154\x2e\x74\x77\x69\x67", ["\x73\x69\164\145" => $site, "\146\157\162\x6d" => $form->createView(), "\x66\x6f\162\155\105\162\162\x6f\162\x73" => $this->formErrors]); goto cbb11; C4514: $response = $this->handleCronJobForm($request, $form, $site); goto C1adc; b28ee: Dee15: goto D2cc8; B19fd: $cronJobEntity = $this->cronJobEntityManager->createEntity(); goto E7b44; E7b44: $cronJobEntity->setSite($siteEntity); goto F9e9d; Cd419: $site = $this->getSite($request); goto b2fb1; b2fb1: if (false === is_null($site)) { goto D0a87; } goto C3093; D2cc8: f2d0e: goto A44dd; D6752: if (!(true === $form->isSubmitted())) { goto f2d0e; } goto C4514; ed1dd: if (!(true === $request->isMethod("\120\117\x53\x54"))) { goto E0eb9; } goto d72e7; C3093: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\151\x74\145\163")); goto Ed6c0; Ed6c0: goto b7f67; goto f9617; F3ecb: return $response; goto D8edf; A44dd: E0eb9: goto a2691; F9e9d: $form = $this->createCronJobForm($cronJobEntity); goto ed1dd; cbb11: b7f67: goto F3ecb; f9617: D0a87: goto e460e; a82e7: return $response; goto b28ee; e460e: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto B19fd; C1adc: if (!(false === is_null($response))) { goto Dee15; } goto a82e7; d72e7: $form->handleRequest($request); goto D6752; D8edf: } private function createCronJobForm(CronJobEntity $cronJobEntity) : Form { goto ce81b; C5bfb: return $form; goto Afa84; E3f31: $form = $this->createForm("\101\x70\x70\x5c\x46\157\162\155\x5c\123\151\164\145\x43\x72\157\156\112\x6f\x62\124\x79\x70\x65", $cronJobEntity, ["\141\143\164\151\157\x6e" => $this->generateUrl("\x63\x6c\x70\x5f\x73\x69\x74\x65\137\x63\x72\x6f\x6e\x5f\x6a\x6f\142\x5f\156\145\167", ["\144\157\x6d\141\x69\156\x4e\141\x6d\x65" => $siteEntity->getDomainName()]), "\155\145\164\150\x6f\x64" => "\120\x4f\123\x54", "\141\x74\164\162" => []]); goto dd1f3; dd1f3: $form->add("\163\x75\x62\x6d\151\x74", SubmitType::class, ["\141\x74\164\162" => ["\143\x6c\141\163\x73" => "\x62\x74\156\x20\x62\164\156\55\142\x6c\165\145\40\x62\164\x6e\55\x6c\x67"], "\154\141\x62\x65\154" => "\x41\144\x64\40\103\x72\157\156\x20\x4a\x6f\142"]); goto C5bfb; ce81b: $siteEntity = $cronJobEntity->getSite(); goto E3f31; Afa84: } private function handleCronJobForm(Request $request, Form $form, Site $site) { goto d1445; F15f0: $this->formErrors = $this->getErrorMessages($form); goto Ff8ae; dec1b: D2a3f: goto d046e; e8d18: C216c: goto D9edf; d1445: if (true === $form->isValid()) { goto C216c; } goto F15f0; D9edf: try { goto F3a7a; f13f9: $siteEntity = $this->getSiteEntity($domainName); goto ba7c2; A6671: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_ADD, $user, $eventData, $request); goto f6ce1; e7219: $eventData = ["\x73\x69\164\145" => $domainName, "\143\162\157\156\x74\141\142\x45\170\160\x72\x65\x73\163\x69\157\x6e" => $cronJobEntity->getCrontabExpression()]; goto A6671; Fb97f: $this->siteEntityManager->updateEntity($siteEntity); goto D6ed3; a3f2a: $domainName = $site->getDomainName(); goto f13f9; ba7c2: if (false === is_null($siteEntity)) { goto Ebc2a; } goto E9062; F3a7a: $session = $request->getSession(); goto a3f2a; eb236: $cronJobEntity = $form->getData(); goto D86a6; B5ffc: Ebc2a: goto Ca5d0; a047d: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\151\x74\145\x5f\x63\x72\x6f\x6e\x5f\x6a\x6f\x62\x73", ["\x64\157\x6d\141\x69\156\116\141\x6d\145" => $site->getDomainName()])); goto d128e; Ca5d0: $user = $this->getUser(); goto eb236; D86a6: $siteEntity->addCronJob($cronJobEntity); goto Aa8cf; f6ce1: $session->getFlashBag()->set("\x73\165\143\x63\x65\x73\x73", $this->translator->trans("\103\x72\157\156\40\112\x6f\x62\x20\x68\x61\x73\x20\x62\145\x65\156\x20\x61\x64\x64\x65\144\56")); goto a047d; A44b0: $siteUpdater->updateUserCrontab(); goto e7219; E9062: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x73\x69\x74\145\163")); goto f873d; d128e: ae3ec: goto e70ef; D6ed3: $siteUpdater = $this->getSiteUpdater($site); goto A44b0; e70ef: return $response; goto B15eb; Aa8cf: $site->setCronJobs($siteEntity->getCronJobs()); goto Fb97f; f873d: goto ae3ec; goto B5ffc; B15eb: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\x72", $this->translator->trans("\x41\156\x20\145\x72\x72\x6f\162\40\x68\x61\x73\x20\x6f\x63\143\165\x72\162\145\144\54\40\x65\x72\162\x6f\162\x20\155\145\x73\x73\x61\147\x65\72\40\x25\145\x72\x72\157\x72\115\x65\x73\x73\x61\147\x65\45", ["\x25\x65\x72\x72\x6f\x72\x4d\x65\x73\x73\x61\x67\x65\x25" => $e->getMessage()])); } goto dec1b; Ff8ae: goto D2a3f; goto e8d18; d046e: } public function deleteCronJob(Request $request) : Response { goto F5bd3; c54dc: if (!(false === is_null($site))) { goto bb1b2; } goto e1a09; e1a09: try { goto E08cd; acf06: $domainName = $site->getDomainName(); goto ec137; E08cd: $session = $request->getSession(); goto C7c0a; f84ff: $evenData = ["\163\151\x74\x65" => $domainName, "\143\157\155\x6d\141\156\x64" => $cronJobEntity->getCommand()]; goto Ba7e7; da664: $site->setCronJobs($siteEntity->getCronJobs()); goto B99f7; d7892: $session->getFlashBag()->set("\163\x75\143\x63\x65\x73\163", $this->translator->trans("\x43\162\157\156\40\x4a\x6f\142\x20\150\x61\163\40\x62\x65\x65\x6e\40\x64\x65\x6c\x65\x74\145\144\x2e")); goto f3cf1; Ac5c6: ba41b: goto Ff2f8; a7e74: $user = $this->getUser(); goto f72e3; F4e8a: beaa2: goto Ac5c6; B99f7: $this->siteEntityManager->updateEntity($siteEntity); goto f573d; a137e: if (!(false === is_null($siteEntity) && false === is_null($cronJobEntity))) { goto ba41b; } goto F2f19; Ba7e7: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_DELETE, $user, $evenData, $request); goto d7892; f4ab5: $siteUpdater->updateUserCrontab(); goto f84ff; f573d: $siteUpdater = $this->getSiteUpdater($site); goto f4ab5; f3cf1: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\x65\x5f\143\x72\x6f\x6e\137\x6a\157\142\163", ["\144\157\155\x61\x69\x6e\x4e\141\x6d\145" => $site->getDomainName()])); goto cfc63; f72e3: $siteEntity->removeCronJob($cronJobEntity); goto da664; F2f19: $cronJobSiteEntity = $cronJobEntity->getSite(); goto ac343; ac343: if (!($siteEntity->getDomainName() == $cronJobSiteEntity->getDomainName())) { goto beaa2; } goto a7e74; ec137: $siteEntity = $this->getSiteEntity($domainName); goto A1dcd; A1dcd: $cronJobEntity = $this->cronJobEntityManager->findOneById($id); goto a137e; cfc63: return $response; goto F4e8a; C7c0a: $id = (int) $request->get("\151\x64"); goto acf06; Ff2f8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\x65\162", $this->translator->trans("\x41\x6e\40\x65\162\x72\x6f\x72\x20\150\x61\163\x20\x6f\x63\x63\x75\162\x72\x65\x64\x2c\x20\145\162\162\157\162\x20\155\145\163\163\141\147\x65\72\40\x25\x65\x72\162\157\162\x4d\145\x73\x73\141\147\145\x25", ["\x25\145\x72\162\x6f\162\x4d\x65\x73\163\141\147\145\x25" => $e->getMessage()])); } goto E14a3; c0769: return $response; goto A3b11; ee727: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\x69\164\145\163")); goto c0769; F5bd3: $site = $this->getSite($request); goto c54dc; E14a3: bb1b2: goto ee727; A3b11: } public function editCronJob(Request $request) : Response { goto cc747; A5ce4: $form = $this->createCronJobEditForm($cronJobEntity); goto c5fc5; Ee962: goto D39c5; goto aa575; F1271: $form->handleRequest($request); goto Aa742; Ad8be: $response = $this->handleCronJobEditForm($request, $form, $site); goto eba0e; cc747: $id = (int) $request->get("\151\144"); goto e91dc; D1636: D39c5: goto E5b23; e91dc: $site = $this->getSite($request); goto dbe07; E5af6: return $response; goto E5201; F3456: a47a4: goto Aed05; dbe07: $cronJobEntity = $this->cronJobEntityManager->findOneById($id); goto f3a3e; f3a3e: if (false === is_null($cronJobEntity) && false === is_null($site) && $cronJobEntity->getSite()->getDomainName() == $site->getDomainName()) { goto Cd162; } goto F7714; aa575: Cd162: goto A5ce4; E5201: d6ad6: goto f8019; eba0e: if (!(false === is_null($response))) { goto d6ad6; } goto E5af6; f8019: b99de: goto F3456; F7714: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\163\x69\x74\x65\x73")); goto Ee962; Aa742: if (!(true === $form->isSubmitted())) { goto b99de; } goto Ad8be; Aed05: $response = $this->render("\x46\162\x6f\x6e\164\145\x6e\x64\57\x53\151\x74\145\57\145\144\x69\x74\55\x63\x72\x6f\x6e\x2d\152\157\x62\56\x68\164\x6d\x6c\x2e\x74\167\151\147", ["\x73\151\x74\145" => $site, "\x66\x6f\162\155" => $form->createView(), "\x66\x6f\x72\155\x45\162\162\x6f\162\x73" => $this->formErrors]); goto D1636; E5b23: return $response; goto f9d56; c5fc5: if (!(true === $request->isMethod("\120\x4f\123\x54"))) { goto a47a4; } goto F1271; f9d56: } private function createCronJobEditForm(CronJobEntity $cronJobEntity) : Form { goto B83a9; Fee49: $form->add("\163\x75\x62\x6d\x69\x74", SubmitType::class, ["\x61\164\x74\x72" => ["\143\x6c\141\163\163" => "\142\x74\x6e\x20\142\164\x6e\55\x62\x6c\165\x65\40\x62\x74\156\x2d\154\147"], "\x6c\x61\x62\145\x6c" => "\123\x61\166\x65"]); goto ff42e; B83a9: $siteEntity = $cronJobEntity->getSite(); goto b75de; b75de: $form = $this->createForm("\x41\160\x70\134\106\x6f\x72\155\x5c\x53\x69\x74\145\x43\162\157\156\x4a\157\142\x45\144\x69\164\x54\171\x70\145", $cronJobEntity, ["\141\143\164\151\157\x6e" => $this->generateUrl("\x63\154\160\137\x73\x69\164\x65\x5f\143\162\157\156\x5f\x6a\157\x62\x5f\x65\144\x69\x74", ["\144\x6f\155\x61\x69\x6e\x4e\x61\155\x65" => $siteEntity->getDomainName(), "\151\x64" => $cronJobEntity->getId()]), "\x6d\x65\x74\150\x6f\144" => "\120\117\123\x54", "\x61\x74\164\x72" => []]); goto Fee49; ff42e: return $form; goto be83d; be83d: } private function handleCronJobEditForm(Request $request, Form $form, Site $site) { goto e137f; D2e0d: $this->formErrors = $this->getErrorMessages($form); goto f0658; c7fa5: Ef4e9: goto C6fcd; Eee04: b7c5b: goto cb94a; cb94a: try { goto D1598; E1572: $this->siteEntityManager->updateEntity($siteEntity); goto Deb8f; fc149: $session->getFlashBag()->set("\163\x75\143\x63\145\163\163", $this->translator->trans("\x43\162\157\x6e\40\x4a\x6f\x62\40\x68\x61\x73\40\x62\145\145\156\40\x73\x61\x76\145\x64\x2e")); goto b020b; C6ce4: $eventData = ["\x73\x69\164\x65" => $domainName, "\143\162\x6f\x6e\164\141\x62\x45\x78\160\x72\x65\163\x73\x69\x6f\156" => $cronJobEntity->getCrontabExpression()]; goto e883d; E19ee: return $response; goto efd5a; Fc24e: $siteEntity->addCronJob($cronJobEntity); goto c201a; b156f: $cronJobEntity = $form->getData(); goto Fc24e; D1598: $session = $request->getSession(); goto c287c; E3cad: Cc3fc: goto E19ee; c201a: $site->setCronJobs($siteEntity->getCronJobs()); goto E1572; Deb8f: $siteUpdater = $this->getSiteUpdater($site); goto bb5f6; Eb038: $siteEntity = $this->getSiteEntity($domainName); goto Cf4dc; e883d: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_EDIT, $user, $eventData, $request); goto fc149; c287c: $domainName = $site->getDomainName(); goto Eb038; Cf4dc: if (false === is_null($siteEntity)) { goto f542a; } goto Be8fb; bb5f6: $siteUpdater->updateUserCrontab(); goto C6ce4; ec2a6: f542a: goto b1537; Af202: goto Cc3fc; goto ec2a6; Be8fb: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\151\x74\145\x73")); goto Af202; b1537: $user = $this->getUser(); goto b156f; b020b: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\151\x74\x65\137\143\x72\157\x6e\x5f\152\157\142\163", ["\144\157\x6d\x61\x69\x6e\116\x61\155\145" => $site->getDomainName()])); goto E3cad; efd5a: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\145\162", $this->translator->trans("\x41\x6e\40\x65\x72\x72\x6f\162\40\150\x61\x73\40\x6f\x63\x63\165\x72\162\x65\144\x2c\40\145\x72\x72\157\162\40\155\x65\x73\x73\141\147\x65\x3a\40\x25\145\x72\x72\x6f\162\115\145\x73\x73\141\x67\145\x25", ["\x25\145\x72\162\x6f\x72\x4d\145\163\163\141\147\x65\45" => $e->getMessage()])); } goto c7fa5; f0658: goto Ef4e9; goto Eee04; e137f: if (true === $form->isValid()) { goto b7c5b; } goto D2e0d; C6fcd: } public function users(Request $request) : Response { goto fb208; E03e7: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\x69\x74\x65\x73")); goto ff2ac; Ff1e6: Bc481: goto a53ef; d647a: $response = $this->render("\x46\162\157\156\x74\x65\x6e\x64\x2f\123\151\x74\x65\57\x75\163\x65\x72\x73\56\150\x74\155\154\x2e\x74\x77\x69\x67", ["\x73\x69\164\145" => $site, "\146\157\x72\x6d\x45\x72\162\x6f\x72\163" => $this->formErrors]); goto Ff1e6; a53ef: return $response; goto A0f9b; ff2ac: goto Bc481; goto Cef4a; A641e: if (false === is_null($site)) { goto Da673; } goto E03e7; fb208: $site = $this->getSite($request); goto A641e; Cef4a: Da673: goto d647a; A0f9b: } public function newFtpUser(Request $request) : Response { goto f6adf; B91ba: if (!(true === $request->isMethod("\120\x4f\x53\124"))) { goto E2ce4; } goto fa37d; Eefeb: return $response; goto F9bcf; bb50d: if (false === is_null($site)) { goto A7283; } goto f8769; d5447: $response = $this->render("\x46\x72\x6f\156\164\145\x6e\x64\x2f\x53\151\164\x65\57\x6e\x65\167\55\146\x74\x70\x2d\165\x73\x65\162\x2e\150\164\x6d\154\x2e\164\x77\151\147", ["\163\151\x74\145" => $site, "\146\x6f\x72\x6d" => $form->createView(), "\146\x6f\x72\x6d\x45\162\x72\x6f\x72\163" => $this->formErrors]); goto da436; d8673: $form = $this->createFtpUserForm($ftpUserEntity); goto B91ba; a564b: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto C1f63; F9bcf: bc2d9: goto F38dd; f6adf: $site = $this->getSite($request); goto bb50d; B3055: $response = $this->handleFtpUserForm($request, $form, $site); goto cf23d; Eaac9: $ftpUserEntity->setSite($siteEntity); goto d8673; E7ae7: E2ce4: goto d5447; C1f63: $ftpUserEntity = $this->ftpUserEntityManager->createEntity(); goto Eaac9; cf23d: if (!(false === is_null($response))) { goto bc2d9; } goto Eefeb; c4cf6: return $response; goto ff223; f0fca: goto ae92e; goto bb3e0; F38dd: e950b: goto E7ae7; da436: ae92e: goto c4cf6; f8769: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\151\164\145\163")); goto f0fca; F4c14: if (!(true === $form->isSubmitted())) { goto e950b; } goto B3055; bb3e0: A7283: goto a564b; fa37d: $form->handleRequest($request); goto F4c14; ff223: } private function createFtpUserForm(FtpUserEntity $ftpUserEntity) : Form { goto D407f; F487d: $form = $this->createForm("\101\x70\x70\x5c\x46\157\162\x6d\134\123\x69\x74\145\106\x74\x70\125\x73\145\x72\124\171\x70\x65", $ftpUserEntity, ["\141\x63\164\x69\x6f\156" => $this->generateUrl("\143\x6c\160\137\x73\x69\x74\145\x5f\x66\164\160\137\165\x73\145\162\x5f\156\145\x77", ["\x64\x6f\155\141\x69\156\116\141\155\x65" => $siteEntity->getDomainName()]), "\155\x65\164\x68\157\144" => "\120\x4f\x53\x54", "\x61\164\164\162" => []]); goto d859a; d859a: $form->add("\x73\x75\142\155\151\164", SubmitType::class, ["\141\164\x74\162" => ["\x63\x6c\141\163\x73" => "\142\164\156\40\142\164\156\x2d\142\x6c\165\x65\40\x62\164\156\55\x6c\147"], "\154\141\x62\145\154" => "\x41\x64\x64\40\125\163\x65\x72"]); goto c441c; c441c: return $form; goto E6d60; D407f: $siteEntity = $ftpUserEntity->getSite(); goto F487d; E6d60: } private function handleFtpUserForm(Request $request, Form $form, Site $site) { goto da4eb; Bdb41: Cd04c: goto Afe6e; D2623: try { goto ae39f; c4cf5: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\151\164\x65\x5f\165\163\x65\162\163", ["\144\157\x6d\x61\x69\156\116\x61\155\145" => $site->getDomainName()])); goto Ea8c7; b9937: $ftpUserEntity = $form->getData(); goto ab559; Bf38d: $ftpUserPassword = $form->get("\x70\141\x73\x73\x77\157\x72\144")->getData(); goto Afe03; a4608: $user = $this->getUser(); goto b9937; b937d: $session->getFlashBag()->set("\163\165\143\x63\x65\x73\x73", $this->translator->trans("\x55\x73\145\162\x20\150\141\163\x20\142\x65\x65\x6e\x20\x61\144\x64\x65\x64\56")); goto c4cf5; e3478: $this->siteEntityManager->updateEntity($siteEntity); goto C9926; A7726: $siteEntity->addFtpUser($ftpUserEntity); goto e3478; a7dcb: if (false === is_null($siteEntity)) { goto ed897; } goto Ee338; Ee685: $siteEntity = $this->getSiteEntity($domainName); goto a7dcb; C62a8: goto Ebb7a; goto fcf12; C9926: $siteUpdater = $this->getSiteUpdater($site); goto F81d0; a50fd: $domainName = $site->getDomainName(); goto Ee685; ae39f: $session = $request->getSession(); goto a50fd; fcf12: ed897: goto a4608; B7b4d: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_ADD, $user, $eventData, $request); goto b937d; ab559: $ftpUserName = $ftpUserEntity->getUserName(); goto Bf38d; Ee338: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\x65\x73")); goto C62a8; F81d0: $siteUpdater->createFtpUser($ftpUserEntity); goto D14b4; Ea8c7: Ebb7a: goto f1c6f; f1c6f: return $response; goto aae13; Afe03: $ftpUserEntity->setPassword($ftpUserPassword); goto A7726; D14b4: $eventData = ["\x73\x69\x74\x65" => $domainName, "\x75\163\x65\x72\116\141\x6d\145" => $ftpUserName, "\x68\x6f\155\145\x44\x69\x72\x65\x63\164\157\x72\171" => $ftpUserEntity->getHomeDirectory()]; goto B7b4d; aae13: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\145\162", $this->translator->trans("\101\x6e\40\145\162\x72\157\x72\40\x68\141\163\40\x6f\x63\143\x75\162\x72\145\x64\x2c\40\145\162\162\157\x72\40\155\x65\x73\163\141\147\x65\72\40\x25\x65\162\162\x6f\162\115\145\x73\163\141\147\x65\x25", ["\x25\x65\x72\162\x6f\162\115\145\163\163\x61\x67\145\x25" => $e->getMessage()])); } goto Bdb41; B8e78: goto Cd04c; goto Bdbad; Bdbad: C459f: goto D2623; Ee3cf: $this->formErrors = $this->getErrorMessages($form); goto B8e78; da4eb: if (true === $form->isValid()) { goto C459f; } goto Ee3cf; Afe6e: } public function editFtpUser(Request $request) : Response { goto D7c01; Decde: if (!(true === $form->isSubmitted())) { goto D3fa1; } goto aa1a0; e7b7b: D3fa1: goto f0929; D7c01: $userName = $request->get("\x75\x73\x65\162\116\141\x6d\x65"); goto e9d6a; D3503: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\151\x74\145\x73")); goto F5b6a; fadb3: return $response; goto dd616; f0929: a678b: goto B2e15; e9d6a: $site = $this->getSite($request); goto C77d2; B4d7c: return $response; goto d67be; C77d2: $ftpUserEntity = $this->ftpUserEntityManager->findOneByUserName($userName); goto D6630; d1829: $form->handleRequest($request); goto Decde; E51b0: if (!(false === is_null($response))) { goto Bfedc; } goto fadb3; dd616: Bfedc: goto e7b7b; D2945: F090d: goto e9f33; d9843: c0a05: goto B4d7c; e9f33: $form = $this->createFtpUserEditForm($ftpUserEntity); goto B07e6; D6630: if (false === is_null($ftpUserEntity) && false === is_null($site) && $ftpUserEntity->getSite()->getDomainName() == $site->getDomainName()) { goto F090d; } goto D3503; F5b6a: goto c0a05; goto D2945; aa1a0: $response = $this->handleFtpUserEditForm($request, $form, $site); goto E51b0; B07e6: if (!(true === $request->isMethod("\120\117\x53\124"))) { goto a678b; } goto d1829; B2e15: $response = $this->render("\106\162\x6f\x6e\x74\145\x6e\x64\x2f\123\151\164\145\57\x65\144\151\164\x2d\146\164\x70\x2d\165\163\145\162\56\150\x74\155\x6c\56\164\x77\x69\147", ["\163\x69\164\145" => $site, "\x66\157\x72\x6d" => $form->createView(), "\x66\x6f\162\x6d\x45\162\x72\x6f\162\x73" => $this->formErrors]); goto d9843; d67be: } private function createFtpUserEditForm(FtpUserEntity $ftpUserEntity) : Form { goto E265f; A176e: $form = $this->createForm("\101\x70\x70\134\106\157\162\x6d\134\x53\151\164\x65\x46\164\160\x55\x73\x65\x72\x45\x64\151\x74\x54\x79\x70\x65", $ftpUserEntity, ["\141\143\x74\151\157\x6e" => $this->generateUrl("\143\x6c\x70\137\x73\151\164\145\x5f\146\x74\x70\137\165\163\145\162\137\x65\144\x69\164", ["\x64\157\x6d\141\151\x6e\x4e\141\x6d\145" => $siteEntity->getDomainName(), "\165\163\x65\162\x4e\141\x6d\145" => $ftpUserEntity->getUserName()]), "\155\145\x74\150\x6f\144" => "\x50\x4f\x53\124", "\x61\164\164\162" => []]); goto C4ea6; f02e3: return $form; goto bdc59; E265f: $siteEntity = $ftpUserEntity->getSite(); goto A176e; C4ea6: $form->add("\163\165\x62\155\x69\x74", SubmitType::class, ["\141\164\164\x72" => ["\143\154\x61\x73\x73" => "\142\x74\156\x20\x62\164\x6e\x2d\x62\x6c\165\x65\40\x62\x74\156\55\x6c\x67"], "\x6c\x61\x62\145\x6c" => "\x53\141\166\x65"]); goto f02e3; bdc59: } private function handleFtpUserEditForm(Request $request, Form $form, Site $site) { goto a7c09; Fa141: Fc4bc: goto f6872; eb9e4: E9ce5: goto Dce84; a7c09: if (true === $form->isValid()) { goto Fc4bc; } goto F14a9; A5cbf: goto E9ce5; goto Fa141; F14a9: $this->formErrors = $this->getErrorMessages($form); goto A5cbf; f6872: try { goto F9d9b; E0bb9: C64c4: goto B53df; D9d35: A5096: goto d31bf; F9d9b: $session = $request->getSession(); goto a4dcf; fe629: $ftpUserPassword = $form->get("\160\141\163\163\x77\157\x72\144")->getData(); goto f8d67; ded0c: $this->siteEntityManager->updateEntity($siteEntity); goto Bbd2c; a1950: $ftpUserEntity = $form->getData(); goto A8bf1; d3fd8: $siteUpdater->changeUserHomeDirectory($ftpUserName, $ftpUserHomeDirectory); goto F3e15; A9f00: goto C64c4; goto bbb22; Efc01: $session->getFlashBag()->set("\163\x75\x63\143\x65\x73\x73", $this->translator->trans("\125\163\145\x72\40\x68\141\163\40\142\145\x65\x6e\x20\x73\141\166\x65\x64\56")); goto b63c2; F6bf1: $siteUpdater->changeUserPassword($ftpUserName, $ftpUserPassword); goto D9d35; d31bf: $eventData = ["\x73\151\x74\145" => $domainName, "\165\163\145\x72\116\x61\155\x65" => $ftpUserName, "\x68\157\x6d\x65\x44\151\x72\x65\x63\x74\x6f\162\171" => $ftpUserHomeDirectory]; goto f2676; bbb22: D6780: goto f1735; a9dc3: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\163\151\x74\145\x73")); goto A9f00; f1735: $user = $this->getUser(); goto a1950; a4dcf: $domainName = $site->getDomainName(); goto Dcfae; F3e15: if (!(false === empty($ftpUserPassword))) { goto A5096; } goto F6bf1; Eaefb: if (false === is_null($siteEntity)) { goto D6780; } goto a9dc3; b63c2: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\x69\x74\x65\137\x75\163\x65\162\163", ["\144\157\x6d\x61\x69\x6e\116\141\155\145" => $site->getDomainName()])); goto E0bb9; Bbd2c: $siteUpdater = $this->getSiteUpdater($site); goto d3fd8; B53df: return $response; goto b13e9; A8bf1: $ftpUserName = $ftpUserEntity->getUserName(); goto fe629; f2676: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_EDIT, $user, $eventData, $request); goto Efc01; f8d67: $ftpUserHomeDirectory = $ftpUserEntity->getHomeDirectory(); goto ded0c; Dcfae: $siteEntity = $this->getSiteEntity($domainName); goto Eaefb; b13e9: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\145\162", $this->translator->trans("\101\x6e\40\x65\x72\162\x6f\162\x20\150\x61\163\x20\x6f\143\143\x75\162\162\145\144\54\x20\x65\162\x72\x6f\x72\x20\x6d\145\x73\163\x61\x67\x65\x3a\x20\45\145\x72\x72\157\x72\x4d\145\x73\163\141\147\145\x25", ["\45\x65\162\162\x6f\x72\115\x65\163\163\x61\147\x65\45" => $e->getMessage()])); } goto eb9e4; Dce84: } public function deleteFtpUser(Request $request) : Response { goto a7b84; D2ad6: return $response; goto fbf95; a7b84: $site = $this->getSite($request); goto F22d3; A0ebd: f4703: goto a758d; a758d: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\x73\x69\164\x65\x73")); goto D2ad6; F22d3: if (!(false === is_null($site))) { goto f4703; } goto aa13e; aa13e: try { goto Ff315; fce22: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_DELETE, $user, $evenData, $request); goto Cede2; d5d5a: $ftpUserEntity = $this->ftpUserEntityManager->findOneByUserName($userName); goto c9f97; e20d4: $siteUpdater = $this->getSiteUpdater($site); goto E2e99; e56de: $this->siteEntityManager->updateEntity($siteEntity); goto e20d4; b2e56: $siteEntity = $this->getSiteEntity($domainName); goto d5d5a; Ff315: $session = $request->getSession(); goto ea257; F147f: if (!($siteEntity->getDomainName() == $ftpUserSiteEntity->getDomainName())) { goto df7ce; } goto A0874; b01c6: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x73\x69\x74\145\137\165\163\145\162\x73", ["\x64\x6f\x6d\141\x69\156\116\141\x6d\145" => $site->getDomainName()])); goto bc93c; aef72: $domainName = $site->getDomainName(); goto b2e56; c9f97: if (!(false === is_null($siteEntity) && false === empty($userName) && false === is_null($ftpUserEntity))) { goto d1f3d; } goto b1bcb; ea257: $userName = $request->get("\x75\163\x65\x72\x4e\141\x6d\x65"); goto aef72; bc93c: return $response; goto A9563; A3ed5: d1f3d: goto C1a88; E2e99: $siteUpdater->deleteUser($userName, false); goto b10c1; Cc97e: $userName = $ftpUserEntity->getUserName(); goto B4b44; A9563: df7ce: goto A3ed5; Cede2: $session->getFlashBag()->set("\x73\x75\x63\x63\x65\x73\x73", $this->translator->trans("\125\163\x65\162\40\x68\x61\x73\x20\142\145\x65\156\40\144\x65\154\x65\164\x65\144\x2e")); goto b01c6; b10c1: $evenData = ["\163\x69\x74\145" => $domainName, "\165\x73\x65\x72\116\x61\155\145" => $userName]; goto fce22; A0874: $user = $this->getUser(); goto Cc97e; b1bcb: $ftpUserSiteEntity = $ftpUserEntity->getSite(); goto F147f; B4b44: $siteEntity->removeFtpUser($ftpUserEntity); goto e56de; C1a88: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\x67\x65\x72", $this->translator->trans("\x41\156\40\x65\162\x72\157\162\x20\x68\141\x73\x20\157\x63\x63\x75\162\x72\x65\144\54\40\145\x72\x72\157\162\x20\155\145\163\x73\141\x67\145\72\x20\x25\x65\x72\x72\x6f\162\x4d\x65\x73\x73\x61\x67\x65\x25", ["\45\145\x72\x72\x6f\162\x4d\x65\163\163\x61\147\145\45" => $e->getMessage()])); } goto A0ebd; fbf95: } public function newSshUser(Request $request) : Response { goto ecd5b; Edfcd: $sshUserEntity = $this->sshUserEntityManager->createEntity(); goto fa7e3; F319a: ac0d8: goto c4596; A603b: if (!(true === $request->isMethod("\x50\x4f\123\124"))) { goto ac0d8; } goto A5838; D0321: ec2a8: goto D41b5; Ff5dc: Dae7e: goto Bda1a; E1a80: $form = $this->createSshUserForm($sshUserEntity); goto A603b; ecd5b: $site = $this->getSite($request); goto d5f38; De92d: return $response; goto D5639; c9129: b385b: goto F319a; c4596: $response = $this->render("\106\x72\x6f\156\x74\145\156\x64\57\x53\x69\164\145\x2f\156\x65\167\55\163\x73\150\x2d\x75\x73\x65\x72\56\150\164\155\x6c\56\164\167\x69\x67", ["\163\151\x74\x65" => $site, "\146\157\x72\155" => $form->createView(), "\146\x6f\162\x6d\105\x72\x72\157\x72\163" => $this->formErrors]); goto D0321; A4762: if (!(true === $form->isSubmitted())) { goto b385b; } goto cb405; D5639: E7998: goto c9129; C3a2d: goto ec2a8; goto Ff5dc; d5f38: if (false === is_null($site)) { goto Dae7e; } goto F0c48; d964d: if (!(false === is_null($response))) { goto E7998; } goto De92d; A5838: $form->handleRequest($request); goto A4762; cb405: $response = $this->handleSshUserForm($request, $form, $site); goto d964d; D41b5: return $response; goto e56f2; fa7e3: $sshUserEntity->setSite($siteEntity); goto E1a80; F0c48: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\x69\x74\x65\x73")); goto C3a2d; Bda1a: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto Edfcd; e56f2: } private function createSshUserForm(SshUserEntity $sshUserEntity) : Form { goto ce6ce; Dbd68: $form->add("\x73\x75\142\x6d\x69\164", SubmitType::class, ["\x61\164\164\x72" => ["\143\x6c\141\163\163" => "\142\x74\x6e\40\142\164\x6e\55\x62\x6c\165\145\x20\142\x74\x6e\55\154\x67"], "\x6c\x61\142\145\x6c" => "\x41\x64\x64\x20\125\163\145\162"]); goto Ddb27; Ddb27: return $form; goto Da2fc; af731: $form = $this->createForm("\x41\x70\160\x5c\106\x6f\x72\x6d\134\123\151\164\145\x53\x73\150\x55\163\x65\162\x54\x79\x70\x65", $sshUserEntity, ["\x61\x63\164\151\x6f\x6e" => $this->generateUrl("\143\154\x70\137\x73\151\x74\145\137\x73\x73\x68\137\165\163\145\x72\137\156\x65\167", ["\144\x6f\155\141\x69\156\116\141\155\x65" => $siteEntity->getDomainName()]), "\155\145\x74\x68\x6f\144" => "\120\117\123\x54", "\x61\x74\x74\162" => []]); goto Dbd68; ce6ce: $siteEntity = $sshUserEntity->getSite(); goto af731; Da2fc: } private function handleSshUserForm(Request $request, Form $form, Site $site) { goto e1011; Df11b: $this->formErrors = $this->getErrorMessages($form); goto Ba311; e1011: if (true === $form->isValid()) { goto b2873; } goto Df11b; Ef1b7: try { goto d9804; Cd720: $sshKeys = $sshUserEntity->getSshKeys(); goto Dbca2; e02e3: goto ba94c; goto c073f; B8c67: $sshUserEntity = $form->getData(); goto Eecd2; B98e6: $this->siteEntityManager->updateEntity($siteEntity); goto D4c36; A50ae: $siteEntity = $this->getSiteEntity($domainName); goto b8ee5; d5e51: ba94c: goto F74c3; E27b3: if (!(false === empty($sshKeys))) { goto baf0a; } goto b5107; b5107: $siteUpdater->updateUserSShKeys($sshUserName, $sshKeys); goto Fe8d3; Bdeba: $siteUpdater->createSshUser($sshUserEntity); goto E27b3; D4c36: $siteUpdater = $this->getSiteUpdater($site); goto Bdeba; F74c3: return $response; goto E4f43; Dbca2: $siteEntity->addSshUser($sshUserEntity); goto B98e6; c7124: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\x69\x74\145\137\165\163\x65\162\x73", ["\x64\x6f\155\141\x69\x6e\116\x61\155\x65" => $site->getDomainName()])); goto d5e51; A2cf7: $session->getFlashBag()->set("\x73\165\143\143\x65\x73\163", $this->translator->trans("\x55\163\145\x72\x20\150\x61\163\40\x62\x65\145\156\40\141\x64\x64\x65\x64\x2e")); goto c7124; bf2ad: $sshUserPassword = $form->get("\160\x61\163\163\167\x6f\162\144")->getData(); goto Be13b; b8ee5: if (false === is_null($siteEntity)) { goto c54e7; } goto E3c10; d9804: $session = $request->getSession(); goto bc39b; Be13b: $sshUserEntity->setPassword($sshUserPassword); goto Cd720; bc39b: $domainName = $site->getDomainName(); goto A50ae; E3c10: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\151\x74\x65\x73")); goto e02e3; c073f: c54e7: goto C4c8f; Ad940: $eventData = ["\x73\151\x74\145" => $domainName, "\x75\163\145\162\116\141\155\145" => $sshUserName, "\163\163\150\113\145\x79\163" => $sshKeys]; goto Ddc6e; Eecd2: $sshUserName = $sshUserEntity->getUserName(); goto bf2ad; Fe8d3: baf0a: goto Ad940; Ddc6e: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_ADD, $user, $eventData, $request); goto A2cf7; C4c8f: $user = $this->getUser(); goto B8c67; E4f43: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\156\147\145\162", $this->translator->trans("\x41\x6e\40\145\x72\x72\x6f\x72\40\150\x61\x73\x20\x6f\143\x63\165\x72\162\x65\x64\54\x20\145\162\162\157\x72\40\x6d\145\163\x73\x61\x67\145\72\40\45\145\x72\x72\157\x72\x4d\x65\x73\163\x61\147\145\45", ["\x25\x65\162\x72\x6f\x72\115\x65\x73\163\141\147\x65\45" => $e->getMessage()])); } goto F4d0d; Ba311: goto a085e; goto f299a; F4d0d: a085e: goto cede5; f299a: b2873: goto Ef1b7; cede5: } public function editSshUser(Request $request) : Response { goto b85cc; Dc8e8: if (!(false === is_null($response))) { goto Ee67c; } goto C2701; c156f: $response = $this->handleSshUserEditForm($request, $form, $site); goto Dc8e8; d2978: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($userName); goto dab33; dab33: if (false === is_null($sshUserEntity) && false === is_null($site) && $sshUserEntity->getSite()->getDomainName() == $site->getDomainName()) { goto eed84; } goto fd2da; c98b5: if (!(true === $form->isSubmitted())) { goto C0ba7; } goto c156f; F9e65: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto c8ce7; } goto E423d; fd2da: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\x69\x74\x65\163")); goto fdff4; d5996: $response = $this->render("\x46\x72\x6f\x6e\164\x65\x6e\144\x2f\123\151\164\x65\x2f\145\x64\151\164\x2d\163\163\150\55\165\x73\x65\x72\56\x68\164\x6d\154\x2e\164\x77\151\x67", ["\x73\x69\164\x65" => $site, "\146\x6f\162\x6d" => $form->createView(), "\x66\x6f\162\155\x45\162\162\x6f\162\163" => $this->formErrors]); goto cbcfb; C2701: return $response; goto d7a06; b85cc: $userName = $request->get("\x75\163\145\162\116\x61\155\x65"); goto f877c; C081b: $form = $this->createSshUserEditForm($sshUserEntity); goto F9e65; E423d: $form->handleRequest($request); goto c98b5; a4dda: C0ba7: goto a3309; d7a06: Ee67c: goto a4dda; fdff4: goto D047d; goto F654c; A6d92: return $response; goto A92c1; cbcfb: D047d: goto A6d92; a3309: c8ce7: goto d5996; F654c: eed84: goto C081b; f877c: $site = $this->getSite($request); goto d2978; A92c1: } private function createSshUserEditForm(SshUserEntity $sshUserEntity) : Form { goto Bd4d8; B03d7: return $form; goto C8293; Bd4d8: $siteEntity = $sshUserEntity->getSite(); goto fd8ab; fd8ab: $form = $this->createForm("\101\160\x70\134\x46\157\x72\x6d\134\123\151\x74\145\123\163\150\x55\163\x65\162\105\144\151\x74\x54\171\160\145", $sshUserEntity, ["\x61\143\x74\151\x6f\x6e" => $this->generateUrl("\143\154\160\x5f\x73\x69\x74\145\137\x73\x73\x68\137\x75\163\x65\162\137\145\x64\151\x74", ["\x64\157\155\x61\x69\156\116\141\x6d\x65" => $siteEntity->getDomainName(), "\x75\163\x65\162\x4e\x61\x6d\x65" => $sshUserEntity->getUserName()]), "\x6d\145\164\x68\x6f\x64" => "\x50\x4f\x53\x54", "\141\x74\164\x72" => []]); goto D6725; D6725: $form->add("\163\165\x62\x6d\151\x74", SubmitType::class, ["\x61\164\164\x72" => ["\x63\x6c\x61\163\x73" => "\x62\x74\x6e\40\142\x74\x6e\55\142\154\165\x65\40\142\x74\156\55\x6c\147"], "\x6c\141\x62\x65\x6c" => "\x53\141\166\145"]); goto B03d7; C8293: } private function handleSshUserEditForm(Request $request, Form $form, Site $site) { goto ae783; ae783: if (true === $form->isValid()) { goto da52c; } goto D6c0f; b0bc8: Ff61d: goto c8002; D6c0f: $this->formErrors = $this->getErrorMessages($form); goto fb89c; c83ee: try { goto e5857; b1bd6: $sshUserPassword = $form->get("\x70\x61\x73\x73\167\157\162\x64")->getData(); goto B76f4; B4815: B88ac: goto fd7eb; c531e: $session->getFlashBag()->set("\x73\165\x63\143\x65\x73\x73", $this->translator->trans("\x55\163\145\162\x20\x68\141\163\40\x62\145\145\x6e\40\163\141\x76\x65\144\56")); goto bef64; A81fc: c5ee8: goto Faa13; bef64: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\x69\164\145\x5f\165\x73\145\x72\x73", ["\144\157\155\x61\151\156\x4e\x61\x6d\x65" => $site->getDomainName()])); goto B4815; fd7eb: return $response; goto C14c8; A318d: $siteUpdater->changeUserPassword($sshUserName, $sshUserPassword); goto Bd07c; F85f6: goto B88ac; goto A81fc; E0761: if (false === is_null($siteEntity)) { goto c5ee8; } goto a6897; Dc3f9: $siteUpdater->updateUserSShKeys($sshUserName, $sshKeys); goto B41f6; D7b84: $siteEntity = $this->getSiteEntity($domainName); goto E0761; fd6de: $sshUserEntity = $form->getData(); goto de76a; d334d: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_EDIT, $user, $eventData, $request); goto c531e; B8b72: if (!(false === empty($sshUserPassword))) { goto Cd2cb; } goto A318d; Faa13: $user = $this->getUser(); goto fd6de; d3143: $domainName = $site->getDomainName(); goto D7b84; D3ad4: $this->siteEntityManager->updateEntity($siteEntity); goto Ac404; a6897: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\163\x69\x74\x65\163")); goto F85f6; de76a: $sshUserName = $sshUserEntity->getUserName(); goto b1bd6; Bd07c: Cd2cb: goto Dc3f9; e5857: $session = $request->getSession(); goto d3143; B41f6: $eventData = ["\163\151\164\x65" => $domainName, "\165\x73\145\162\116\141\x6d\145" => $sshUserName, "\x73\163\x68\x4b\x65\171\163" => $sshKeys]; goto d334d; B76f4: $sshKeys = false === is_null($sshUserEntity->getSshKeys()) ? $sshUserEntity->getSshKeys() : ''; goto D3ad4; Ac404: $siteUpdater = $this->getSiteUpdater($site); goto B8b72; C14c8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\x67\145\x72", $this->translator->trans("\101\x6e\x20\x65\x72\162\157\x72\x20\x68\141\x73\x20\157\143\x63\165\162\162\x65\x64\x2c\40\145\x72\162\x6f\x72\40\x6d\145\x73\163\141\x67\145\x3a\x20\45\x65\162\162\x6f\x72\115\145\163\163\x61\x67\x65\x25", ["\45\145\x72\x72\157\162\115\x65\x73\x73\x61\147\145\x25" => $e->getMessage()])); } goto b0bc8; Eddd5: da52c: goto c83ee; fb89c: goto Ff61d; goto Eddd5; c8002: } public function deleteSshUser(Request $request) : Response { goto ae403; ae403: $site = $this->getSite($request); goto A4a8d; a49f1: c9698: goto b1b58; a1af2: try { goto A7459; A0eeb: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_DELETE, $user, $evenData, $request); goto F0def; F4b95: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($userName); goto C0846; C288f: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\x69\x74\x65\137\x75\163\x65\162\163", ["\x64\x6f\x6d\141\151\x6e\x4e\141\x6d\145" => $site->getDomainName()])); goto Ecc6b; feb6c: $user = $this->getUser(); goto E6622; cf95b: $userName = $request->get("\x75\163\145\162\x4e\141\155\145"); goto D39fa; Ecc6b: return $response; goto f2ee2; E6622: $userName = $sshUserEntity->getUserName(); goto ccf2b; Df693: $sshUserSiteEntity = $sshUserEntity->getSite(); goto defef; Fd4ec: $siteUpdater = $this->getSiteUpdater($site); goto C52f3; C0846: if (!(false === is_null($siteEntity) && false === empty($userName) && false === is_null($sshUserEntity))) { goto D536e; } goto Df693; F0def: $session->getFlashBag()->set("\163\x75\x63\x63\x65\x73\x73", $this->translator->trans("\x55\x73\145\x72\40\150\x61\163\40\142\x65\145\156\40\x64\145\154\145\x74\x65\144\x2e")); goto C288f; C52f3: $siteUpdater->deleteUser($userName, true); goto Fcd83; f2ee2: C46a2: goto fb5aa; ed361: $siteEntity = $this->getSiteEntity($domainName); goto F4b95; Fcd83: $evenData = ["\x73\151\164\145" => $domainName, "\165\163\x65\162\116\x61\x6d\x65" => $userName]; goto A0eeb; fbffc: $this->siteEntityManager->updateEntity($siteEntity); goto Fd4ec; ccf2b: $siteEntity->removeSshUser($sshUserEntity); goto fbffc; D39fa: $domainName = $site->getDomainName(); goto ed361; defef: if (!($siteEntity->getDomainName() == $sshUserSiteEntity->getDomainName())) { goto C46a2; } goto feb6c; fb5aa: D536e: goto F7ad6; A7459: $session = $request->getSession(); goto cf95b; F7ad6: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\x67\x65\162", $this->translator->trans("\x41\x6e\x20\145\162\162\x6f\x72\40\x68\x61\163\40\157\x63\143\165\x72\x72\145\x64\x2c\x20\x65\162\x72\157\162\x20\155\145\x73\163\141\x67\x65\72\40\x25\145\x72\162\157\x72\115\x65\163\x73\x61\x67\145\45", ["\x25\145\x72\162\x6f\162\115\x65\163\163\141\x67\145\x25" => $e->getMessage()])); } goto a49f1; ab2fa: return $response; goto d9b06; A4a8d: if (!(false === is_null($site))) { goto c9698; } goto a1af2; b1b58: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\x69\x74\145\163")); goto ab2fa; d9b06: } public function security(Request $request) : Response { goto Ab97d; ab57b: if (!(true === $request->isMethod("\120\x4f\123\x54"))) { goto Bbca6; } goto Bcd71; Bcd71: $basicAuthForm->handleRequest($request); goto Cccff; Abdad: $basicAuthEntity = $this->basicAuthEntityManager->createEntity(); goto f17e5; B89dc: ee86c: goto d3b33; d2580: goto c8783; goto B89dc; D4514: b9b4a: goto e8391; cb372: if (!(true === $basicAuthForm->isSubmitted())) { goto abf90; } goto A8116; B22ca: $cloudflareData = ["\141\x6c\x6c\x6f\x77\124\x72\141\x66\146\151\143\106\x72\x6f\x6d\x43\x6c\157\x75\x64\x66\x6c\141\x72\145\117\156\x6c\171" => $siteEntity->allowTrafficFromCloudflareOnly()]; goto Ea376; A2bfd: c8783: goto Bad72; f072f: abf90: goto Eab43; f27c9: $basicAuthEntity->setSite($siteEntity); goto dd069; Ab97d: $site = $this->getSite($request); goto Aebc0; Be0ac: if (!(false === is_null($response))) { goto Dc4dc; } goto Ac3bb; e39d2: return $response; goto D4514; Cbc74: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x73\x69\164\x65\163")); goto d2580; e968e: if (!(false === is_null($response))) { goto b9b4a; } goto e39d2; e5b3f: Dc4dc: goto f072f; Ee3e9: $basicAuthEntity = $site->getBasicAuth(); goto df71b; efce9: $response = $this->render("\106\x72\157\156\x74\x65\x6e\x64\x2f\x53\x69\x74\x65\x2f\x73\x65\x63\165\162\151\164\x79\56\150\164\x6d\154\56\164\167\151\x67", ["\x73\x69\x74\145" => $site, "\x62\x6c\157\x63\x6b\145\x64\111\x70\x73" => $blockedIps, "\142\154\157\143\x6b\x65\x64\x42\157\164\x73" => $blockedBots, "\142\141\x73\151\143\x41\x75\x74\x68\x46\157\x72\155" => $basicAuthForm->createView(), "\x63\x6c\x6f\x75\144\x66\x6c\x61\162\145\106\x6f\162\155" => $cloudflareForm->createView(), "\146\x6f\x72\155\105\162\162\157\162\x73" => $this->formErrors]); goto A2bfd; Eab43: if (!(true === $cloudflareForm->isSubmitted())) { goto A902b; } goto e9ad0; dd069: $basicAuthForm = $this->createBasicAuthForm($basicAuthEntity); goto ccdbe; e9ad0: $response = $this->handleCloudflareForm($request, $cloudflareForm, $site); goto e968e; Bad72: return $response; goto Daccc; d3b33: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto B22ca; Ac3bb: return $response; goto e5b3f; A8116: $response = $this->handleBasicAuthForm($request, $basicAuthForm, $site); goto Be0ac; e8391: A902b: goto Df1a7; Df1a7: Bbca6: goto efce9; f17e5: C77d7: goto f27c9; Cccff: $cloudflareForm->handleRequest($request); goto cb372; Aebc0: if (false === is_null($site)) { goto ee86c; } goto Cbc74; Ea376: $blockedBots = $site->getBlockedBots(); goto A67b8; ccdbe: $cloudflareForm = $this->createCloudflareForm($siteEntity, $cloudflareData); goto ab57b; df71b: if (!(true === is_null($basicAuthEntity))) { goto C77d7; } goto Abdad; A67b8: $blockedIps = $site->getBlockedIps(); goto Ee3e9; Daccc: } private function createCloudflareForm(SiteEntity $siteEntity, array $data) : Form { goto Cf87f; E3540: $form->add("\163\165\x62\155\x69\x74", SubmitType::class, ["\x61\164\164\x72" => ["\143\154\141\163\163" => "\x62\x74\156\x20\x62\164\156\x2d\142\x6c\165\x65\x20\x62\164\x6e\55\154\x67"], "\x6c\x61\142\145\154" => "\123\141\166\x65"]); goto D1f4d; Cf87f: $form = $this->createForm("\101\160\160\134\x46\157\x72\x6d\134\x53\151\x74\x65\103\x6c\157\165\144\146\154\x61\162\x65\x54\171\x70\x65", $data, ["\141\143\x74\x69\x6f\x6e" => $this->generateUrl("\143\154\160\x5f\163\x69\x74\145\x5f\163\145\143\165\x72\151\x74\171", ["\x64\157\155\x61\x69\156\x4e\141\155\x65" => $siteEntity->getDomainName()]), "\155\145\164\150\157\x64" => "\x50\x4f\123\124", "\141\x74\164\162" => []]); goto E3540; D1f4d: return $form; goto Cefbf; Cefbf: } private function createBasicAuthForm(BasicAuthEntity $basicAuthEntity) : Form { goto d1f1e; A4bf6: $form->add("\x73\x75\x62\x6d\151\164", SubmitType::class, ["\x61\164\x74\x72" => ["\x63\x6c\141\x73\163" => "\142\x74\156\x20\142\164\156\x2d\142\154\165\145\x20\142\x74\156\x2d\154\x67"], "\x6c\141\142\x65\x6c" => "\123\141\166\145"]); goto b510e; d1f1e: $siteEntity = $basicAuthEntity->getSite(); goto E75e8; E75e8: $form = $this->createForm("\x41\160\160\134\106\157\162\x6d\x5c\123\151\x74\x65\x42\141\x73\151\x63\x41\x75\164\x68\x54\171\160\145", $basicAuthEntity, ["\141\143\164\151\157\156" => $this->generateUrl("\143\x6c\160\x5f\x73\x69\164\145\137\163\145\x63\x75\x72\x69\164\171", ["\144\157\155\x61\x69\x6e\116\141\155\x65" => $siteEntity->getDomainName()]), "\155\145\164\x68\x6f\x64" => "\x50\x4f\x53\124", "\x61\164\x74\162" => []]); goto A4bf6; b510e: return $form; goto E1c3e; E1c3e: } private function handleBasicAuthForm(Request $request, Form $form, Site $site) { goto a5908; a5908: if (true === $form->isValid()) { goto da17b; } goto ccb96; c1a7f: goto d8545; goto B5315; B5315: da17b: goto b1c0e; b1c0e: try { goto f947b; E43e9: Fd024: goto Deda3; Deda3: return $response; goto A5f1e; Cb20b: $siteUpdater->reloadNginxService(); goto Ad63f; Fca75: $user = $this->getUser(); goto e6d61; f947b: $session = $request->getSession(); goto f6699; d748d: if (false === is_null($siteEntity)) { goto e99c3; } goto Df97d; c8eac: $site->setBasicAuth($basicAuthEntity); goto ff0fd; c8845: EventQueue::addEvent(EventQueue::EVENT_SITE_BASIC_AUTHENTIFICATION_SETTINGS, $user, $eventData, $request); goto D328b; e6d61: $basicAuthEntity = $form->getData(); goto Ee48d; E00da: $siteUpdater->createBasicAuthFile($basicAuthEntity); goto Ff541; e95b0: e99c3: goto Fca75; ff0fd: $this->siteEntityManager->updateEntity($siteEntity); goto B809d; c99fe: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\151\164\145\x5f\x73\x65\x63\165\162\151\x74\x79", ["\x64\x6f\x6d\x61\151\156\x4e\141\155\x65" => $site->getDomainName()])); goto E43e9; Ee48d: $siteEntity->setBasicAuth($basicAuthEntity); goto c8eac; B345e: goto Fd024; goto e95b0; Ff541: $siteUpdater->updateNginxVhost(); goto Cb20b; f6699: $domainName = $site->getDomainName(); goto a4c81; a4c81: $siteEntity = $this->getSiteEntity($domainName); goto d748d; Ad63f: $eventData = ["\163\151\164\145" => $domainName, "\x61\143\x74\151\166\145" => true === $basicAuthEntity->getIsActive() ? "\x31" : "\60", "\165\163\x65\x72\x4e\141\x6d\x65" => $basicAuthEntity->getUserName(), "\167\x68\x69\164\x65\x6c\x69\x73\x74\145\144\111\160\163" => $basicAuthEntity->getWhitelistedIps()]; goto c8845; B809d: $siteUpdater = $this->getSiteUpdater($site); goto E00da; Df97d: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x73\x69\164\x65\163")); goto B345e; D328b: $session->getFlashBag()->set("\163\x75\143\143\145\x73\163", $this->translator->trans("\102\141\163\x69\x63\40\x41\x75\x74\x68\145\x6e\x74\151\x63\141\x74\151\157\x6e\x20\x73\145\x74\x74\x69\156\147\163\x20\150\141\166\x65\40\x62\145\x65\x6e\40\x73\141\x76\x65\144\x2e")); goto c99fe; A5f1e: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\x65\x72", $this->translator->trans("\x41\x6e\x20\x65\162\162\157\162\40\150\141\163\40\157\143\x63\165\162\x72\145\144\54\40\x65\162\x72\157\x72\40\155\x65\x73\163\141\x67\x65\72\40\45\145\x72\162\x6f\x72\115\145\x73\x73\141\147\145\45", ["\45\x65\162\162\x6f\162\115\x65\163\163\141\x67\x65\x25" => $e->getMessage()])); } goto e409b; e409b: d8545: goto d5ac9; ccb96: $this->formErrors = $this->getErrorMessages($form); goto c1a7f; d5ac9: } private function handleCloudflareForm(Request $request, Form $form, Site $site) { goto ef520; ef520: if (true === $form->isValid()) { goto Ac85c; } goto Bc7f6; Bc7f6: $this->formErrors = $this->getErrorMessages($form); goto a4a9d; de48f: ffe44: goto C0116; C33e3: Ac85c: goto de45a; a4a9d: goto ffe44; goto C33e3; de45a: try { goto E744c; fda53: d59c6: goto Df8ac; Cd362: EventQueue::addEvent(EventQueue::EVENT_SITE_CLOUDFLARE_SETTINGS, $user, $eventData, $request); goto F79ff; Ce4b0: $user = $this->getUser(); goto C5b41; Fa6b4: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\x69\x74\x65\163")); goto a056c; b9326: if (false === is_null($siteEntity)) { goto B633a; } goto Fa6b4; Df8ac: return $response; goto Abdea; d8dcb: $domainName = $site->getDomainName(); goto d2596; F79ff: $session->getFlashBag()->set("\x73\x75\x63\143\145\163\163", $this->translator->trans("\103\x6c\x6f\x75\x64\x66\x6c\x61\162\145\x20\163\x65\164\164\151\x6e\147\163\40\x68\141\x76\145\x20\x62\145\x65\156\40\x73\x61\x76\x65\x64\x2e")); goto afbbe; d2596: $siteEntity = $this->getSiteEntity($domainName); goto b9326; Ef5d1: $siteUpdater->reloadNginxService(); goto a256a; C5b41: $allowTrafficFromCloudflareOnly = $form->get("\x61\154\x6c\x6f\x77\124\x72\141\146\146\x69\143\x46\162\x6f\155\103\154\157\165\x64\x66\x6c\141\162\145\117\156\154\171")->getData(); goto ae6d4; Cef1d: $siteUpdater = $this->getSiteUpdater($site); goto ef826; a256a: $eventData = ["\163\x69\x74\x65" => $domainName, "\x61\154\154\157\x77\x54\162\x61\x66\146\151\x63\x46\x72\157\155\x43\x6c\x6f\165\x64\x66\x6c\x61\162\145\117\156\154\171" => true === $allowTrafficFromCloudflareOnly ? "\61" : "\60"]; goto Cd362; ae6d4: $siteEntity->setAllowTrafficFromCloudflareOnly($allowTrafficFromCloudflareOnly); goto e37b5; afbbe: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\x69\164\145\x5f\x73\145\143\x75\x72\x69\x74\x79", ["\x64\157\x6d\x61\x69\156\x4e\x61\x6d\x65" => $site->getDomainName()])); goto fda53; E744c: $session = $request->getSession(); goto d8dcb; daad2: B633a: goto Ce4b0; e37b5: $site->setAllowTrafficFromCloudflareOnly($allowTrafficFromCloudflareOnly); goto b4af4; a056c: goto d59c6; goto daad2; b4af4: $this->siteEntityManager->updateEntity($siteEntity); goto Cef1d; ef826: $siteUpdater->updateNginxVhost(); goto Ef5d1; Abdea: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\x67\x65\x72", $this->translator->trans("\x41\x6e\40\145\x72\162\157\x72\x20\150\x61\163\x20\157\143\143\165\162\162\145\x64\x2c\40\x65\x72\162\x6f\162\40\x6d\145\x73\x73\141\x67\145\72\x20\x25\x65\162\162\x6f\162\x4d\145\x73\x73\x61\147\145\x25", ["\45\x65\162\x72\157\x72\x4d\145\x73\163\141\x67\x65\x25" => $e->getMessage()])); } goto de48f; C0116: } public function newBlockedIp(Request $request) : Response { goto B3640; c1a08: if (!(true === $form->isSubmitted())) { goto d7b00; } goto ad73e; E7b69: $response = $this->render("\x46\162\x6f\156\164\x65\156\144\x2f\x53\151\164\145\57\156\x65\x77\55\x62\154\157\x63\153\145\x64\x2d\x69\160\56\150\x74\x6d\154\56\164\x77\x69\x67", ["\x73\x69\164\x65" => $site, "\146\x6f\x72\x6d" => $form->createView(), "\146\x6f\162\x6d\x45\x72\x72\157\162\x73" => $this->formErrors]); goto D4ebf; bb234: return $response; goto Dbd37; D4ebf: Bbe2d: goto bb234; c1f1d: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\163\x69\164\x65\x73")); goto F2721; f8c77: if (false === is_null($site)) { goto Aa3b6; } goto c1f1d; cd7fb: return $response; goto B6449; B6449: Bda5d: goto ec77e; f910e: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto eedf5; ce454: $form->handleRequest($request); goto c1a08; aa320: Aa3b6: goto f910e; ec77e: d7b00: goto b3584; b3584: d6a2d: goto E7b69; ad73e: $response = $this->handleBlockedIpForm($request, $form, $site); goto D78c2; eedf5: $blockedIpEntity = $this->blockedIpEntityManager->createEntity(); goto b4388; deff9: if (!(true === $request->isMethod("\x50\x4f\123\x54"))) { goto d6a2d; } goto ce454; F2721: goto Bbe2d; goto aa320; b4388: $blockedIpEntity->setSite($siteEntity); goto E01d3; B3640: $site = $this->getSite($request); goto f8c77; D78c2: if (!(false === is_null($response))) { goto Bda5d; } goto cd7fb; E01d3: $form = $this->createBlockedIpForm($blockedIpEntity); goto deff9; Dbd37: } private function createBlockedIpForm(BlockedIpEntity $blockedIpEntity) : Form { goto af07f; af07f: $siteEntity = $blockedIpEntity->getSite(); goto d86dc; cb7d6: return $form; goto Eceb4; F5ec0: $form->add("\163\x75\x62\x6d\x69\164", SubmitType::class, ["\x61\164\x74\x72" => ["\143\x6c\x61\x73\163" => "\142\x74\x6e\x20\142\x74\156\x2d\x62\154\165\x65\40\x62\164\x6e\x2d\x6c\x67"], "\154\x61\142\145\154" => "\x41\x64\x64\40\111\x50"]); goto cb7d6; d86dc: $form = $this->createForm("\x41\160\160\134\x46\x6f\162\x6d\134\x53\151\x74\145\x42\154\157\x63\153\x65\x64\111\120\x54\x79\160\x65", $blockedIpEntity, ["\141\143\x74\151\157\156" => $this->generateUrl("\x63\154\160\137\x73\x69\x74\145\137\x73\x65\x63\x75\x72\x69\x74\171\x5f\142\x6c\157\143\153\145\144\137\x69\x70\x5f\x6e\x65\167", ["\144\x6f\155\x61\151\156\x4e\x61\x6d\145" => $siteEntity->getDomainName()]), "\x6d\x65\164\150\x6f\144" => "\x50\117\123\124", "\141\164\x74\162" => []]); goto F5ec0; Eceb4: } private function handleBlockedIpForm(Request $request, Form $form, Site $site) { goto Ed0b1; fee22: try { goto Fcb04; Fcb04: $session = $request->getSession(); goto Dd949; Eac8e: $siteEntity->addBlockedIp($blockedIp); goto Ab014; e5cd6: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\151\164\145\x73")); goto B2867; Debb8: return $response; goto ec2f5; F4d08: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\163\x69\x74\145\x5f\163\x65\x63\165\x72\x69\164\x79", ["\x64\x6f\x6d\141\x69\156\116\141\155\x65" => $site->getDomainName()])); goto Db42c; d9c2f: $siteUpdater->reloadNginxService(); goto C0628; Db42c: E06db: goto Debb8; e1b1c: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_IP_ADD, $user, $eventData, $request); goto E1300; Ab014: $this->siteEntityManager->updateEntity($siteEntity); goto F5fcf; Bf020: d100b: goto c1f22; C0e77: if (false === is_null($siteEntity)) { goto d100b; } goto e5cd6; C0628: $eventData = ["\163\x69\x74\x65" => $domainName, "\x69\160" => $blockedIp->getIp()]; goto e1b1c; c68ef: $siteEntity = $this->getSiteEntity($domainName); goto C0e77; c1f22: $user = $this->getUser(); goto eca4e; B2867: goto E06db; goto Bf020; eca4e: $blockedIp = $form->getData(); goto Eac8e; F5fcf: $siteUpdater = $this->getSiteUpdater($site); goto c8f41; c8f41: $siteUpdater->updateNginxVhost(); goto d9c2f; E1300: $session->getFlashBag()->set("\x73\x75\x63\x63\145\x73\163", $this->translator->trans("\111\120\x20\150\x61\163\40\142\x65\x65\x6e\x20\x61\x64\x64\145\144\x2e")); goto F4d08; Dd949: $domainName = $site->getDomainName(); goto c68ef; ec2f5: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\x67\x65\162", $this->translator->trans("\x41\156\40\145\162\x72\157\162\x20\150\x61\163\x20\157\143\x63\x75\162\x72\145\x64\54\40\145\x72\162\157\x72\40\155\145\x73\163\141\147\x65\72\40\45\x65\x72\x72\157\x72\x4d\x65\x73\163\141\147\x65\45", ["\x25\x65\x72\x72\157\162\x4d\145\163\163\x61\147\145\45" => $e->getMessage()])); } goto fb723; e3446: B9f5e: goto fee22; e97a4: goto Dcba4; goto e3446; Cd001: $this->formErrors = $this->getErrorMessages($form); goto e97a4; fb723: Dcba4: goto fff81; Ed0b1: if (true === $form->isValid()) { goto B9f5e; } goto Cd001; fff81: } public function deleteBlockedIp(Request $request) : Response { goto a705b; e44db: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x73\x69\x74\145\163")); goto fb3b1; f1edf: C07d9: goto e44db; ee480: if (!(false === is_null($site))) { goto C07d9; } goto b8ef4; fb3b1: return $response; goto a8b1a; b8ef4: try { goto Fd9e9; df373: $siteUpdater->reloadNginxService(); goto Ac49f; C732e: $siteEntity = $this->getSiteEntity($domainName); goto Ac67d; e7eca: $domainName = $site->getDomainName(); goto C732e; C483e: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_IP_DELETE, $user, $eventData, $request); goto f28d6; Fd9e9: $session = $request->getSession(); goto Adc4b; Ac49f: $eventData = ["\x73\x69\164\145" => $domainName, "\x69\x70" => $blockedIpEntity->getIp()]; goto C483e; c9ce0: $siteEntity->removeBlockedIp($blockedIpEntity); goto F5b06; Ca314: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x73\151\164\145\x5f\163\145\x63\x75\x72\x69\x74\x79", ["\x64\x6f\155\141\151\156\116\141\155\145" => $site->getDomainName()])); goto Ecd55; B2fe0: if (!(false === is_null($siteEntity) && false === empty($id) && false === is_null($blockedIpEntity) && $siteEntity == $blockedIpEntity->getSite())) { goto ead05; } goto Ee949; Adc4b: $id = (int) $request->get("\151\144"); goto e7eca; a16fd: $siteUpdater->updateNginxVhost(); goto df373; Ecd55: return $response; goto a7a17; a7a17: ead05: goto B1396; Ac67d: $blockedIpEntity = $this->blockedIpEntityManager->findOneById($id); goto B2fe0; Ee949: $user = $this->getUser(); goto c9ce0; F5b06: $this->siteEntityManager->updateEntity($siteEntity); goto F7f35; F7f35: $siteUpdater = $this->getSiteUpdater($site); goto a16fd; f28d6: $session->getFlashBag()->set("\163\x75\x63\x63\x65\163\163", $this->translator->trans("\x49\120\x20\150\x61\x73\40\x62\145\x65\156\x20\144\x65\154\x65\x74\x65\144\56")); goto Ca314; B1396: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\x65\x72", $this->translator->trans("\x41\x6e\x20\145\x72\x72\x6f\162\x20\x68\141\163\40\157\x63\143\165\162\162\x65\x64\54\40\x65\162\162\157\x72\x20\155\145\x73\x73\141\147\x65\72\x20\x25\145\x72\162\157\162\x4d\x65\163\163\x61\147\145\45", ["\45\145\x72\x72\157\162\x4d\145\x73\163\141\147\x65\x25" => $e->getMessage()])); } goto f1edf; a705b: $site = $this->getSite($request); goto ee480; a8b1a: } public function newBlockedBot(Request $request) : Response { goto aed58; b57b3: $form->handleRequest($request); goto Bd73d; f89f4: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto bead4; bead4: $blockedBotEntity = $this->blockedBotEntityManager->createEntity(); goto Fbd9c; Dde9e: if (!(false === is_null($response))) { goto Beec5; } goto B46be; Fbd9c: $blockedBotEntity->setSite($siteEntity); goto E4821; a33e4: C5ff6: goto F41da; fabfd: if (false === is_null($site)) { goto D3a70; } goto dd05b; b10e3: return $response; goto f507e; Bd73d: if (!(true === $form->isSubmitted())) { goto C5ff6; } goto F4f62; aed58: $site = $this->getSite($request); goto fabfd; f4602: $response = $this->render("\106\x72\157\x6e\x74\x65\x6e\x64\x2f\x53\151\164\145\x2f\156\145\167\55\142\x6c\x6f\143\x6b\x65\144\55\142\x6f\x74\56\150\164\155\154\56\x74\167\151\x67", ["\163\151\164\x65" => $site, "\146\157\x72\155" => $form->createView(), "\x66\x6f\162\155\x45\x72\162\157\x72\163" => $this->formErrors]); goto fe65f; fe65f: e5d7b: goto b10e3; F41da: de81b: goto f4602; F759b: goto e5d7b; goto A5279; F4f62: $response = $this->handleBlockedBotForm($request, $form, $site); goto Dde9e; A5279: D3a70: goto f89f4; a361b: Beec5: goto a33e4; D31ae: if (!(true === $request->isMethod("\x50\x4f\123\x54"))) { goto de81b; } goto b57b3; dd05b: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\x69\x74\x65\163")); goto F759b; B46be: return $response; goto a361b; E4821: $form = $this->createBlockedBotForm($blockedBotEntity); goto D31ae; f507e: } private function createBlockedBotForm(BlockedBotEntity $blockedBotEntity) : Form { goto E6df0; E6df0: $siteEntity = $blockedBotEntity->getSite(); goto C205e; E8b73: return $form; goto F3e76; C205e: $form = $this->createForm("\x41\x70\160\134\x46\157\x72\x6d\x5c\x53\151\164\x65\x42\x6c\157\x63\153\145\x64\x42\157\x74\x54\171\160\145", $blockedBotEntity, ["\141\143\x74\x69\x6f\x6e" => $this->generateUrl("\143\154\160\137\163\x69\x74\145\137\x73\x65\x63\x75\162\151\x74\171\137\x62\x6c\x6f\143\153\145\x64\x5f\x62\x6f\164\x5f\x6e\145\167", ["\144\x6f\155\x61\x69\x6e\116\141\x6d\x65" => $siteEntity->getDomainName()]), "\x6d\145\164\150\x6f\x64" => "\120\117\123\x54", "\x61\164\164\162" => []]); goto A354f; A354f: $form->add("\163\165\142\155\151\x74", SubmitType::class, ["\x61\x74\x74\x72" => ["\x63\154\x61\163\163" => "\x62\164\156\x20\x62\x74\x6e\x2d\142\x6c\x75\x65\x20\142\164\156\55\154\x67"], "\x6c\141\x62\145\154" => "\x41\144\x64\x20\x42\x6f\164"]); goto E8b73; F3e76: } private function handleBlockedBotForm(Request $request, Form $form, Site $site) { goto a5404; a5404: if (true === $form->isValid()) { goto e364a; } goto Ea63e; F7d4c: try { goto Abdca; Fbfde: if (false === is_null($siteEntity)) { goto F0f33; } goto Cc34a; cede4: $eventData = ["\x73\151\x74\145" => $domainName, "\x6e\x61\x6d\x65" => $blockedBot->getName()]; goto e9fe3; Cc34a: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\x69\164\145\x73")); goto Ff41a; e9fe3: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_BOT_ADD, $user, $eventData, $request); goto b8866; A27e9: $siteUpdater->reloadNginxService(); goto cede4; A5243: $blockedBot = $form->getData(); goto a7251; F2209: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\151\164\145\137\x73\x65\143\x75\162\x69\164\x79", ["\144\157\x6d\x61\151\156\116\x61\x6d\x65" => $site->getDomainName()])); goto Efe51; Abdca: $session = $request->getSession(); goto cfb55; eca71: $this->siteEntityManager->updateEntity($siteEntity); goto Ecdbe; b8866: $session->getFlashBag()->set("\x73\165\143\143\145\163\x73", $this->translator->trans("\x42\x6f\x74\x20\150\141\x73\40\142\145\x65\156\x20\x61\x64\144\145\x64\x2e")); goto F2209; Ff41a: goto Fcf62; goto Cfb8d; daae6: return $response; goto dd4dd; Ecdbe: $siteUpdater = $this->getSiteUpdater($site); goto C8f88; Efe51: Fcf62: goto daae6; e0328: $siteEntity = $this->getSiteEntity($domainName); goto Fbfde; Ccc9d: $user = $this->getUser(); goto A5243; cfb55: $domainName = $site->getDomainName(); goto e0328; Cfb8d: F0f33: goto Ccc9d; C8f88: $siteUpdater->updateNginxVhost(); goto A27e9; a7251: $siteEntity->addBlockedBot($blockedBot); goto eca71; dd4dd: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\x72", $this->translator->trans("\101\x6e\x20\145\x72\x72\x6f\x72\40\150\x61\x73\x20\x6f\x63\x63\x75\x72\x72\x65\144\x2c\x20\x65\x72\x72\157\162\40\155\x65\x73\163\141\x67\145\x3a\x20\45\x65\x72\162\157\162\x4d\145\163\163\141\147\145\45", ["\x25\x65\162\x72\x6f\x72\115\145\x73\163\x61\x67\x65\45" => $e->getMessage()])); } goto d68e2; f95ff: goto Dad91; goto Ba7be; Ea63e: $this->formErrors = $this->getErrorMessages($form); goto f95ff; d68e2: Dad91: goto Ce21b; Ba7be: e364a: goto F7d4c; Ce21b: } public function deleteBlockedBot(Request $request) : Response { goto ec7cc; Acb16: try { goto Eaef3; e65b0: $user = $this->getUser(); goto B878e; ecfad: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_BOT_DELETE, $user, $eventData, $request); goto b2d84; Dd2c2: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\151\164\x65\137\163\x65\x63\165\x72\x69\x74\171", ["\x64\157\x6d\x61\x69\x6e\x4e\141\155\x65" => $site->getDomainName()])); goto a34f9; F3a72: $id = (int) $request->get("\151\144"); goto d924c; b2d84: $session->getFlashBag()->set("\163\x75\143\143\x65\163\x73", $this->translator->trans("\102\157\x74\x20\x68\x61\x73\x20\142\x65\x65\x6e\x20\144\x65\154\x65\x74\x65\x64\x2e")); goto Dd2c2; Deaee: $siteUpdater->updateNginxVhost(); goto e855f; E3334: $this->siteEntityManager->updateEntity($siteEntity); goto c0d97; d924c: $domainName = $site->getDomainName(); goto e07dd; e855f: $siteUpdater->reloadNginxService(); goto E3026; Eaef3: $session = $request->getSession(); goto F3a72; c2486: if (!(false === is_null($siteEntity) && false === empty($id) && false === is_null($blockedBotEntity) && $siteEntity == $blockedBotEntity->getSite())) { goto F5d6a; } goto e65b0; c0d97: $siteUpdater = $this->getSiteUpdater($site); goto Deaee; Eb47b: $blockedBotEntity = $this->blockedBotEntityManager->findOneById($id); goto c2486; a34f9: return $response; goto ecf3a; e07dd: $siteEntity = $this->getSiteEntity($domainName); goto Eb47b; E3026: $eventData = ["\x73\151\x74\x65" => $domainName, "\156\141\x6d\145" => $blockedBotEntity->getName()]; goto ecfad; B878e: $siteEntity->removeBlockedBot($blockedBotEntity); goto E3334; ecf3a: F5d6a: goto aac0b; aac0b: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\x65\162", $this->translator->trans("\101\156\40\145\x72\x72\157\162\40\x68\x61\163\x20\157\143\143\x75\x72\x72\x65\144\54\40\145\x72\x72\157\x72\x20\155\145\163\163\141\x67\145\x3a\40\45\x65\162\162\x6f\x72\x4d\145\163\x73\x61\x67\145\45", ["\x25\145\162\x72\x6f\162\115\145\163\x73\141\x67\145\x25" => $e->getMessage()])); } goto dffa1; f5229: if (!(false === is_null($site))) { goto Acd81; } goto Acb16; Bf260: return $response; goto B9480; dffa1: Acd81: goto cbe36; ec7cc: $site = $this->getSite($request); goto f5229; cbe36: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\x69\164\145\x73")); goto Bf260; B9480: } public function certificates(Request $request) : Response { goto e8e46; D5b5e: $certificates = $site->getCertificates(); goto E3b3a; A9abe: if (false === is_null($site)) { goto A6a9f; } goto db17c; D88e8: A6a9f: goto E398f; db17c: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\151\x74\145\163")); goto B446f; Aa9e4: return $response; goto e29fc; E398f: $installedCertificate = $site->getCertificate(); goto D5b5e; F22ad: D8a21: goto Aa9e4; E3b3a: $response = $this->render("\x46\x72\157\x6e\164\145\156\144\57\x53\151\x74\x65\57\x63\x65\x72\x74\151\146\151\143\141\x74\x65\163\56\x68\164\x6d\x6c\x2e\164\167\151\147", ["\x73\151\164\x65" => $site, "\x69\x6e\x73\x74\141\x6c\154\x65\144\x43\x65\x72\x74\x69\x66\x69\143\141\x74\145" => $installedCertificate, "\143\x65\x72\x74\151\146\x69\x63\x61\x74\145\x73" => $certificates]); goto F22ad; B446f: goto D8a21; goto D88e8; e8e46: $site = $this->getSite($request); goto A9abe; e29fc: } public function importCertificate(Request $request) : Response { goto abeb6; b140a: $form = $this->createImportCertificateForm($certificateEntity); goto Efc15; Efc15: if (!(true === $request->isMethod("\x50\117\123\x54"))) { goto a4458; } goto ec735; Fd686: D9ed2: goto cb9db; a1d95: $certificateEntity = $this->certificateEntityManager->createEntity(); goto fcaeb; F8ff0: B2886: goto e7eed; f6444: $response = $this->handleImportCertificateForm($request, $form, $site); goto Fb24b; Fb24b: if (!(false === is_null($response))) { goto f3238; } goto B342c; f8f58: if (!(true === $form->isSubmitted())) { goto F13c9; } goto f6444; B342c: return $response; goto Bbe27; f2595: F13c9: goto Ef986; D3b0b: $response = $this->render("\x46\x72\157\x6e\164\x65\x6e\x64\57\x53\151\x74\x65\57\x69\x6d\x70\157\162\x74\55\x63\x65\x72\x74\151\x66\x69\143\141\164\x65\x2e\150\164\155\154\x2e\x74\167\151\147", ["\163\151\164\145" => $site, "\146\157\x72\x6d" => $form->createView(), "\x66\x6f\162\155\105\162\x72\x6f\x72\x73" => $this->formErrors]); goto F8ff0; F38b1: $certificateEntity->setSite($siteEntity); goto b140a; ec735: $form->handleRequest($request); goto f8f58; A78f4: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\x69\x74\x65\163")); goto d7fe0; Bbe27: f3238: goto f2595; D4ccc: if (false === is_null($site)) { goto D9ed2; } goto A78f4; d7fe0: goto B2886; goto Fd686; cb9db: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto a1d95; Ef986: a4458: goto D3b0b; abeb6: $site = $this->getSite($request); goto D4ccc; e7eed: return $response; goto bb38b; fcaeb: $certificateEntity->setType(CertificateEntity::TYPE_IMPORTED); goto F38b1; bb38b: } private function createImportCertificateForm(CertificateEntity $certificateEntity) : Form { goto B907d; b39d9: return $form; goto c2850; B907d: $siteEntity = $certificateEntity->getSite(); goto e9f88; d2d4c: $form->add("\x73\x75\x62\x6d\151\164", SubmitType::class, ["\x61\x74\x74\x72" => ["\x63\154\141\x73\x73" => "\x62\x74\156\40\x62\x74\x6e\x2d\142\154\165\145\x20\142\164\156\x2d\154\147"], "\x6c\141\x62\145\154" => "\x49\x6d\x70\x6f\x72\x74\x20\x61\x6e\144\x20\111\x6e\163\164\141\154\x6c"]); goto b39d9; e9f88: $form = $this->createForm("\x41\x70\x70\x5c\106\157\x72\155\134\x53\x69\x74\x65\111\x6d\x70\157\162\164\103\145\x72\x74\151\x66\151\x63\x61\164\x65\124\x79\160\x65", $certificateEntity, ["\x61\x63\x74\x69\157\156" => $this->generateUrl("\143\x6c\160\x5f\x73\151\x74\x65\x5f\x63\x65\x72\x74\x69\x66\x69\x63\x61\164\145\137\x69\x6d\160\157\162\x74", ["\144\x6f\155\141\x69\x6e\x4e\x61\x6d\x65" => $siteEntity->getDomainName()]), "\155\145\164\x68\x6f\144" => "\120\117\x53\124", "\141\164\x74\x72" => []]); goto d2d4c; c2850: } private function handleImportCertificateForm(Request $request, Form $form, Site $site) { goto B9fcb; dbadc: goto ab1b4; goto F726a; Da217: $this->formErrors = $this->getErrorMessages($form); goto dbadc; C0c8d: ab1b4: goto c0747; F726a: fe10b: goto Be0f6; Be0f6: try { goto b8efb; E2bd6: return $response; goto F3ff9; c49a3: $siteEntity->setCertificate($certificateEntity); goto b6010; e4676: be558: goto E2bd6; b8efb: $session = $request->getSession(); goto a089d; Ae35e: $user = $this->getUser(); goto b2073; b2073: $certificateEntity = $form->getData(); goto ad6c7; Bd445: goto be558; goto D0783; E08b5: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\x73\x69\x74\145\163")); goto Bd445; A4c28: $siteUpdater->installCertificate($certificateEntity); goto c49a3; ad6c7: $siteUpdater = $this->getSiteUpdater($site); goto A4c28; Eba22: $evenData = ["\x73\151\164\145" => $domainName]; goto D4169; D4169: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto C1bd0; Bcb6c: if (false === is_null($siteEntity)) { goto E3444; } goto E08b5; b6010: $siteEntity->addCertificate($certificateEntity); goto e15af; D0783: E3444: goto Ae35e; E10c3: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\151\164\x65\x5f\x63\x65\162\x74\x69\146\151\x63\141\x74\x65\x73", ["\144\157\155\x61\151\156\116\141\x6d\145" => $site->getDomainName()])); goto e4676; C8450: $siteEntity = $this->getSiteEntity($domainName); goto Bcb6c; a089d: $domainName = $site->getDomainName(); goto C8450; C1bd0: $session->getFlashBag()->set("\x73\165\143\x63\x65\163\163", $this->translator->trans("\103\x65\x72\164\151\x66\151\143\141\164\145\40\x68\x61\163\40\x62\145\145\156\x20\151\x6e\x73\164\141\154\154\x65\x64\x2e")); goto E10c3; e15af: $this->siteEntityManager->updateEntity($siteEntity); goto Eba22; F3ff9: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\x67\145\162", $this->translator->trans("\101\x6e\x20\145\x72\162\157\162\40\x68\141\x73\40\157\x63\x63\165\x72\162\145\x64\54\40\x65\162\162\157\162\x20\155\145\163\163\x61\147\145\72\x20\x25\x65\x72\162\x6f\x72\115\145\x73\163\141\x67\x65\45", ["\x25\x65\162\x72\x6f\x72\115\x65\x73\163\x61\x67\x65\x25" => $e->getMessage()])); } goto C0c8d; B9fcb: if (true === $form->isValid()) { goto fe10b; } goto Da217; c0747: } public function newLetsEncryptCertificate(Request $request) : Response { goto bf758; a9d3b: D003c: goto Cc710; f3d62: $domains = array_filter($domains, function ($value) { return false === empty(trim($value)); }); goto cff2c; F1789: $domains = []; goto Df048; Dae56: goto a5451; goto a9d3b; A0002: a5451: goto f4070; cff2c: $domains = array_map("\164\x72\x69\155", $domains); goto df45e; f9257: $domains = (array) $request->get("\x64\x6f\x6d\x61\x69\156\163"); goto f3d62; b7cb5: goto Cd1a5; goto D743d; e2a7d: $subdomain = false === empty($subdomain) ? $subdomain : null; goto A0dc4; c4e33: return $response; goto ccc30; Cef18: $domains = [$domainName]; goto b7cb5; fa3a0: if (!(false === is_null($response))) { goto C7ff8; } goto eef9b; a8fc5: $form = $this->createLetsEncryptCertificateForm($domainName); goto F1789; a2d93: if (false === is_null($site)) { goto C1bdc; } goto ec7e0; E2d4f: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto c6e6d; B5f96: $domains = [$registrableDomain, sprintf("\x77\x77\x77\x2e\x25\163", $registrableDomain)]; goto Bd973; Ff760: e9052: goto c4e33; Df048: if (true === $request->isMethod("\x50\117\123\x54")) { goto D003c; } goto F6317; Cc710: $form->handleRequest($request); goto Ac072; Bd973: Cd1a5: goto Dae56; Ea6be: goto e9052; goto C70e9; f4070: $response = $this->render("\106\x72\x6f\x6e\x74\145\x6e\144\57\x53\151\164\145\x2f\x6e\145\x77\55\154\x65\164\x73\55\x65\156\x63\x72\171\x70\164\x2d\x63\145\x72\164\x69\x66\x69\143\141\164\x65\56\150\x74\155\154\x2e\164\x77\x69\147", ["\163\151\164\x65" => $site, "\144\x6f\x6d\141\151\x6e\163" => $domains, "\146\x6f\162\x6d" => $form->createView(), "\146\x6f\162\x6d\105\162\x72\157\x72\x73" => $this->formErrors]); goto Ff760; e63eb: $response = $this->handleLetsEncryptCertificateForm($request, $form, $site, $domains); goto fa3a0; df45e: $domains = array_unique($domains); goto e63eb; c748a: $domainName = $site->getDomainName(); goto a8fc5; c7459: A1fc8: goto A0002; Ac072: if (!(true === $form->isSubmitted())) { goto A1fc8; } goto f9257; F6317: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto E2d4f; A0dc4: if (true === is_null($subdomain) || "\167\167\167" == $subdomain) { goto E4fca; } goto Cef18; ec7e0: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\151\164\145\x73")); goto Ea6be; C70e9: C1bdc: goto c748a; eef9b: return $response; goto f06e1; c6e6d: $subdomain = $resolvedDomainName->subDomain()->toString(); goto e2a7d; D743d: E4fca: goto B5f96; bf758: $site = $this->getSite($request); goto a2d93; f06e1: C7ff8: goto c7459; ccc30: } private function createLetsEncryptCertificateForm(string $domainName) : Form { goto Aef7b; F9e11: return $form; goto e4176; B0d76: $form->add("\x73\x75\142\x6d\x69\x74", SubmitType::class, ["\x61\164\164\x72" => ["\143\x6c\141\163\163" => "\142\x74\156\40\x62\x74\156\55\x62\154\165\x65\40\142\x74\x6e\55\154\x67"], "\x6c\141\x62\145\x6c" => "\x43\x72\145\x61\164\145\x20\141\156\x64\40\111\x6e\x73\x74\141\x6c\154"]); goto F9e11; Aef7b: $form = $this->createForm("\101\160\160\x5c\x46\157\162\155\134\123\151\x74\x65\114\145\164\163\105\156\x63\162\x79\160\x74\x43\145\162\x74\x69\x66\151\143\x61\164\145\x54\x79\x70\145", [], ["\x61\143\x74\x69\157\x6e" => $this->generateUrl("\x63\x6c\160\137\x73\151\x74\x65\137\154\145\x74\x73\x5f\145\x6e\143\x72\171\x70\x74\x5f\143\x65\162\164\151\146\x69\x63\141\164\145\137\x6e\145\x77", ["\144\x6f\x6d\141\x69\156\116\141\155\x65" => $domainName]), "\155\x65\x74\150\157\x64" => "\120\x4f\123\x54", "\141\x74\164\x72" => ["\151\x64" => "\x63\x72\145\141\x74\145\55\x6c\x65\x74\x73\x2d\x65\156\143\x72\171\x70\164\x2d\x63\x65\162\164\x69\146\151\x63\141\x74\x65\x2d\146\157\x72\x6d"]]); goto B0d76; e4176: } private function handleLetsEncryptCertificateForm(Request $request, Form $form, Site $site, array $domains) { goto f837d; Bd9fc: $this->formErrors = $this->getErrorMessages($form); goto e1533; b0585: d7da9: goto Bd9fc; f837d: if (!(true === $form->isValid())) { goto d7da9; } goto F4a14; F4a14: try { goto Faa35; b9ebf: Fc636: goto ea874; F0cda: $domainName = $site->getDomainName(); goto c5f9d; E014e: $certificateEntity->setCertificate($certificate->getCertificate()); goto B0392; Ba521: Dab55: goto Ab7d4; eec29: $session->getFlashBag()->set("\163\x75\x63\x63\145\163\163", $this->translator->trans("\103\x65\162\164\151\146\x69\x63\x61\164\145\40\x68\141\x73\40\x62\145\x65\156\x20\x69\x6e\163\x74\141\154\154\x65\144\56")); goto B25b1; Ab7d4: E4799: goto b5fcb; c18f4: $certificateEntity = $this->certificateEntityManager->createEntity(); goto C1b7b; af83c: $certificateEntity->setPrivateKey($certificate->getPrivateKey()); goto E014e; D01b2: $this->siteEntityManager->updateEntity($siteEntity); goto E65f3; E65f3: $evenData = ["\163\151\x74\x65" => $domainName]; goto E7a9f; Fc868: $certificate = $letsEncryptClient->finalizeOrder($certificateOrder, $privateKey, $csr); goto c18f4; F1c7f: $distinguishedNameDomains = $domains; goto A5f74; a1532: $letsEncryptClient = new LetsEncryptClient($privateKey); goto D2469; Cff93: $csr = $csrGenerator->generate(); goto Fc868; Bbdc6: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto bc890; C7777: foreach ($validationErrors as $domain => $validationErrorMessage) { $form->addError(new FormError(sprintf("\45\163\x3a\40\x25\163", $domain, $validationErrorMessage))); d0a2b: } goto b9ebf; A4601: $letsEncryptPrivateKey = $this->configManager->get("\154\145\x5f\x70\x72\x69\166\x61\164\x65\x5f\x6b\145\x79"); goto Fe4b9; eeed6: d548c: goto Ca0f6; bc1e6: $siteUpdater = $this->getSiteUpdater($site); goto b6f8d; Faa35: $session = $request->getSession(); goto F0cda; Cc29b: $certificateEntity->setCsr($certificate->getCsr()); goto af83c; bc890: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto Cff93; De5cd: return $response; goto Ba521; Bbd1b: $validationErrors = $letsEncryptClient->validateDomains($certificateOrder); goto D99be; E850c: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\x69\x74\145\163")); goto Bb05b; ebee1: if (false === is_null($siteEntity)) { goto d548c; } goto E850c; C1b7b: $certificateEntity->setType(CertificateEntity::TYPE_LETS_ENCRYPT); goto ae1eb; A5f74: $commonName = array_shift($distinguishedNameDomains); goto a018c; ae1eb: $certificateEntity->setSite($siteEntity); goto Cc29b; Dfc89: goto E4799; goto eeed6; Ca0f6: $user = $this->getUser(); goto A4601; ea874: goto Dab55; goto F0e57; c5f9d: $siteEntity = $this->getSiteEntity($domainName); goto ebee1; b11c6: $siteEntity->setCertificate($certificateEntity); goto Ad418; D99be: if (true === empty($validationErrors)) { goto b7661; } goto C7777; B25b1: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x73\x69\164\x65\x5f\143\145\x72\164\151\x66\x69\143\x61\x74\x65\x73", ["\x64\x6f\155\x61\x69\x6e\x4e\141\155\x65" => $site->getDomainName()])); goto De5cd; E3479: $siteUpdater = $this->getSiteUpdater($site); goto b955c; b955c: $siteUpdater->installCertificate($certificateEntity); goto b11c6; Bb05b: return $response; goto Dfc89; F0e57: b7661: goto F1c7f; Fe4b9: $privateKey = new PrivateKey($letsEncryptPrivateKey); goto a1532; e9913: $rsaKeyGenerator = new RsaKeyGenerator(); goto Bbdc6; f83c6: $certificateOrder = $letsEncryptClient->requestOrder($domains); goto bc1e6; a018c: $distinguishedName = new DistinguishedName($commonName, $distinguishedNameDomains); goto e9913; b6f8d: $siteUpdater->deleteLetsEncryptChallengeDirectory(); goto Dfd51; Dfd51: $siteUpdater->createLetsEncryptChallengeFiles($certificateOrder); goto Bbd1b; E7a9f: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto eec29; B0392: $certificateEntity->setCertificateChain($certificate->getCertificateChain()); goto E3479; D2469: $letsEncryptClient->registerAccount(); goto f83c6; Ad418: $siteEntity->addCertificate($certificateEntity); goto D01b2; b5fcb: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\x65\x72", $this->translator->trans("\x41\x6e\40\x65\162\162\x6f\x72\40\x68\141\163\40\x6f\x63\143\165\x72\162\145\x64\x2c\x20\x65\162\x72\x6f\162\x20\x6d\145\163\x73\141\147\x65\x3a\x20\45\x65\162\162\157\x72\115\145\163\x73\141\x67\x65\45", ["\45\x65\x72\x72\157\x72\115\145\x73\163\x61\147\x65\45" => $e->getMessage()])); } finally { if (!(true === isset($siteUpdater))) { goto ff0f1; } $siteUpdater->deleteLetsEncryptChallengeDirectory(); ff0f1: } goto b0585; e1533: } public function installCertificate(Request $request) : Response { goto Ec520; Dc219: return $response; goto B86c2; Ec520: $site = $this->getSite($request); goto cf0a4; cf0a4: if (!(false === is_null($site))) { goto D62c7; } goto E96ce; c8883: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\151\x74\x65\x73")); goto Dc219; E96ce: try { goto b0a24; C51e8: if (!(false === is_null($siteEntity) && false === empty($uid) && false === is_null($certificateEntity))) { goto e0fe7; } goto D6c9f; cd97b: $user = $this->getUser(); goto Bf880; A5a1a: $session->getFlashBag()->set("\163\165\x63\143\x65\x73\163", $this->translator->trans("\x43\145\x72\164\x69\x66\x69\x63\x61\164\145\40\x68\x61\x73\40\x62\x65\x65\x6e\x20\151\156\x73\164\x61\154\x6c\x65\144\56")); goto C86f9; Bf880: $siteUpdater = $this->getSiteUpdater($site); goto fbfd3; C86f9: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\163\151\x74\x65\137\x63\145\162\x74\x69\x66\x69\143\x61\164\145\x73", ["\x64\157\x6d\x61\x69\x6e\x4e\x61\x6d\145" => $site->getDomainName()])); goto B8117; fbfd3: $siteUpdater->installCertificate($certificateEntity); goto dce0b; e2a3e: f1ee5: goto ea123; fec8f: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto A5a1a; dcd12: $evenData = ["\x73\151\x74\145" => $domainName]; goto fec8f; de79e: $this->siteEntityManager->updateEntity($siteEntity); goto dcd12; Eac8c: $certificateEntity = $this->certificateEntityManager->findOneByUid($uid); goto C51e8; B8117: return $response; goto e2a3e; D6c9f: $certificateSiteEntity = $certificateEntity->getSite(); goto C6979; b0a24: $session = $request->getSession(); goto Bf4ec; da265: $domainName = $site->getDomainName(); goto A4d8b; dce0b: $siteEntity->setCertificate($certificateEntity); goto de79e; C6979: if (!($siteEntity->getDomainName() == $certificateSiteEntity->getDomainName() && $siteEntity->getCertificate() != $certificateSiteEntity)) { goto f1ee5; } goto cd97b; ea123: e0fe7: goto Bcb05; Bf4ec: $uid = $request->get("\x75\151\144"); goto da265; A4d8b: $siteEntity = $this->getSiteEntity($domainName); goto Eac8c; Bcb05: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\x67\145\x72", $this->translator->trans("\101\x6e\40\145\162\162\x6f\x72\40\x68\141\163\40\157\143\143\x75\x72\162\145\144\54\x20\145\x72\x72\157\162\40\155\145\163\x73\141\147\x65\x3a\x20\45\x65\162\x72\x6f\162\115\x65\163\163\x61\x67\145\x25", ["\x25\145\162\x72\x6f\162\x4d\x65\x73\163\141\x67\145\x25" => $e->getMessage()])); } goto c39f5; c39f5: D62c7: goto c8883; B86c2: } public function deleteCertificate(Request $request) : Response { goto A8f8b; fbda2: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\x69\164\x65\163")); goto F60b8; A8f8b: $site = $this->getSite($request); goto Bdda9; F60b8: return $response; goto cc3c1; d73c3: try { goto F8155; dde74: $certificateSiteEntity = $certificateEntity->getSite(); goto b6ba6; ca245: $certificateEntity = $this->certificateEntityManager->findOneByUid($uid); goto e6bb2; e7043: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_DELETE, $user, $evenData, $request); goto A9d7c; A9d7c: $session->getFlashBag()->set("\163\165\143\143\x65\x73\x73", $this->translator->trans("\103\145\162\x74\x69\146\x69\x63\141\x74\x65\x20\x68\x61\163\40\x62\145\x65\x6e\40\144\145\154\145\164\145\144\x2e")); goto D7f3b; C19fb: $evenData = ["\163\151\164\x65" => $domainName]; goto e7043; e6892: $uid = $request->get("\x75\151\144"); goto Ed202; e6bb2: if (!(false === is_null($siteEntity) && false === empty($uid) && false === is_null($certificateEntity) && false === $certificateEntity->getDefaultCertificate())) { goto Bf8f2; } goto dde74; e0c6e: $siteEntity->removeCertificate($certificateEntity); goto C4f29; a9bb5: C617c: goto eb646; D7f3b: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\x65\x5f\x63\145\162\x74\x69\146\151\143\141\164\145\x73", ["\144\157\155\x61\151\156\116\141\x6d\x65" => $site->getDomainName()])); goto B310c; E5366: $siteEntity = $this->getSiteEntity($domainName); goto ca245; C4f29: $this->siteEntityManager->updateEntity($siteEntity); goto C19fb; b6ba6: if (!($siteEntity->getDomainName() == $certificateSiteEntity->getDomainName() && $siteEntity->getCertificate() != $certificateSiteEntity)) { goto C617c; } goto a2725; a2725: $user = $this->getUser(); goto e0c6e; B310c: return $response; goto a9bb5; eb646: Bf8f2: goto e1ff8; Ed202: $domainName = $site->getDomainName(); goto E5366; F8155: $session = $request->getSession(); goto e6892; e1ff8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\x65\x72", $this->translator->trans("\x41\156\x20\145\x72\x72\x6f\162\x20\x68\x61\163\x20\157\x63\143\x75\162\x72\x65\x64\54\x20\145\162\x72\157\162\x20\x6d\145\163\x73\141\x67\x65\x3a\x20\x25\x65\x72\162\157\162\x4d\145\x73\x73\x61\x67\145\x25", ["\x25\145\162\x72\157\x72\115\x65\x73\x73\x61\x67\145\x25" => $e->getMessage()])); } goto Eb5d8; Bdda9: if (!(false === is_null($site))) { goto Cc5d1; } goto d73c3; Eb5d8: Cc5d1: goto fbda2; cc3c1: } public function databases(Request $request) : Response { goto db0b0; D918d: goto Ce235; goto D64ac; D64ac: Ac424: goto F0b66; dd3ad: $response = $this->redirect($this->generateUrl("\x63\154\160\137\x73\151\x74\x65\163")); goto D918d; C7f75: $databaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto D38e7; D38e7: $numberOfDatabaseUsers = 0; goto Ec85a; b5673: if (false === is_null($site)) { goto Ac424; } goto dd3ad; Ad12b: return $response; goto E4a4d; F0b66: $databases = $site->getDatabases(); goto C7f75; Ec85a: foreach ($databases as $database) { $numberOfDatabaseUsers += count($database->getUsers()); C209d: } goto a615d; a615d: F3db6: goto D6925; D6925: $response = $this->render("\x46\x72\x6f\156\164\145\x6e\x64\x2f\x53\x69\x74\145\57\x64\x61\x74\x61\142\141\x73\x65\163\x2e\x68\164\x6d\154\56\164\x77\151\147", ["\163\x69\x74\x65" => $site, "\x64\x61\x74\x61\x62\141\163\145\163" => $databases, "\156\165\x6d\142\x65\x72\x4f\146\104\x61\164\x61\x62\x61\x73\x65\x55\163\145\162\163" => $numberOfDatabaseUsers, "\144\141\x74\x61\x62\141\x73\x65\x53\145\162\166\145\162" => $databaseServerEntity]); goto Bd37c; db0b0: $site = $this->getSite($request); goto b5673; Bd37c: Ce235: goto Ad12b; E4a4d: } public function newDatabase(Request $request) : Response { goto Bf9e3; E54a0: return $response; goto Ff472; af3b7: if (!(true === $request->isMethod("\x50\x4f\x53\x54"))) { goto A73a7; } goto fa53c; ab880: $response = $this->handleDatabaseForm($request, $form, $site); goto C9b0a; db0e3: A3563: goto d3b3e; dd027: if (!(true === $form->isSubmitted())) { goto B7999; } goto ab880; C9b0a: if (!(false === is_null($response))) { goto d14a2; } goto E54a0; dbc48: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\163\x69\x74\x65\163")); goto baa56; Ff472: d14a2: goto B2e08; F9d61: $databaseEntity->setSite($siteEntity); goto Cb5e0; Af2b8: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto b2d0d; c9a38: $response = $this->render("\x46\x72\157\x6e\164\145\156\144\x2f\123\x69\x74\x65\57\156\145\167\55\x64\x61\x74\141\142\x61\163\145\56\x68\164\155\154\56\164\167\151\147", ["\163\151\x74\x65" => $site, "\146\157\x72\155" => $form->createView(), "\x66\x6f\162\155\105\162\x72\x6f\x72\x73" => $this->formErrors]); goto db0e3; baa56: goto A3563; goto Bf493; Bf9e3: $site = $this->getSite($request); goto dac23; B2e08: B7999: goto Ae415; Bf493: Ca936: goto Af2b8; d3b3e: return $response; goto C8b74; Ae415: A73a7: goto c9a38; Cb5e0: $form = $this->createDatabaseForm($site, $databaseEntity); goto af3b7; b2d0d: $databaseEntity = $this->databaseEntityManager->createEntity(); goto F9d61; dac23: if (false === is_null($site)) { goto Ca936; } goto dbc48; fa53c: $form->handleRequest($request); goto dd027; C8b74: } private function createDatabaseForm(Site $site, DatabaseEntity $databaseEntity) : Form { goto Fcc02; e8dc3: return $form; goto Bf171; A4d33: $form->add("\x73\x75\142\155\151\x74", SubmitType::class, ["\x61\164\164\162" => ["\143\x6c\x61\x73\163" => "\x62\x74\x6e\x20\x62\164\156\55\142\154\165\145\40\x62\164\x6e\55\x6c\147"], "\x6c\141\142\x65\x6c" => "\x41\x64\x64\40\104\x61\x74\x61\x62\x61\x73\x65"]); goto e8dc3; Fcc02: $form = $this->createForm("\x41\160\160\134\106\157\x72\x6d\x5c\x53\x69\x74\145\x44\x61\x74\x61\x62\141\x73\x65\124\x79\x70\145", $databaseEntity, ["\141\143\x74\x69\157\x6e" => $this->generateUrl("\x63\x6c\160\x5f\x73\x69\x74\x65\x5f\x64\x61\164\x61\x62\x61\x73\x65\137\x6e\145\x77", ["\x64\157\x6d\x61\151\156\116\x61\155\x65" => $site->getDomainName()]), "\x6d\x65\164\150\157\x64" => "\120\x4f\123\124", "\141\x74\164\x72" => []]); goto A4d33; Bf171: } private function handleDatabaseForm(Request $request, Form $form, Site $site) { goto B8946; e0a25: F4be6: goto c14d9; cc604: $this->formErrors = $this->getErrorMessages($form); goto a6e5f; c14d9: try { goto Fcf9f; fe7a2: $databaseManager->createUser($databaseUserEntity); goto a90b4; D4555: $domainName = $site->getDomainName(); goto f616d; A078d: $session->getFlashBag()->set("\163\165\x63\x63\x65\x73\163", $this->translator->trans("\x44\x61\164\x61\x62\x61\163\x65\40\150\141\163\40\x62\x65\145\156\x20\141\x64\144\x65\144\x2e")); goto d85b5; baef8: $siteEntity->addDatabase($databaseEntity); goto F558f; C2759: $databaseUserEntity->setPassword(Crypto::encrypt($databaseUserPassword)); goto b2f6d; d85b5: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\145\137\x64\x61\x74\141\142\141\x73\145\163", ["\x64\157\155\141\151\x6e\x4e\x61\x6d\145" => $site->getDomainName()])); goto Fbe0e; e5255: $session = $request->getSession(); goto D4555; F558f: $databaseManager->createDatabase($databaseEntity); goto fe7a2; Fbe0e: cdc7b: goto B1e44; f616d: $siteEntity = $this->getSiteEntity($domainName); goto Ba905; a90b4: $this->siteEntityManager->updateEntity($siteEntity); goto b39e1; D3b2d: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto Cd0ad; b39e1: $eventData = ["\x73\x69\x74\145" => $domainName, "\x64\x61\164\x61\142\x61\x73\x65" => $databaseEntity->getName(), "\x64\141\x74\141\142\x61\163\145\x55\x73\x65\x72\x4e\x61\155\145" => $databaseUserEntity->getUserName()]; goto c1d51; c1d51: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_ADD, $user, $eventData, $request); goto A078d; E84bb: $databaseEntity->setSite($siteEntity); goto Ffe7c; D0179: $databaseEntity->setDatabaseServer($activeDatabaseServerEntity); goto E84bb; ae47a: $databaseUserEntity->setDatabase($databaseEntity); goto A5c31; Cd0ad: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto D0179; d953b: $databaseUserPassword = $form->get("\x75\x73\x65\x72\x50\141\163\163\x77\157\162\144")->getData(); goto f4878; Fcf9f: $user = $this->getUser(); goto e5255; f4878: $databaseUserEntity = $this->databaseUserEntityManager->createEntity(); goto c6745; Ffe7c: $databaseUserName = $form->get("\165\x73\145\x72\x4e\x61\x6d\x65")->getData(); goto d953b; ad92f: $databaseEntity = $form->getData(); goto D3b2d; c6745: $databaseUserEntity->setUserName($databaseUserName); goto C2759; b0a0f: A78e1: goto ad92f; d98de: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\151\x74\145\x5f\x64\141\164\x61\142\141\x73\145\137\156\145\x77", ["\x64\157\155\141\151\156\x4e\141\x6d\145" => $site->getDomainName()])); goto F2579; A5c31: $databaseEntity->addUser($databaseUserEntity); goto baef8; B1e44: return $response; goto D9ad8; F2579: goto cdc7b; goto b0a0f; b2f6d: $databaseUserEntity->setPermissions(DatabaseUserEntity::PERMISSIONS_READ_WRITE); goto ae47a; Ba905: if (false === is_null($siteEntity)) { goto A78e1; } goto d98de; D9ad8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\145\x72", $this->translator->trans("\x41\156\x20\145\162\162\157\x72\x20\150\x61\163\x20\x6f\x63\143\165\x72\x72\145\x64\x2c\40\x65\x72\162\x6f\x72\40\x6d\145\163\163\x61\147\x65\72\x20\x25\145\162\162\x6f\162\115\145\163\163\141\x67\x65\45", ["\45\x65\162\x72\157\x72\115\145\x73\163\141\147\x65\x25" => $e->getMessage()])); } goto b1e04; a6e5f: goto Dbf53; goto e0a25; b1e04: Dbf53: goto f5bfd; B8946: if (true === $form->isValid()) { goto F4be6; } goto cc604; f5bfd: } public function deleteDatabase(Request $request) : Response { goto Cb9f3; aaacd: return $response; goto b3342; C1b2e: return $response; goto d4a08; F2cdc: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName() && false === is_null($siteEntity))) { goto Ff652; } goto D0b48; B07bd: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\163\x69\x74\145\x5f\144\x61\x74\141\x62\141\x73\145\x73", ["\x64\x6f\x6d\x61\151\156\116\141\x6d\145" => $site->getDomainName()])); goto C1b2e; D0b48: try { goto D4d2b; E17f9: $databaseManager->deleteDatabase($databaseEntity, true); goto D498c; B570c: $domainName = $site->getDomainName(); goto acec3; fd7b6: $databaseManager = new DatabaseManager($databaseServerEntity); goto E17f9; A4103: $session = $request->getSession(); goto B570c; E6cdf: $session->getFlashBag()->set("\163\x75\143\x63\145\163\163", $this->translator->trans("\x44\x61\164\141\142\x61\x73\145\x20\150\141\x73\40\142\x65\145\x6e\40\144\x65\154\x65\164\145\x64\56")); goto fef84; Ce95e: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_DELETE, $user, $eventData, $request); goto E6cdf; d8a45: $eventData = ["\x73\151\x74\145" => $domainName, "\x64\x61\x74\141\x62\141\163\x65" => $databaseEntity->getName()]; goto Ce95e; D4d2b: $user = $this->getUser(); goto A4103; acec3: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto fd7b6; b6f06: $this->siteEntityManager->updateEntity($siteEntity); goto d8a45; D498c: $siteEntity->removeDatabase($databaseEntity); goto b6f06; fef84: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\x72", $this->translator->trans("\x41\156\x20\x65\162\x72\x6f\162\x20\150\141\x73\x20\x6f\143\143\x75\162\x72\x65\144\x2c\40\145\162\162\157\x72\40\x6d\x65\x73\x73\x61\x67\145\72\x20\45\145\x72\162\157\162\x4d\x65\163\x73\x61\x67\145\45", ["\45\145\162\x72\x6f\162\x4d\x65\163\x73\x61\x67\x65\45" => $e->getMessage()])); } goto B07bd; D7728: if (!(false === is_null($site))) { goto Fc878; } goto cf4f9; Ae879: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto F2cdc; Cb9f3: $site = $this->getSite($request); goto D7728; cf4f9: $databaseName = $request->get("\144\141\x74\141\142\x61\x73\145\x4e\x61\x6d\145"); goto ec512; B55f5: Fc878: goto E90ff; d4a08: Ff652: goto B55f5; ec512: $databaseEntity = $this->databaseEntityManager->findOneByName($databaseName); goto Ae879; E90ff: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\151\164\145\x73")); goto aaacd; b3342: } public function phpMyAdmin(Request $request) : Response { goto Fb9ba; fc04f: $response->headers->clearCookie("\160\150\160\115\x79\101\144\x6d\x69\156\x5f\x68\x74\164\x70\x73"); goto f6e58; ae8ca: if (!(false === is_null($activeDatabaseServerEntity) && false === is_null($activeDatabaseServerEntity))) { goto B5165; } goto F82ea; Dd403: d251d: goto c3b55; b94ff: E03b8: goto Cdf78; e2728: goto d251d; goto b94ff; c42c7: $databaseServerHost = urlencode(base64_encode($activeDatabaseServerEntity->getHost())); goto b6aa3; f8bad: $phpMyAdminUrl = sprintf("\150\x74\x74\160\x73\x3a\x2f\57\45\x73\72\45\163\x2f\x70\150\160\155\x79\x61\144\155\x69\156\57\x6c\x6f\x67\x69\x6e\56\x70\150\160\77\150\x6f\x73\164\x3d\x25\x73\x26\x70\x6f\162\164\75\45\163", $request->getHost(), $request->getPort(), $databaseServerHost, $databaseServerPort); goto b5f50; faf98: if (!(false === is_null($site))) { goto E5182; } goto Bef1d; bdf00: Abc7c: goto Da62c; Ddf29: $response = new RedirectResponse($phpMyAdminUrl); goto F157f; F157f: $response->headers->setCookie($cookie); goto D45c4; E7589: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto A9174; D2e48: $databaseServerPort = $activeDatabaseServerEntity->getPort(); goto e3fa7; Faf7e: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto ae8ca; Cdf78: $site = $this->getSite($request); goto faf98; A9174: if (!(false === is_null($activeDatabaseServerEntity))) { goto F5a8f; } goto b1906; Fc1f1: if (false === is_null($domainName)) { goto E03b8; } goto E7589; Bef1d: $databaseUserName = $request->get("\144\141\164\141\142\141\x73\x65\125\x73\145\162\x4e\x61\x6d\x65"); goto eb83d; Da62c: B5165: goto D0831; e572d: F5a8f: goto e2728; f93dd: return $response; goto aa4b9; f42e7: return $response; goto e572d; b7865: $data = serialize($data); goto Bc322; b6aa3: $databaseServerPort = $activeDatabaseServerEntity->getPort(); goto f8bad; b6a25: $cookie = new Cookie("\143\154\x70\55\160\x6d\x61", $encryptedData); goto Ddf29; b5f50: $data = ["\150\157\163\164" => $activeDatabaseServerEntity->getHost(), "\165\163\145\x72\x4e\x61\x6d\x65" => $databaseUserEntity->getUserName(), "\x70\141\x73\x73\x77\x6f\x72\x64" => $databaseUserEntity->getDecryptedPassword(), "\x70\x6f\x72\164" => $activeDatabaseServerEntity->getPort()]; goto b7865; F82ea: $databaseEntity = $databaseUserEntity->getDatabase(); goto Ea7a9; Ea7a9: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName())) { goto Abc7c; } goto c42c7; f6e58: $response->headers->clearCookie("\x70\155\141\101\x75\164\150\x2d\x31\x5f\150\x74\164\160\163"); goto ac6f1; eb83d: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto Faf7e; D45c4: return $response; goto bdf00; D0831: E5182: goto Dd403; Ac67c: $response->headers->clearCookie("\143\x6c\160\55\160\155\x61"); goto fc04f; Fb9ba: $domainName = $request->get("\x64\x6f\155\141\x69\156\116\x61\155\x65"); goto Fc1f1; e3fa7: $phpMyAdminUrl = sprintf("\x68\164\164\x70\x73\x3a\x2f\57\x25\163\x3a\x25\163\x2f\x70\x68\160\x6d\171\x61\144\x6d\x69\x6e\x2f\154\157\147\151\156\x2e\x70\150\160\77\x68\157\163\164\75\x25\163\46\x70\x6f\162\x74\75\45\x73", $request->getHost(), $request->getPort(), $databaseServerHost, $databaseServerPort); goto D8d77; ac6f1: $response->headers->clearCookie("\123\x69\x67\x6e\157\156\123\145\x73\x73\x69\x6f\x6e"); goto f42e7; c3b55: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\151\164\x65\x73")); goto f93dd; b1906: $databaseServerHost = urlencode(base64_encode($activeDatabaseServerEntity->getHost())); goto D2e48; D8d77: $response = new RedirectResponse($phpMyAdminUrl); goto Ac67c; e60e6: $encryptedData = trim(base64_encode($encryptedData)); goto b6a25; Bc322: $encryptedData = Crypto::encrypt($data); goto e60e6; aa4b9: } public function phpMyAdminLogout(Request $request) { goto E3d61; E3d61: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\x73\151\x74\x65\x73")); goto A292e; f563d: $response->headers->clearCookie("\x53\151\147\x6e\157\156\123\x65\163\x73\151\x6f\x6e"); goto D1ade; D5ad6: $response->headers->clearCookie("\x70\150\160\115\171\x41\x64\x6d\151\156\x5f\150\x74\164\160\163"); goto B8958; D1ade: return $response; goto b8c6e; B8958: $response->headers->clearCookie("\x70\x6d\141\x41\165\164\150\55\x31\x5f\150\x74\164\x70\163"); goto f563d; A292e: $response->headers->clearCookie("\143\x6c\160\x2d\160\155\x61"); goto D5ad6; b8c6e: } public function newDatabaseUser(Request $request) : Response { goto B443b; e4f95: $domainName = $site->getDomainName(); goto d588c; D2eb6: $session->getFlashBag()->set("\x64\141\x6e\x67\x65\x72", $this->translator->trans("\116\157\x20\144\141\164\x61\142\141\163\x65\x20\x66\x6f\165\x6e\x64\73\x20\143\x72\145\141\x74\x65\40\x61\x20\x64\x61\164\141\142\x61\x73\145\x20\146\x69\x72\x73\x74\56")); goto Bb5f4; A246a: E03f3: goto Aef98; e7cf5: $databaseUserEntity = $this->databaseUserEntityManager->createEntity(); goto C11bf; C11bf: $databaseUserEntity->setSite($siteEntity); goto f1eb9; b05f0: if (!(true === $form->isSubmitted())) { goto Ebead; } goto f3504; ef15f: D077a: goto b61fa; d2aca: if (count($databases) && false === is_null($siteEntity)) { goto E526e; } goto ce569; Aef98: $databases = $site->getDatabases(); goto e4f95; d588c: $siteEntity = $this->getSiteEntity($domainName); goto d2aca; B8366: if (false === is_null($site)) { goto E03f3; } goto b3849; b8744: Cfa4a: goto D78cd; Bb5f4: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\x69\164\145\x5f\x64\141\164\x61\142\x61\163\x65\163", ["\x64\157\155\x61\151\x6e\116\141\155\x65" => $site->getDomainName()])); goto C9a9a; C07ed: $response = $this->render("\106\x72\x6f\x6e\164\145\x6e\x64\x2f\123\151\x74\x65\x2f\156\145\x77\55\144\x61\x74\141\x62\x61\163\145\55\x75\163\x65\162\56\150\164\x6d\x6c\x2e\164\x77\x69\x67", ["\x73\x69\x74\x65" => $site, "\144\141\x74\141\142\141\163\145\125\163\x65\162" => $databaseUserEntity, "\144\141\x74\141\x62\x61\163\145\163" => $databases, "\x66\157\162\155" => $form->createView(), "\146\x6f\x72\155\105\x72\162\157\x72\x73" => $this->formErrors]); goto Ac008; C9a9a: goto B9aa9; goto df229; df229: E526e: goto e7cf5; e13fa: if (!(true === $request->isMethod("\x50\x4f\x53\x54"))) { goto B7007; } goto bddf5; D9423: B7007: goto C07ed; f3504: $response = $this->handleDatabaseUserForm($request, $form, $site); goto C5558; f1eb9: $form = $this->createDatabaseUserForm($site, $databaseUserEntity); goto e13fa; e938a: goto D077a; goto A246a; C5558: if (!(false === is_null($response))) { goto Cfa4a; } goto Eaf5f; D78cd: Ebead: goto D9423; b61fa: return $response; goto b5a79; Ac008: B9aa9: goto ef15f; Eaf5f: return $response; goto b8744; ce569: $session = $request->getSession(); goto D2eb6; b3849: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\x69\x74\145\x73")); goto e938a; B443b: $site = $this->getSite($request); goto B8366; bddf5: $form->handleRequest($request); goto b05f0; b5a79: } private function createDatabaseUserForm(Site $site, DatabaseUserEntity $databaseUserEntity) : Form { goto deb22; A6500: return $form; goto aa30f; C167f: $form->add("\x73\165\x62\x6d\x69\x74", SubmitType::class, ["\x61\164\x74\162" => ["\143\x6c\x61\x73\163" => "\142\164\x6e\40\142\x74\156\55\142\x6c\165\x65\x20\x62\x74\156\55\154\147"], "\x6c\141\x62\145\x6c" => "\x41\x64\144\x20\104\141\164\x61\142\141\x73\145\40\125\x73\145\x72"]); goto A6500; deb22: $form = $this->createForm("\101\x70\x70\x5c\106\157\x72\x6d\134\123\x69\x74\145\104\141\x74\x61\142\x61\163\145\x55\163\145\x72\124\171\160\x65", $databaseUserEntity, ["\141\x63\164\151\x6f\156" => $this->generateUrl("\143\154\160\137\x73\x69\x74\145\x5f\144\141\164\141\x62\x61\163\x65\x5f\x75\x73\x65\x72\137\x6e\x65\167", ["\144\x6f\155\x61\x69\x6e\x4e\141\155\145" => $site->getDomainName()]), "\x6d\145\164\x68\x6f\x64" => "\120\x4f\123\124", "\141\x74\164\x72" => []]); goto C167f; aa30f: } private function handleDatabaseUserForm(Request $request, Form $form, Site $site) { goto D0c4a; D9586: try { goto Aefed; d7659: goto A97d4; goto Df4a5; a5471: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_ADD, $user, $eventData, $request); goto f7e94; f4e4b: $databaseUserEntity = $form->getData(); goto C0cc5; Fa549: $databaseName = $databaseEntity->getName(); goto d1995; da311: $domainName = $site->getDomainName(); goto a7a71; ac77d: $this->databaseUserEntityManager->updateEntity($databaseUserEntity); goto E8de5; Fa42d: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto Aaaec; Cd366: if (false === is_null($siteEntity)) { goto Ad65c; } goto A4836; C0cc5: $encryptedPassword = Crypto::encrypt($databaseUserEntity->getPassword()); goto Ff857; De677: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\151\164\145\x5f\x64\x61\x74\x61\142\141\163\145\x73", ["\x64\157\x6d\141\151\156\116\x61\x6d\x65" => $site->getDomainName()])); goto b1f85; Df4a5: Ad65c: goto f4e4b; E59f7: return $response; goto cc7ad; b1f85: A97d4: goto E59f7; a7a71: $siteEntity = $this->getSiteEntity($domainName); goto Cd366; dc247: $session = $request->getSession(); goto da311; Aefed: $user = $this->getUser(); goto dc247; f7e94: $session->getFlashBag()->set("\163\x75\143\x63\x65\x73\x73", $this->translator->trans("\104\141\164\x61\142\x61\x73\145\x20\125\x73\x65\x72\40\x68\141\163\40\x62\145\x65\x6e\x20\141\x64\x64\x65\144\56")); goto De677; Aaaec: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto e2661; E8de5: $databaseEntity = $databaseUserEntity->getDatabase(); goto Fa549; e2661: $databaseManager->createUser($databaseUserEntity); goto ac77d; A4836: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\151\x74\x65\137\x64\141\164\x61\x62\x61\x73\145\x5f\165\163\145\x72\137\x6e\x65\x77", ["\x64\x6f\x6d\141\x69\156\x4e\141\155\145" => $site->getDomainName()])); goto d7659; Ff857: $databaseUserEntity->setPassword($encryptedPassword); goto Fa42d; d1995: $eventData = ["\x73\x69\x74\145" => $domainName, "\144\x61\x74\x61\142\141\x73\x65\x55\x73\145\162\116\x61\155\x65" => $databaseUserEntity->getUserName(), "\160\145\162\155\x69\x73\163\x69\x6f\x6e\163" => $databaseUserEntity->getPermissions(), "\x64\141\x74\141\142\x61\x73\x65" => $databaseName]; goto a5471; cc7ad: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\147\145\162", $this->translator->trans("\x41\x6e\40\x65\162\162\x6f\162\x20\x68\x61\163\40\157\x63\x63\165\x72\x72\x65\144\x2c\x20\145\162\x72\x6f\x72\x20\x6d\145\163\x73\x61\x67\x65\72\x20\45\145\162\x72\157\x72\115\x65\x73\x73\x61\147\x65\45", ["\x25\145\x72\162\157\x72\115\145\163\x73\x61\x67\145\45" => $e->getMessage()])); } goto Ca2f2; fd6a3: $this->formErrors = $this->getErrorMessages($form); goto d853b; d853b: goto A9dab; goto e43cb; Ca2f2: A9dab: goto cd81d; D0c4a: if (true === $form->isValid()) { goto Af475; } goto fd6a3; e43cb: Af475: goto D9586; cd81d: } public function editDatabaseUser(Request $request) : Response { goto Df24f; Df24f: $site = $this->getSite($request); goto cb394; A4084: $domainName = $site->getDomainName(); goto b31fb; A9d16: dc084: goto F9b42; f6650: goto F1d13; goto Af0c7; c2cbe: if (!(true === $request->isMethod("\x50\x4f\123\x54"))) { goto a1f3e; } goto f719f; Fd37a: $response = $this->render("\x46\x72\157\156\x74\145\156\144\57\123\x69\164\x65\x2f\145\144\151\164\55\x64\141\164\141\x62\x61\163\145\55\x75\x73\145\x72\x2e\x68\x74\155\x6c\x2e\164\167\x69\x67", ["\x73\151\x74\145" => $site, "\144\x61\x74\141\142\x61\163\145\x55\163\145\162" => $databaseUserEntity, "\x66\157\162\155" => $form->createView(), "\146\157\162\x6d\105\x72\x72\x6f\x72\x73" => $this->formErrors]); goto ae36e; f92ae: return $response; goto Aec59; Fe8d7: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto e4fb9; Ade34: $databaseUserName = $request->get("\x64\141\164\x61\142\x61\x73\x65\125\x73\145\162\116\x61\x6d\x65"); goto Fe8d7; ea059: A7377: goto Ffade; da081: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\151\164\145\137\144\141\164\x61\x62\141\x73\x65\163", ["\x64\x6f\x6d\141\151\x6e\116\x61\x6d\x65" => $site->getDomainName()])); goto f6650; aec70: $databases = $site->getDatabases(); goto A4084; A761d: $session->getFlashBag()->set("\x64\x61\156\147\145\162", $this->translator->trans("\116\157\40\x64\x61\164\x61\142\x61\163\145\40\146\157\x75\x6e\x64\x3b\40\143\162\x65\x61\164\145\40\141\x20\x64\141\x74\x61\x62\141\163\145\40\146\151\162\x73\x74\56")); goto da081; Daf54: $response = $this->handleDatabaseUserEditForm($request, $form, $site); goto B26d4; Aec59: E4303: goto A9d16; b31fb: $siteEntity = $this->getSiteEntity($domainName); goto f733e; A6aa4: F1d13: goto ea059; B26d4: if (!(false === is_null($response))) { goto E4303; } goto f92ae; Ffade: return $response; goto ef373; D5169: if (!(true === $form->isSubmitted())) { goto dc084; } goto Daf54; Af0c7: Ff2b5: goto Ade34; F9b42: a1f3e: goto Fd37a; cb394: if (false === is_null($site)) { goto Eb640; } goto Da0c7; c6854: Eb640: goto aec70; e4fb9: if (!(false === is_null($databaseUserEntity))) { goto b3476; } goto C7c99; A3b50: $session = $request->getSession(); goto A761d; Da0c7: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\163\151\164\145\163")); goto ad2d9; Cbe10: $form = $this->createDatabaseUserEditForm($site, $databaseUserEntity); goto c2cbe; ad2d9: goto A7377; goto c6854; C7c99: $databaseUserEntity->setPassword(''); goto Cbe10; ae36e: b3476: goto A6aa4; f733e: if (count($databases) && false === is_null($siteEntity)) { goto Ff2b5; } goto A3b50; f719f: $form->handleRequest($request); goto D5169; ef373: } private function createDatabaseUserEditForm(Site $site, DatabaseUserEntity $databaseUserEntity) : Form { goto ee9b0; D8761: $form->add("\x73\165\142\x6d\151\164", SubmitType::class, ["\141\164\x74\162" => ["\143\154\141\x73\163" => "\142\x74\156\40\142\164\156\55\142\154\x75\145\40\142\164\156\55\154\147"], "\x6c\141\142\145\x6c" => "\x53\x61\x76\145"]); goto E6a1d; ee9b0: $form = $this->createForm("\x41\x70\160\134\x46\x6f\x72\x6d\x5c\123\151\x74\x65\104\141\164\x61\x62\x61\x73\145\x55\163\145\162\105\x64\x69\164\x54\x79\x70\145", $databaseUserEntity, ["\141\x63\x74\151\x6f\156" => $this->generateUrl("\143\x6c\160\137\163\151\164\145\137\144\141\x74\141\142\x61\163\145\137\165\x73\145\162\137\x65\144\151\164", ["\144\x6f\x6d\x61\x69\x6e\116\x61\x6d\145" => $site->getDomainName(), "\x64\x61\164\x61\x62\x61\x73\x65\125\x73\145\x72\x4e\x61\x6d\145" => $databaseUserEntity->getUserName()]), "\x6d\x65\164\150\157\x64" => "\x50\x4f\123\x54", "\141\164\164\162" => []]); goto D8761; E6a1d: return $form; goto F89e2; F89e2: } private function handleDatabaseUserEditForm(Request $request, Form $form, Site $site) { goto Cfc7f; F7120: b9413: goto b0f7d; e4bf7: try { goto fb8c0; b8631: $session = $request->getSession(); goto F3e69; cc20f: $databaseEntity = $databaseUserEntity->getDatabase(); goto e0d78; a4a16: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\x69\x74\145\x5f\x64\x61\x74\x61\142\141\x73\x65\x5f\x75\x73\x65\x72\137\156\x65\x77", ["\x64\x6f\155\141\151\x6e\116\x61\x6d\x65" => $site->getDomainName()])); goto b74ca; b74ca: goto Dfa70; goto Dd02c; Faa9c: $this->databaseUserEntityManager->updateEntity($databaseUserEntity); goto cc20f; a7cc3: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto B5162; F00d0: $databaseUserEntity->setPassword($encryptedPassword); goto Eb0b3; E7e0d: $session->getFlashBag()->set("\x73\165\x63\x63\145\x73\x73", $this->translator->trans("\x44\141\164\x61\x62\141\163\x65\x20\125\x73\x65\x72\x20\150\141\163\x20\x62\x65\x65\x6e\x20\165\160\x64\x61\x74\145\x64\56")); goto a7ec3; a4999: $eventData = ["\163\151\x74\145" => $domainName, "\144\141\164\141\142\141\x73\145\125\x73\145\162\116\141\x6d\145" => $databaseUserEntity->getUserName(), "\160\145\162\x6d\x69\163\163\151\x6f\x6e\163" => $databaseUserEntity->getPermissions(), "\144\x61\164\141\x62\x61\x73\145" => $databaseName]; goto D4427; F3e69: $domainName = $site->getDomainName(); goto D7e2c; B5162: $databaseManager->createUser($databaseUserEntity); goto Faa9c; e0d78: $databaseName = $databaseEntity->getName(); goto a4999; D7e2c: $siteEntity = $this->getSiteEntity($domainName); goto e27bc; Eb0b3: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto a7cc3; a7ec3: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\x69\x74\x65\x5f\144\x61\x74\x61\142\141\x73\x65\x73", ["\x64\x6f\x6d\141\x69\x6e\116\141\x6d\145" => $site->getDomainName()])); goto De029; Dd02c: a66bc: goto d2287; fb8c0: $user = $this->getUser(); goto b8631; e27bc: if (false === is_null($siteEntity)) { goto a66bc; } goto a4a16; f1173: return $response; goto d45c4; De029: Dfa70: goto f1173; E2de0: $encryptedPassword = Crypto::encrypt($databaseUserEntity->getPassword()); goto F00d0; d2287: $databaseUserEntity = $form->getData(); goto E2de0; D4427: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_EDIT, $user, $eventData, $request); goto E7e0d; d45c4: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\145\x72", $this->translator->trans("\x41\156\x20\145\162\162\157\162\40\150\141\163\40\x6f\143\x63\x75\x72\162\x65\144\x2c\x20\145\162\162\x6f\x72\x20\155\145\163\x73\x61\147\x65\x3a\40\45\145\162\162\157\x72\115\145\x73\x73\141\x67\x65\45", ["\45\x65\162\x72\157\162\115\x65\x73\163\141\147\145\x25" => $e->getMessage()])); } goto F7120; d4eaf: adc21: goto e4bf7; E18e4: $this->formErrors = $this->getErrorMessages($form); goto A30ba; A30ba: goto b9413; goto d4eaf; Cfc7f: if (true === $form->isValid()) { goto adc21; } goto E18e4; b0f7d: } public function deleteDatabaseUser(Request $request) : Response { goto a6003; b7835: try { goto D5424; C4fc2: $session->getFlashBag()->set("\x73\165\x63\x63\x65\163\x73", $this->translator->trans("\104\141\164\x61\x62\141\x73\x65\x20\x55\x73\x65\x72\x20\150\x61\163\40\142\x65\145\x6e\40\x64\145\x6c\x65\164\x65\x64\x2e")); goto e7c47; c78b8: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto F6eaa; bf798: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_DELETE, $user, $eventData, $request); goto c591f; F6eaa: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto a452d; c591f: F2d21: goto E80ec; e7c47: $eventData = ["\x73\x69\x74\x65" => $domainName, "\144\141\x74\141\x62\x61\x73\145\125\163\x65\x72\x4e\x61\155\x65" => $databaseUserName]; goto bf798; cd9cb: $user = $this->getUser(); goto B16cb; Ced55: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName())) { goto F2d21; } goto cd9cb; D5424: $databaseEntity = $databaseUserEntity->getDatabase(); goto Ced55; b427f: $session = $request->getSession(); goto c78b8; e426d: $this->databaseUserEntityManager->deleteEntity($databaseUserEntity); goto C4fc2; a452d: $databaseManager->deleteUser($databaseUserEntity); goto e426d; B16cb: $domainName = $site->getDomainName(); goto b427f; E80ec: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\145\x72", $this->translator->trans("\101\156\40\x65\162\x72\x6f\162\x20\150\141\x73\40\157\143\143\x75\162\x72\x65\144\x2c\40\145\x72\162\x6f\162\40\155\145\x73\x73\x61\x67\x65\x3a\40\45\145\162\162\157\162\x4d\145\163\163\x61\x67\145\x25", ["\45\145\162\162\x6f\162\x4d\145\x73\x73\x61\x67\x65\x25" => $e->getMessage()])); } goto e1b36; a8d59: $databaseUserName = $request->get("\x64\x61\164\x61\142\141\x73\145\125\x73\145\162\116\x61\155\145"); goto B697a; cff46: return $response; goto dd583; aa01a: if (!(false === is_null($databaseUserEntity))) { goto f5045; } goto b7835; a6003: $site = $this->getSite($request); goto a2b44; D19f8: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\x69\164\x65\x73")); goto cff46; D4dbd: f5045: goto Af1f2; Af1f2: a5f50: goto D19f8; a2b44: if (!(false === is_null($site))) { goto a5f50; } goto a8d59; e1b36: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\x69\x74\x65\x5f\x64\141\x74\x61\142\x61\163\x65\163", ["\x64\157\x6d\141\151\x6e\x4e\x61\155\x65" => $site->getDomainName()])); goto c292e; B697a: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto aa01a; c292e: return $response; goto D4dbd; dd583: } public function vhost(Request $request) : Response { goto E2453; cb2ee: if (!(false === is_null($response))) { goto eabd4; } goto Bccc2; ec4b1: Fbc07: goto adb2c; a957f: $vhostTemplate = trim($request->get("\x76\150\x6f\163\164\x2d\x74\145\x6d\x70\154\141\164\145")); goto D6a6b; F9597: $siteEntity = $this->getSiteEntity($domainName); goto F0c53; C2248: if (false === is_null($site)) { goto Fbc07; } goto Cef8a; dde20: e67fc: goto c39da; A4f8e: return $response; goto E6bcc; D57b1: e130a: goto dde20; Cb72f: Fadc0: goto A4f8e; E2453: $site = $this->getSite($request); goto C2248; Cef8a: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\151\164\x65\163")); goto C800c; A86f5: $domainName = $site->getDomainName(); goto F9597; Bccc2: return $response; goto c6e85; c6e85: eabd4: goto D57b1; adb2c: if (!(true === $request->isMethod("\x50\117\x53\124"))) { goto e67fc; } goto a957f; C800c: goto Fadc0; goto ec4b1; c39da: $response = $this->render("\106\x72\x6f\x6e\164\x65\156\x64\x2f\x53\x69\164\x65\x2f\166\x68\x6f\163\x74\56\150\x74\155\154\56\x74\x77\x69\147", ["\163\151\164\145" => $site]); goto Cb72f; D6a6b: if (!(false === empty($vhostTemplate))) { goto e130a; } goto A86f5; a1930: $response = $this->handleVhostUpdate($request, $site, $siteEntity, $oldVhostTemplate); goto cb2ee; F0c53: $oldVhostTemplate = $siteEntity->getVhostTemplate(); goto ce114; ce114: $site->setVhostTemplate($vhostTemplate); goto a1930; E6bcc: } private function handleVhostUpdate(Request $request, Site $site, SiteEntity $siteEntity, string $oldVhostTemplate) { try { goto Efe61; Dc931: $siteEntity->setVhostTemplate($vhostTemplate); goto c1d5d; eb13c: $siteUpdater = $this->getSiteUpdater($site); goto c8c71; A67b4: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\151\x74\x65\x5f\166\150\157\163\x74", ["\x64\157\155\141\151\x6e\x4e\141\x6d\145" => $domainName])); goto e484e; c6583: $domainName = $site->getDomainName(); goto b9923; e484e: return $response; goto Fcaa2; b9923: $vhostTemplate = $site->getVhostTemplate(); goto eb13c; Efe61: $user = $this->getUser(); goto D3c0d; A2d79: $eventData = ["\x73\x69\x74\145" => $domainName, "\166\150\x6f\163\164" => $vhostTemplate, "\x6f\154\144\126\x68\x6f\163\164" => $oldVhostTemplate]; goto fc65c; fc65c: EventQueue::addEvent(EventQueue::EVENT_SITE_VHOST_UPDATE, $user, $eventData, $request); goto A67b4; c1d5d: $this->siteEntityManager->updateEntity($siteEntity); goto A39f1; c8c71: $siteUpdater->updateNginxVhostWithRollback(); goto Dc931; A39f1: $session->getFlashBag()->set("\163\165\143\143\145\x73\x73", $this->translator->trans("\x56\x68\157\163\164\x20\150\141\x73\40\142\x65\145\156\40\x73\141\x76\145\144\x2e")); goto A2d79; D3c0d: $session = $request->getSession(); goto c6583; Fcaa2: } catch (InvalidVhostException $e) { $session->getFlashBag()->set("\x64\x61\x6e\147\145\162", $this->translator->trans("\x56\x68\157\x73\x74\x20\151\x73\40\x6e\x6f\164\x20\166\141\x6c\151\144\54\40\145\162\x72\x6f\x72\x20\x6d\145\x73\163\141\147\x65\x3a\x20\45\x65\162\162\x6f\x72\115\x65\163\163\x61\x67\145\x25", ["\45\x65\162\x72\x6f\x72\x4d\145\163\163\x61\147\145\45" => $e->getMessage()])); } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\145\x72", $this->translator->trans("\101\x6e\40\x65\x72\x72\157\162\x20\150\x61\163\40\157\x63\x63\x75\x72\162\145\x64\54\x20\x65\x72\x72\x6f\162\40\x6d\145\x73\163\141\147\145\x3a\x20\45\145\162\x72\x6f\162\x4d\x65\x73\x73\141\x67\145\45", ["\x25\145\162\x72\x6f\x72\115\145\x73\163\x61\x67\145\45" => $e->getMessage()])); } } public function settings(Request $request) : Response { goto Ba4c7; C4450: $pythonSettingsForm = $this->createPythonSettingsForm($site, $pythonSettings); goto d43f1; bac59: c34be: goto b29d9; C5053: unset($parameters["\160\141\147\145\123\x70\145\x65\144\123\145\x74\x74\x69\156\147\x73\106\x6f\x72\155"]); goto Dc655; dbf44: $parameters = ["\x73\x69\x74\x65" => $site, "\x64\x6f\155\x61\151\x6e\123\x65\164\164\x69\x6e\147\163\x46\x6f\x72\x6d" => $domainSettingsForm->createView(), "\x73\x69\164\145\125\163\x65\162\x53\145\164\164\x69\156\147\x73\x46\157\x72\x6d" => $siteUserSettingsForm->createView(), "\160\141\147\145\123\160\145\x65\144\123\x65\x74\x74\151\156\x67\163\x46\x6f\x72\x6d" => $pageSpeedSettingsForm->createView(), "\163\151\164\x65\104\145\154\145\x74\x65\106\x6f\x72\x6d" => $siteDeleteForm->createView()]; goto d8e31; Aca8d: $domainSettingsForm->handleRequest($request); goto ee127; e84c5: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\x73\x69\x74\x65\x73")); goto D9822; f6ebd: $domainSettingsData = ["\144\x6f\x6d\x61\151\156\116\141\155\x65" => $site->getDomainName(), "\x72\157\x6f\x74\x44\x69\162\145\x63\x74\157\x72\171" => $site->getRootDirectory()]; goto a8ffe; Ef6e0: d28a3: goto Edd58; f92a2: if (!(true === $pageSpeedSettingsForm->isSubmitted())) { goto Ab880; } goto Bd862; D14d8: if (!(true === $siteDeleteForm->isSubmitted())) { goto af9d2; } goto Bb38f; a6245: fab80: goto f92a2; dfbfa: return $response; goto F9a2a; Cac49: $pageSpeedSettingsData = ["\x69\163\x45\x6e\141\x62\x6c\145\x64" => $site->getPageSpeedEnabled(), "\x73\145\x74\x74\151\x6e\x67\x73" => $site->getPageSpeedSettings()]; goto dc51b; f55f2: af9d2: goto f1de4; dbaa9: $pageSpeedSettingsForm = $this->createPageSpeedSettingsForm($site, $pageSpeedSettingsData); goto E281f; f8a22: $siteDeleteData = ["\144\157\x6d\141\x69\156\116\141\x6d\x65" => $site->getDomainName()]; goto Cac49; ab930: if (!(false === is_null($response))) { goto b7106; } goto d5c5d; feb4d: c57a4: goto d8ddf; f4ba0: Ab880: goto D14d8; Bb38f: $response = $this->handleSiteDeleteForm($request, $siteDeleteForm, $site); goto f55f2; B9119: if (!(true === $nodejsSettingsForm->isSubmitted())) { goto ca0ac; } goto c1f2f; D775d: $siteDeleteForm->handleRequest($request); goto e33cf; D9822: goto f6d2a; goto A0db0; F0322: if (!(true === $pythonSettingsForm->isSubmitted())) { goto C0519; } goto ffdc8; d8e31: if (!(SiteEntity::TYPE_NODEJS == $site->getType())) { goto f9964; } goto A11d1; f23ed: Aa7bc: goto f2d23; b6ef5: $pythonSettings = $site->getPythonSettings(); goto C4450; d17c2: if (!(SiteEntity::TYPE_PHP == $site->getType())) { goto cb340; } goto D3511; D75a3: $currentNodeSettings = clone $nodejsSettings; goto f5473; b29d9: D80cc: goto dbf44; C7871: if (false === is_null($site)) { goto a5e5e; } goto e84c5; c1f2f: $response = $this->handleNodejsSettingsForm($request, $nodejsSettingsForm, $currentNodeSettings, $site); goto ab930; f2d23: if (!(true === $siteUserSettingsForm->isSubmitted())) { goto fab80; } goto c4297; F0a96: if (!(true === $phpSettingsForm->isSubmitted())) { goto c57a4; } goto Eba82; Bd862: $response = $this->handlePageSpeedSettingsForm($request, $pageSpeedSettingsForm, $site); goto f4ba0; A65ce: if (!(false === is_null($response))) { goto d28a3; } goto ef5de; C4b88: $pythonSettingsForm->handleRequest($request); goto F0322; c8069: $response = null; goto a630b; Ea007: if (!(false === is_null($response))) { goto baf22; } goto dfbfa; dc42b: $response = $this->handleDomainSettingsForm($request, $domainSettingsForm, $site); goto f23ed; e217b: $nodejsSettingsForm = $this->createNodejsSettingsForm($site, $nodejsSettings); goto e5fd3; B3191: c7b1a: goto Bc890; ee127: $siteUserSettingsForm->handleRequest($request); goto D775d; e33cf: $pageSpeedSettingsForm->handleRequest($request); goto c8069; ffdc8: $response = $this->handlePythonSettingsForm($request, $pythonSettingsForm, $site); goto A65ce; Dc655: f9964: goto d17c2; Aba38: $currentPhpSettings = clone $phpSettings; goto ea27a; aea65: b7106: goto Ac086; c63e9: if (!(SiteEntity::TYPE_PYTHON == $site->getType())) { goto F479d; } goto b6ef5; A0db0: a5e5e: goto f6ebd; Bc890: $parameters["\x6e\x6f\x64\x65\x6a\x73\x53\145\164\164\x69\156\x67\x73\x46\157\x72\155"] = $nodejsSettingsForm->createView(); goto C5053; A7adf: if (!(true === $request->isMethod("\120\x4f\x53\124"))) { goto A8ee8; } goto Aba38; Ba4b8: if (!(true === $request->isMethod("\x50\x4f\x53\x54"))) { goto D80cc; } goto Aca8d; F9a2a: baf22: goto feb4d; F9a7a: cb340: goto c63e9; C6ffc: $siteUserSettingsForm = $this->createSiteUserSettingsForm($site, $siteUserSettingsData); goto dbaa9; B88dc: return $response; goto bac59; D3511: $phpSettings = $site->getPhpSettings(); goto ec087; ef5de: return $response; goto Ef6e0; a307a: $parameters["\x70\x68\160\123\x65\x74\164\x69\156\147\x73\106\x6f\162\x6d"] = $phpSettingsForm->createView(); goto F9a7a; dc51b: $domainSettingsForm = $this->createDomainSettingsForm($site, $domainSettingsData); goto C6ffc; Eba82: $response = $this->handlePhpSettingsForm($request, $phpSettingsForm, $currentPhpSettings, $site); goto Ea007; ea27a: $phpSettingsForm->handleRequest($request); goto F0a96; Ac086: ca0ac: goto B3191; Ba4c7: $site = $this->getSite($request); goto C7871; a8ffe: $siteUserSettingsData = ["\163\151\x74\145\x55\163\145\x72" => $site->getUser(), "\x73\163\150\113\145\171\x73" => $site->getSshKeys()]; goto f8a22; c4297: $response = $this->handleSiteUserSettingsForm($request, $siteUserSettingsForm, $site); goto a6245; d43f1: if (!(true === $request->isMethod("\120\x4f\123\124"))) { goto e6792; } goto C4b88; d5c5d: return $response; goto aea65; A11d1: $nodejsSettings = $site->getNodejsSettings(); goto e217b; cf7e4: return $response; goto dc25c; Dc7fe: $parameters["\x70\171\x74\x68\x6f\156\x53\x65\x74\x74\151\x6e\147\x73\106\x6f\x72\155"] = $pythonSettingsForm->createView(); goto A43f1; f1896: $response = $this->render("\x46\162\157\x6e\164\x65\156\144\57\x53\x69\164\145\57\163\x65\x74\164\x69\x6e\x67\163\56\150\164\155\x6c\56\x74\x77\151\x67", $parameters); goto e1292; ec087: $phpSettingsForm = $this->createPhpSettingsForm($site, $phpSettings); goto A7adf; E281f: $siteDeleteForm = $this->createSiteDeleteForm($site, $siteDeleteData); goto Ba4b8; e1292: f6d2a: goto cf7e4; f5473: $nodejsSettingsForm->handleRequest($request); goto B9119; Edd58: C0519: goto f2fd1; A43f1: F479d: goto A1edc; a630b: if (!(true === $domainSettingsForm->isSubmitted())) { goto Aa7bc; } goto dc42b; d8ddf: A8ee8: goto a307a; e5fd3: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto c7b1a; } goto D75a3; f1de4: if (!(false === is_null($response))) { goto c34be; } goto B88dc; A1edc: $parameters["\x66\x6f\x72\155\x45\x72\x72\x6f\162\x73"] = $this->formErrors; goto f1896; f2fd1: e6792: goto Dc7fe; dc25c: } public function purgePageSpeedCache(Request $request) : Response { goto Ab33a; Ab33a: $site = $this->getSite($request); goto f2b22; d175a: d0e77: goto Ced36; Ced36: try { goto F2283; af7aa: $session = $request->getSession(); goto E1b44; F2283: $user = $this->getUser(); goto af7aa; d4e2e: $eventData = ["\163\x69\164\x65" => $site->getDomainName()]; goto ba947; Fad26: $session->getFlashBag()->set("\x73\x75\143\x63\145\x73\x73", $this->translator->trans("\120\x61\x67\145\40\x53\160\x65\145\x64\40\x43\141\x63\150\x65\x20\x68\x61\x73\40\x62\x65\145\x6e\40\x70\x75\162\147\145\x64\x2e")); goto A25e8; Cf8fa: $siteUpdater->purgePageSpeedCache(); goto d4e2e; ba947: EventQueue::addEvent(EventQueue::EVENT_SITE_PAGE_SPEED_CACHE_PURGE, $user, $eventData, $request); goto Fad26; E1b44: $siteUpdater = $this->getSiteUpdater($site); goto Cf8fa; A25e8: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\x65\x72", $this->translator->trans("\101\156\x20\x65\162\x72\157\162\x20\150\x61\163\40\157\x63\x63\x75\162\162\145\x64\x2c\40\145\x72\x72\x6f\162\x20\155\x65\163\x73\141\x67\145\72\x20\x25\145\x72\x72\x6f\162\x4d\x65\x73\x73\x61\147\x65\x25", ["\x25\145\x72\x72\157\162\x4d\145\163\x73\141\x67\145\x25" => $e->getMessage()])); } goto d8356; C843b: return $response; goto Feb1d; d6a55: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\163\x69\164\145\x73")); goto f5029; ffe06: return $response; goto D61c1; f2b22: if (false === is_null($site)) { goto d0e77; } goto d6a55; f5029: goto Aa598; goto d175a; d8356: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\x73\x69\x74\145\x5f\163\x65\164\x74\x69\x6e\x67\163", ["\x64\x6f\155\141\151\156\x4e\x61\155\145" => $site->getDomainName()])); goto C843b; Feb1d: Aa598: goto ffe06; D61c1: } private function createDomainSettingsForm(Site $site, array $data) : Form { goto Bffc6; Bffc6: $form = $this->createForm("\x41\x70\x70\x5c\x46\x6f\x72\155\x5c\123\x69\164\x65\104\157\x6d\x61\x69\x6e\x53\145\x74\x74\x69\156\147\x73\124\x79\160\145", $data, ["\141\143\164\x69\157\156" => $this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\x65\137\x73\145\164\164\151\156\x67\x73", ["\144\x6f\155\x61\x69\x6e\116\x61\x6d\145" => $site->getDomainName()]), "\155\x65\x74\x68\x6f\144" => "\x50\117\123\124", "\x61\x74\x74\162" => []]); goto e112b; e112b: $form->add("\163\x75\142\155\151\x74", SubmitType::class, ["\x61\164\x74\162" => ["\143\154\x61\x73\163" => "\x62\x74\x6e\40\x62\164\x6e\x2d\x62\x6c\165\145\40\x62\x74\x6e\x2d\154\x67"], "\x6c\141\142\145\x6c" => "\123\x61\166\x65"]); goto ca1cb; ca1cb: return $form; goto f7afc; f7afc: } private function createSiteUserSettingsForm(Site $site, array $data) : Form { goto Fcb28; D410e: return $form; goto d33ee; f010b: $form->add("\x73\x75\142\x6d\151\x74", SubmitType::class, ["\x61\164\x74\162" => ["\143\x6c\141\163\163" => "\142\164\x6e\x20\x62\164\156\55\x62\154\165\x65\40\142\x74\156\x2d\x6c\x67"], "\154\x61\142\145\154" => "\x53\x61\166\x65"]); goto D410e; Fcb28: $form = $this->createForm("\x41\x70\160\x5c\x46\x6f\x72\155\x5c\123\x69\164\x65\125\x73\145\x72\123\145\x74\164\151\156\x67\x73\124\171\x70\x65", $data, ["\x61\x63\164\x69\157\156" => $this->generateUrl("\143\x6c\x70\137\163\151\164\145\x5f\x73\x65\164\164\151\156\x67\163", ["\x64\157\155\x61\151\156\x4e\141\x6d\x65" => $site->getDomainName()]), "\155\x65\164\x68\x6f\144" => "\120\x4f\x53\124", "\x61\x74\164\x72" => []]); goto f010b; d33ee: } private function createPageSpeedSettingsForm(Site $site, array $data) : Form { goto A2aac; B7895: $form->add("\163\x75\142\155\x69\x74", SubmitType::class, ["\141\x74\164\162" => ["\143\x6c\x61\x73\x73" => "\142\x74\156\40\142\164\156\55\x62\x6c\165\145\x20\x62\164\x6e\x2d\x6c\x67"], "\x6c\x61\x62\x65\x6c" => "\123\141\x76\145"]); goto c3ba6; c3ba6: return $form; goto D0d61; A2aac: $form = $this->createForm("\101\x70\160\134\106\x6f\162\x6d\x5c\x53\x69\164\145\x50\141\147\145\123\160\145\145\x64\x53\145\x74\x74\151\156\x67\x73\x54\x79\x70\x65", $data, ["\141\143\164\x69\x6f\156" => $this->generateUrl("\x63\x6c\160\x5f\x73\x69\164\145\137\x73\145\164\x74\x69\156\147\x73", ["\144\x6f\155\141\151\x6e\x4e\141\x6d\145" => $site->getDomainName()]), "\x6d\145\164\x68\x6f\x64" => "\x50\x4f\x53\x54", "\141\x74\x74\x72" => []]); goto B7895; D0d61: } private function createNodejsSettingsForm(Site $site, NodejsSettings $nodejsSettings) : Form { goto f9800; f9800: $form = $this->createForm("\x41\160\x70\134\x46\x6f\x72\155\x5c\x53\x69\x74\x65\116\157\x64\145\x6a\x73\123\145\x74\164\x69\x6e\147\163\124\x79\160\145", $nodejsSettings, ["\141\143\164\x69\157\156" => $this->generateUrl("\x63\154\160\x5f\x73\151\164\x65\x5f\163\x65\x74\164\x69\156\147\x73", ["\144\x6f\155\141\151\156\116\x61\x6d\145" => $site->getDomainName()]), "\155\145\x74\150\157\144" => "\x50\117\x53\124", "\x61\164\x74\162" => ["\151\144" => "\156\x6f\144\145\152\x73\55\x73\145\164\164\151\x6e\x67\x73\x2d\x66\157\162\x6d"]]); goto f477c; Bc415: return $form; goto Cd605; f477c: $form->add("\x73\165\142\x6d\151\x74", SubmitType::class, ["\141\x74\x74\x72" => ["\143\154\141\x73\x73" => "\x62\164\156\40\x62\164\156\55\x62\154\x75\x65\x20\142\164\156\x2d\154\x67"], "\154\141\142\x65\x6c" => "\123\141\x76\145"]); goto Bc415; Cd605: } private function createPhpSettingsForm(Site $site, PhpSettings $phpSettings) : Form { goto be805; a5f9b: return $form; goto E6f02; D1b74: $form->add("\x73\x75\x62\155\x69\164", SubmitType::class, ["\141\164\x74\162" => ["\x63\x6c\x61\163\163" => "\x62\164\156\x20\x62\x74\x6e\55\x62\154\x75\x65\x20\142\x74\x6e\55\x6c\147"], "\x6c\x61\142\x65\154" => "\123\x61\x76\x65"]); goto a5f9b; be805: $form = $this->createForm("\101\160\x70\134\x46\x6f\x72\x6d\x5c\x53\x69\164\145\120\150\x70\x53\145\164\x74\151\156\147\x73\x54\171\x70\145", $phpSettings, ["\141\143\164\151\157\x6e" => $this->generateUrl("\x63\154\x70\137\163\x69\164\x65\137\x73\145\164\x74\151\x6e\147\x73", ["\x64\157\x6d\141\x69\156\x4e\141\x6d\x65" => $site->getDomainName()]), "\x6d\x65\164\150\x6f\144" => "\120\x4f\123\x54", "\141\x74\164\162" => []]); goto D1b74; E6f02: } private function createPythonSettingsForm(Site $site, PythonSettings $pythonSettings) : Form { goto c54c2; Ccc6d: $form->add("\163\x75\142\155\151\164", SubmitType::class, ["\141\164\x74\162" => ["\143\154\141\x73\x73" => "\x62\x74\156\x20\142\x74\156\55\x62\x6c\x75\x65\40\142\x74\156\x2d\154\x67"], "\x6c\x61\142\x65\x6c" => "\123\141\166\x65"]); goto efe84; c54c2: $form = $this->createForm("\x41\160\x70\134\x46\x6f\162\155\134\123\151\x74\145\120\x79\164\150\157\156\x53\x65\x74\164\x69\156\147\x73\124\x79\160\x65", $pythonSettings, ["\x61\x63\x74\151\x6f\156" => $this->generateUrl("\143\154\160\x5f\163\x69\x74\145\137\163\145\164\164\151\156\147\x73", ["\144\157\155\141\151\x6e\116\141\x6d\145" => $site->getDomainName()]), "\155\x65\164\150\x6f\144" => "\x50\x4f\x53\x54", "\x61\164\164\162" => []]); goto Ccc6d; efe84: return $form; goto da6bd; da6bd: } private function createSiteDeleteForm(Site $site, array $data) : Form { goto D33e3; e1bc7: return $form; goto be5d2; Fa170: $form->add("\x73\x75\x62\x6d\151\164", SubmitType::class, ["\141\x74\x74\x72" => ["\x63\154\141\x73\x73" => "\x62\164\x6e\x20\142\164\156\x2d\x62\x6c\x75\145\40\x62\164\156\55\x6c\147", "\144\x69\x73\x61\142\154\x65\x64" => "\144\x69\x73\141\142\x6c\x65\144"], "\x6c\x61\142\145\154" => "\x44\x65\154\x65\164\145\40\123\x69\x74\x65"]); goto e1bc7; D33e3: $form = $this->createForm("\x41\x70\160\134\106\157\162\155\x5c\123\x69\x74\145\104\x65\x6c\x65\164\145\124\171\x70\x65", $data, ["\x61\x63\x74\151\x6f\156" => $this->generateUrl("\x63\x6c\x70\137\163\x69\164\145\137\163\x65\x74\x74\151\x6e\147\163", ["\x64\x6f\155\141\151\156\x4e\x61\155\145" => $site->getDomainName()]), "\155\x65\164\x68\157\x64" => "\x50\117\x53\x54", "\x61\164\164\x72" => []]); goto Fa170; be5d2: } private function handleDomainSettingsForm(Request $request, Form $form, Site $site) { goto C2e27; e4acc: $this->formErrors = $this->getErrorMessages($form); goto Bc8bc; d922a: try { goto e67cf; cb05a: $session = $request->getSession(); goto D0da1; f6148: $eventData = ["\x73\151\x74\145" => $domainName, "\x72\x6f\157\164\x44\151\162\x65\143\164\157\x72\171" => $rootDirectory]; goto Cb312; d630a: $rootDirectory = rtrim($form->get("\162\x6f\x6f\164\x44\x69\x72\145\x63\164\157\162\171")->getData(), "\x2f"); goto Bcb1b; F0eb0: $siteUpdater = $this->getSiteUpdater($site); goto C825f; Ea66b: $siteEntity = $this->getSiteEntity($domainName); goto d3886; C825f: $siteUpdater->domainSettings(); goto f6148; D0da1: $domainName = $site->getDomainName(); goto Ea66b; d2792: $this->siteEntityManager->updateEntity($siteEntity); goto F0eb0; b9a6d: ade01: goto E85f4; d3886: if (!(false === is_null($siteEntity))) { goto ade01; } goto d630a; Cb312: EventQueue::addEvent(EventQueue::EVENT_SITE_ROOT_DIRECTORY_UPDATE, $user, $eventData, $request); goto E5e5b; e67cf: $user = $this->getUser(); goto cb05a; Bcb1b: $site->setRootDirectory($rootDirectory); goto C6f91; C6f91: $siteEntity->setRootDirectory($rootDirectory); goto d2792; c1ca3: return $response; goto Ce87e; E5e5b: $session->getFlashBag()->set("\x73\165\x63\x63\x65\163\163", $this->translator->trans("\122\x6f\157\x74\x20\x44\x69\x72\145\x63\164\157\x72\171\40\150\141\x73\40\x62\145\x65\x6e\x20\163\x61\166\145\x64\56")); goto b9a6d; E85f4: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\151\164\x65\x5f\163\x65\164\164\x69\x6e\x67\163", ["\x64\157\x6d\141\151\156\116\141\x6d\145" => $site->getDomainName()])); goto c1ca3; Ce87e: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\145\x72", $this->translator->trans("\101\156\40\145\162\162\x6f\162\40\x68\x61\x73\40\157\143\143\165\x72\162\x65\144\54\40\145\162\162\157\162\40\155\145\x73\x73\141\147\145\72\40\45\x65\162\x72\x6f\162\115\145\x73\x73\141\147\145\x25", ["\x25\145\162\x72\x6f\x72\x4d\145\163\163\x61\x67\145\x25" => $e->getMessage()])); } goto df29c; df29c: a5583: goto cae6c; Bc8bc: goto a5583; goto d1f3e; d1f3e: F6367: goto d922a; C2e27: if (true === $form->isValid()) { goto F6367; } goto e4acc; cae6c: } private function handleSiteUserSettingsForm(Request $request, Form $form, Site $site) { goto b87fc; D730c: goto e166a; goto E2d95; aed2b: e166a: goto ec5f7; E33a2: try { goto C7909; cb729: $eventData = ["\x73\x69\x74\x65" => $domainName, "\x73\163\x68\113\x65\171\163" => $sshKeys]; goto Db861; Db8d5: $sshKeys = trim($form->get("\163\163\150\x4b\145\x79\163")->getData()); goto E0024; B74cd: da5e0: goto Ac3c6; E741a: $siteUser = $site->getUser(); goto Db8d5; E5e63: $siteEntity = $this->getSiteEntity($domainName); goto B176f; C7909: $user = $this->getUser(); goto Bb885; a497e: return $response; goto bd8cd; B176f: if (!(false === is_null($siteEntity))) { goto da5e0; } goto E741a; Bb885: $session = $request->getSession(); goto f0d81; C1343: $session->getFlashBag()->set("\x73\x75\143\x63\145\x73\163", $this->translator->trans("\x53\151\164\145\x20\x55\x73\x65\x72\40\123\145\x74\164\x69\156\147\163\x20\150\141\166\145\x20\x62\x65\x65\156\40\163\x61\x76\x65\144\56")); goto B74cd; Ed355: $siteEntity->setSshKeys($sshKeys); goto Cddee; E0024: $password = trim($form->get("\160\x61\x73\x73\x77\157\162\x64")->getData()); goto Ed355; Ac3c6: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\x74\x65\137\x73\x65\x74\x74\151\156\x67\163", ["\144\157\x6d\141\x69\156\x4e\x61\x6d\145" => $site->getDomainName()])); goto a497e; ad271: $siteUpdater = $this->getSiteUpdater($site); goto b6256; f0d81: $domainName = $site->getDomainName(); goto E5e63; Db861: EventQueue::addEvent(EventQueue::EVENT_SITE_USER_SETTINGS_UPDATE, $user, $eventData, $request); goto C1343; ce77c: if (!(false === empty($password))) { goto B8fc5; } goto b1a75; Cddee: $this->siteEntityManager->updateEntity($siteEntity); goto ad271; b1a75: $siteUpdater->changeUserPassword($siteUser, $password); goto d9318; b6256: $siteUpdater->updateUserSShKeys($siteUser, $sshKeys); goto ce77c; d9318: B8fc5: goto cb729; bd8cd: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\x65\x72", $this->translator->trans("\101\x6e\x20\x65\x72\162\x6f\x72\x20\150\141\163\x20\x6f\143\143\165\162\162\x65\144\54\x20\x65\x72\162\157\162\x20\x6d\145\x73\163\141\x67\x65\x3a\40\45\x65\162\162\x6f\162\x4d\145\x73\x73\x61\147\145\x25", ["\45\145\x72\x72\x6f\162\x4d\x65\163\x73\x61\x67\145\x25" => $e->getMessage()])); } goto aed2b; bf33f: $this->formErrors = $this->getErrorMessages($form); goto D730c; b87fc: if (true === $form->isValid()) { goto Aa15f; } goto bf33f; E2d95: Aa15f: goto E33a2; ec5f7: } private function handlePageSpeedSettingsForm(Request $request, Form $form, Site $site) { goto edeb0; Bf680: try { goto Eca77; De380: $session->getFlashBag()->set("\163\x75\x63\143\x65\x73\163", $this->translator->trans("\120\141\147\x65\x20\x53\x70\x65\145\x64\x20\x53\145\164\x74\151\x6e\x67\163\40\150\141\x76\x65\40\142\x65\145\156\x20\x73\141\166\x65\x64\56")); goto D94c2; Ad336: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\163\x69\x74\145\x5f\x73\x65\x74\x74\151\156\147\x73", ["\144\x6f\x6d\141\151\156\x4e\141\155\145" => $site->getDomainName()])); goto ad4b0; f1a0f: $site->setPageSpeedSettings($settings); goto Bfd3a; D94c2: d6739: goto Ad336; B494d: $settings = trim($form->get("\163\145\164\x74\151\x6e\x67\163")->getData()); goto f2f3e; e47a4: $session = $request->getSession(); goto A8ec7; ad4b0: return $response; goto D19ef; Df2cd: if (!(false === is_null($siteEntity))) { goto d6739; } goto de888; fbdc3: $siteUpdater->purgePageSpeedCache(); goto a3d90; Cf970: $siteUpdater->updateNginxVhostWithRollback(); goto fbdc3; ac219: $siteEntity = $this->getSiteEntity($domainName); goto Df2cd; F3186: EventQueue::addEvent(EventQueue::EVENT_SITE_PAGE_SPEED_SETTINGS_UPDATE, $user, $eventData, $request); goto De380; ef5cc: $this->siteEntityManager->updateEntity($siteEntity); goto C51b6; a3d90: $siteEntity->setPageSpeedEnabled($isEnabled); goto e3036; Bfd3a: $siteUpdater = $this->getSiteUpdater($site); goto Cf970; e3036: $siteEntity->setPageSpeedSettings($settings); goto ef5cc; de888: $isEnabled = $form->get("\151\x73\105\156\x61\x62\154\x65\x64")->getData(); goto B494d; A8ec7: $domainName = $site->getDomainName(); goto ac219; C51b6: $eventData = ["\x73\151\164\145" => $domainName, "\160\141\147\145\123\x70\145\x65\x64\105\x6e\x61\142\154\145\x64" => $isEnabled, "\x70\141\147\145\123\160\145\x65\x64\123\145\164\164\151\x6e\147\x73" => $settings]; goto F3186; Eca77: $user = $this->getUser(); goto e47a4; f2f3e: $site->setPageSpeedEnabled($isEnabled); goto f1a0f; D19ef: } catch (InvalidVhostException $e) { $session->getFlashBag()->set("\x64\141\156\x67\x65\x72", $this->translator->trans("\x50\x61\147\145\123\160\145\145\x64\x20\x53\x65\164\164\151\156\147\40\x61\162\x65\40\156\157\x74\40\x76\x61\154\x69\144\x2c\40\145\162\162\x6f\162\x20\155\x65\163\163\141\147\x65\x3a\x20\x25\x65\x72\x72\157\162\115\x65\x73\x73\x61\147\145\x25", ["\x25\145\162\162\x6f\x72\x4d\x65\163\x73\x61\147\145\x25" => $e->getMessage()])); } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\x67\145\162", $this->translator->trans("\101\x6e\40\145\x72\162\157\162\x20\150\141\x73\40\157\x63\143\x75\162\x72\145\144\54\40\145\x72\162\157\162\40\x6d\145\163\163\x61\147\145\x3a\40\x25\x65\x72\x72\x6f\162\115\x65\163\163\x61\147\x65\x25", ["\x25\145\x72\162\157\162\115\145\163\163\x61\147\145\x25" => $e->getMessage()])); } goto e19b8; F0676: D2f5b: goto Bf680; e19b8: Ca940: goto A8f3e; edeb0: if (true === $form->isValid()) { goto D2f5b; } goto Fb4a1; Fb4a1: $this->formErrors = $this->getErrorMessages($form); goto efa0f; efa0f: goto Ca940; goto F0676; A8f3e: } private function handleSiteDeleteForm(Request $request, Form $form, Site $site) { goto d2862; d2862: if (true === $form->isValid()) { goto bf20e; } goto b219e; c389d: De818: goto C62af; a416b: try { goto F2c61; F2c61: $user = $this->getUser(); goto C8bbb; D1c69: $eventData = ["\x73\151\164\x65" => $domainName, "\164\x79\160\x65" => $site->getType()]; goto d393b; ccb0a: $this->siteEntityManager->deleteEntity($siteEntity); goto D1c69; b042d: $siteDeleter = $this->getSiteDeleter($site); goto Dca88; Dca88: $siteDeleter->delete(); goto ccb0a; f274a: $siteEntity = $this->getSiteEntity($domainName); goto f726f; B7597: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\151\x74\145\163")); goto fb8a1; C8bbb: $session = $request->getSession(); goto Ac50d; Ac50d: $domainName = $site->getDomainName(); goto f274a; fb8a1: return $response; goto e0947; d29c5: $session->getFlashBag()->set("\x73\165\143\143\x65\x73\x73", $this->translator->trans("\x53\151\164\145\40\x68\141\163\x20\x62\145\x65\156\x20\x64\x65\x6c\145\164\145\x64\x2e")); goto df3cf; df3cf: B0b48: goto B7597; d393b: EventQueue::addEvent(EventQueue::EVENT_SITE_DELETE, $user, $eventData, $request); goto d29c5; f726f: if (!(false === is_null($siteEntity))) { goto B0b48; } goto b042d; e0947: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\145\x72", $this->translator->trans("\101\x6e\40\x65\x72\x72\x6f\x72\x20\150\141\163\x20\157\x63\143\x75\x72\x72\x65\x64\54\x20\145\x72\x72\157\162\x20\x6d\145\x73\x73\141\147\145\72\x20\x25\x65\x72\x72\x6f\x72\x4d\145\x73\x73\141\147\x65\x25", ["\45\145\162\x72\157\x72\x4d\145\163\x73\141\x67\x65\45" => $e->getMessage()])); } goto c389d; b219e: $this->formErrors = $this->getErrorMessages($form); goto F4cb3; Eca3f: bf20e: goto a416b; F4cb3: goto De818; goto Eca3f; C62af: } private function handleNodejsSettingsForm(Request $request, Form $form, NodejsSettings $currentNodejsSettings, Site $site) { goto C204b; Eabcc: goto E4611; goto Ee116; Ee116: eb9b8: goto c78fa; Deaa4: E4611: goto C0d1c; c78fa: try { goto F7c35; cf165: return $response; goto Aae79; ba1c7: if (!(true === $hasNodejsVersionChanged)) { goto c521c; } goto Ccd6b; F7c35: $user = $this->getUser(); goto F9ad5; b67b9: $domainName = $site->getDomainName(); goto E9700; Ccd6b: $siteUpdater->installNodejsVersion(); goto e9dc9; ccae2: $siteUpdater->nodejsSettings(); goto B2a16; d0b3a: $hasNodejsVersionChanged = $currentNodejsSettings->getNodejsVersion() != $nodejsVersion; goto D2483; B70f3: $nodejsVersion = $nodejsSettings->getNodejsVersion(); goto d0b3a; ecd32: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\x69\164\x65\x5f\163\x65\x74\x74\x69\x6e\147\163", ["\144\157\155\x61\151\156\x4e\x61\155\145" => $site->getDomainName()])); goto cf165; e15c7: d4380: goto ecd32; D2483: $siteUpdater = $this->getSiteUpdater($site); goto ba1c7; B2a16: $this->siteEntityManager->updateEntity($siteEntity); goto F4e85; F9ad5: $session = $request->getSession(); goto b67b9; F4e85: $eventData = ["\163\151\164\x65" => $domainName, "\156\x6f\x64\x65\x6a\x73\126\x65\162\x73\151\157\x6e" => $nodejsVersion, "\x70\x6f\x72\164" => $nodejsSettings->getPort()]; goto E26fd; f2404: $session->getFlashBag()->set("\x73\x75\143\143\145\163\x73", $this->translator->trans("\x4e\x6f\x64\145\x2e\x6a\163\x20\123\145\x74\164\151\156\x67\163\40\150\x61\166\145\x20\x62\x65\145\x6e\x20\163\x61\x76\x65\x64\x2e")); goto e15c7; e9dc9: c521c: goto ccae2; E9700: $siteEntity = $this->getSiteEntity($domainName); goto af299; af299: if (!(false === is_null($siteEntity))) { goto d4380; } goto Bd469; Bd469: $nodejsSettings = $form->getData(); goto B70f3; E26fd: EventQueue::addEvent(EventQueue::EVENT_SITE_NODEJS_SETTINGS_UPDATE, $user, $eventData, $request); goto f2404; Aae79: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\x65\x72", $this->translator->trans("\101\x6e\x20\x65\x72\162\x6f\x72\x20\150\x61\x73\x20\157\x63\x63\x75\x72\162\x65\144\54\x20\x65\x72\x72\157\162\40\x6d\x65\163\163\141\x67\x65\72\40\x25\x65\x72\x72\x6f\162\115\x65\x73\163\141\147\x65\x25", ["\x25\145\162\x72\x6f\x72\x4d\x65\163\163\x61\147\145\45" => $e->getMessage()])); } goto Deaa4; debbc: $this->formErrors = $this->getErrorMessages($form); goto Eabcc; C204b: if (true === $form->isValid()) { goto eb9b8; } goto debbc; C0d1c: } private function handlePythonSettingsForm(Request $request, Form $form, Site $site) { goto f6ee7; a5ddf: try { goto b39c7; ce7ff: $siteUpdater->pythonSettings(); goto E6062; D2815: EventQueue::addEvent(EventQueue::EVENT_SITE_PYTHON_SETTINGS_UPDATE, $user, $eventData, $request); goto A919c; ed680: $session = $request->getSession(); goto c1a34; c1a34: $domainName = $site->getDomainName(); goto C9d4a; B8855: $siteUpdater = $this->getSiteUpdater($site); goto E94fd; C9d4a: $siteEntity = $this->getSiteEntity($domainName); goto ad2ae; E6062: $this->siteEntityManager->updateEntity($siteEntity); goto E6ac9; A919c: $session->getFlashBag()->set("\163\x75\x63\143\145\x73\163", $this->translator->trans("\120\171\164\150\157\156\40\x53\145\x74\x74\x69\156\147\x73\40\150\141\x76\145\x20\x62\x65\145\x6e\x20\163\x61\x76\145\x64\56")); goto Bdb74; a9f4b: return $response; goto e4446; Cc3a0: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\163\x69\164\145\137\x73\x65\164\x74\151\x6e\x67\163", ["\144\157\155\x61\151\156\116\141\155\145" => $site->getDomainName()])); goto a9f4b; b39c7: $user = $this->getUser(); goto ed680; E6ac9: $eventData = ["\163\151\x74\145" => $domainName, "\160\171\x74\x68\x6f\x6e\x56\145\x72\163\x69\157\156" => $pythonVersion, "\x70\157\162\x74" => $pythonSettings->getPort()]; goto D2815; Be52d: $pythonSettings = $form->getData(); goto e2a97; e2a97: $pythonVersion = $pythonSettings->getPythonVersion(); goto B8855; E94fd: $siteUpdater->writePythonVersionFile(); goto ce7ff; ad2ae: if (!(false === is_null($siteEntity))) { goto D5777; } goto Be52d; Bdb74: D5777: goto Cc3a0; e4446: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\145\x72", $this->translator->trans("\x41\x6e\40\145\x72\x72\x6f\162\40\150\x61\x73\40\157\x63\143\165\162\162\145\144\x2c\40\x65\162\162\x6f\162\40\x6d\145\163\163\x61\x67\x65\72\x20\x25\145\x72\162\x6f\162\115\x65\x73\x73\141\147\x65\x25", ["\x25\x65\x72\162\x6f\162\x4d\145\163\163\x61\147\x65\45" => $e->getMessage()])); } goto bc696; a0847: $this->formErrors = $this->getErrorMessages($form); goto A91f7; A91f7: goto Cf237; goto f1299; bc696: Cf237: goto cd1bd; f1299: A1b0f: goto a5ddf; f6ee7: if (true === $form->isValid()) { goto A1b0f; } goto a0847; cd1bd: } private function handlePhpSettingsForm(Request $request, Form $form, PhpSettings $currentPhpSettings, Site $site) { goto eb9fd; F0575: F6bcd: goto B3c36; Bfc4e: goto F6bcd; goto b1d42; b1d42: c74ae: goto E6df1; eb9fd: if (true === $form->isValid()) { goto c74ae; } goto e9d1b; e9d1b: $this->formErrors = $this->getErrorMessages($form); goto Bfc4e; E6df1: try { goto a0bfb; A46bf: $siteUpdater->phpSettings(); goto B60da; a0bfb: $user = $this->getUser(); goto e4d73; B982f: B57d6: goto A46bf; c7f7b: if (!(true === $hasPhpVersionChanged)) { goto B57d6; } goto b6047; e4d73: $session = $request->getSession(); goto cbffa; d09c7: $hasPhpVersionChanged = $currentPhpSettings->getPhpVersion() != $phpSettings->getPhpVersion(); goto B5c97; Db15e: $eventData = ["\x73\151\164\x65" => $domainName, "\160\x68\160\x56\145\x72\163\151\x6f\x6e" => $phpSettings->getPhpVersion(), "\x6d\x65\155\157\162\x79\x5f\154\151\x6d\x69\164" => $phpSettings->getMemoryLimit(), "\155\x61\x78\x5f\x65\170\x65\x63\x75\x74\x69\157\x6e\137\164\151\x6d\x65" => $phpSettings->getMaxExecutionTime(), "\x6d\141\170\x5f\x69\x6e\x70\x75\164\137\164\x69\155\x65" => $phpSettings->getMaxInputTime(), "\x6d\x61\170\x5f\x69\x6e\x70\x75\x74\x5f\166\141\x72\163" => $phpSettings->getMaxInputVars(), "\x70\157\x73\x74\x5f\x6d\141\x78\x5f\x73\x69\172\x65" => $phpSettings->getPostMaxSize(), "\165\x70\x6c\x6f\x61\144\x5f\155\x61\x78\137\146\151\x6c\145\x73\x69\x7a\x65" => $phpSettings->getUploadMaxFileSize()]; goto baeb3; baeb3: EventQueue::addEvent(EventQueue::EVENT_SITE_PHP_SETTINGS_UPDATE, $user, $eventData, $request); goto E26ee; A8df3: $siteEntity = $this->getSiteEntity($domainName); goto E106a; E26ee: $session->getFlashBag()->set("\163\x75\x63\x63\145\x73\163", $this->translator->trans("\120\x48\120\40\x53\x65\164\x74\x69\x6e\147\163\40\x68\x61\166\x65\40\x62\x65\x65\156\x20\163\x61\166\x65\144\x2e")); goto c4738; c8d97: $phpSettings = $form->getData(); goto d09c7; E106a: if (!(false === is_null($siteEntity))) { goto ad9d4; } goto c8d97; Bc806: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x73\x69\164\145\137\x73\x65\x74\164\x69\156\x67\x73", ["\x64\157\x6d\x61\x69\156\116\141\155\145" => $site->getDomainName()])); goto Be37b; cbffa: $domainName = $site->getDomainName(); goto A8df3; B60da: $this->siteEntityManager->updateEntity($siteEntity); goto Db15e; b6047: $siteUpdater->changePhpVersion($currentPhpSettings->getPhpVersion(), $phpSettings->getPhpVersion()); goto B982f; c4738: ad9d4: goto Bc806; B5c97: $siteUpdater = $this->getSiteUpdater($site); goto c7f7b; Be37b: return $response; goto Ce9f9; Ce9f9: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\145\162", $this->translator->trans("\x41\156\40\x65\162\162\x6f\162\x20\x68\x61\x73\x20\x6f\x63\143\x75\x72\x72\145\144\54\x20\x65\162\x72\157\x72\40\x6d\x65\x73\163\141\147\x65\72\40\x25\x65\x72\162\x6f\162\115\145\x73\163\x61\147\145\45", ["\x25\145\162\162\x6f\162\115\145\163\x73\141\x67\x65\45" => $e->getMessage()])); } goto F0575; B3c36: } private function getSite(Request $request) : ?Site { goto Ec297; c011f: $site->setDomainName($siteEntity->getDomainName()); goto ac19c; Cd5c1: $site->setBasicAuth($siteEntity->getBasicAuth()); goto eb559; eb559: $site->setBlockedBots($siteEntity->getBlockedBots()); goto f5a59; ceed9: $site->setSubdomain($subdomain); goto a035e; C6e92: Dd626: goto c434c; cfe7f: $site->setFtpUsers($siteEntity->getFtpUsers()); goto a1bc2; B8298: $site->setPageSpeedEnabled($siteEntity->getPageSpeedEnabled()); goto f29f1; a8ac6: e46c4: goto C6e92; e6ff7: if (!(false === is_null($site))) { goto e46c4; } goto fc7ad; ebb94: $site->setVhostTemplate($siteEntity->getVhostTemplate()); goto B0fe0; f5a59: $site->setBlockedIps($siteEntity->getBlockedIps()); goto fcb7f; bfee6: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto C75a6; C75a6: $site = new NodejsSite(); goto Fcee3; Cf0ec: goto dcdea; goto efa2a; Fcee3: $site->setNodejsSettings($siteEntity->getNodejsSettings()); goto Cf0ec; efa2a: case SiteEntity::TYPE_STATIC: $site = new StaticSite(); goto dcdea; case SiteEntity::TYPE_PHP: goto F2fa6; F2fa6: $site = new PhpSite(); goto aca1b; D8b8f: goto dcdea; goto B3e7f; aca1b: $site->setPhpSettings($siteEntity->getPhpSettings()); goto D8b8f; B3e7f: case SiteEntity::TYPE_PYTHON: goto B110f; Eca2a: goto dcdea; goto Ede7f; E99f9: $site->setPythonSettings($siteEntity->getPythonSettings()); goto Eca2a; B110f: $site = new PythonSite(); goto E99f9; Ede7f: } goto D6928; a1bc2: $site->setSshUsers($siteEntity->getSshUsers()); goto c5ca1; Ec297: $user = $this->getUser(); goto d777a; B0fe0: $site->setAllowTrafficFromCloudflareOnly($siteEntity->allowTrafficFromCloudflareOnly()); goto B8298; c5ca1: $site->setSshKeys($siteEntity->getSshKeys()); goto ebb94; bcf7c: $site->setCertificates($siteEntity->getCertificates()); goto Ee145; C8824: $siteEntity = $this->getSiteEntity($domainName); goto b513a; ac19c: $site->setRegistrableDomain($registrableDomain); goto ceed9; D6928: Cadcd: goto F11b6; F11b6: dcdea: goto e6ff7; edfd6: $subdomain = $resolvedDomainName->subDomain()->toString(); goto b476d; fc7ad: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto be993; bf1ea: $site->setUser($siteEntity->getUser()); goto c011f; dcd2b: $siteType = $siteEntity->getType(); goto bfee6; d2948: if (!(false === is_null($siteEntity))) { goto Dd626; } goto Bfdbf; a4a57: $siteDatabases = $this->getSiteDatabases($siteEntity); goto bf1ea; fcb7f: $site->setDatabases($siteDatabases); goto D66b6; C9fac: Fc244: goto dcd2b; Ee145: $site->setCronJobs($siteEntity->getCronJobs()); goto cfe7f; c434c: return $site; goto A8c89; a035e: $site->setRootDirectory($siteEntity->getRootDirectory()); goto Cd5c1; b476d: $subdomain = false === empty($subdomain) ? $subdomain : null; goto a4a57; be993: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto edfd6; D66b6: $site->setCertificate($siteEntity->getCertificate()); goto bcf7c; f29f1: $site->setPageSpeedSettings($siteEntity->getPageSpeedSettings()); goto a8ac6; Bfdbf: if (!(UserEntity::ROLE_USER == $user->getRole() && false === $user->hasSite($siteEntity))) { goto Fc244; } goto Ddb7e; b513a: $site = null; goto d2948; d777a: $domainName = $request->get("\144\157\x6d\141\x69\156\116\141\x6d\x65"); goto C8824; Ddb7e: return null; goto C9fac; A8c89: } private function getSiteDatabases(SiteEntity $siteEntity) : ?ArrayCollection { goto B42e9; Aa39d: return $siteDatabases; goto ddca8; Adc8d: foreach ($databaseEntities as $databaseEntity) { goto D0fad; D0fad: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto d8973; F4e10: B87c1: goto db982; d8973: if (!($databaseServerEntity->getId() == $activeDatabaseServerEntity->getId())) { goto B87c1; } goto Db26a; db982: b9467: goto D55df; Db26a: $siteDatabases->add($databaseEntity); goto F4e10; D55df: } goto Bdd37; F12b8: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto Da093; B42e9: $siteDatabases = new ArrayCollection(); goto F12b8; Bdd37: a1bf7: goto Aa39d; Da093: $databaseEntities = $siteEntity->getDatabases(); goto Adc8d; ddca8: } private function getSiteUpdater(Site $site) : ?SiteUpdater { goto fd74e; fd74e: $siteUpdater = null; goto D80e1; B314c: return $siteUpdater; goto Fa833; c2933: ed7f5: goto a3a44; fce7e: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteUpdater = new NodejsSiteUpdater($site); goto E1ecd; case SiteEntity::TYPE_STATIC: $siteUpdater = new StaticSiteUpdater($site); goto E1ecd; case SiteEntity::TYPE_PHP: $siteUpdater = new PhpSiteUpdater($site); goto E1ecd; case SiteEntity::TYPE_PYTHON: $siteUpdater = new PythonSiteUpdater($site); goto E1ecd; } goto c2933; a3a44: E1ecd: goto B314c; D80e1: $siteType = $site->getType(); goto fce7e; Fa833: } protected function getSiteDeleter(Site $site) : ?SiteDeleter { goto f53a0; B208e: D0136: goto B12ee; Ebbe4: $siteType = $site->getType(); goto a4187; f29fa: Fbb30: goto B208e; f53a0: $siteDeleter = null; goto Ebbe4; B12ee: return $siteDeleter; goto E46e9; a4187: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteDeleter = new NodejsSiteDeleter($site); goto D0136; case SiteEntity::TYPE_STATIC: $siteDeleter = new StaticSiteDeleter($site); goto D0136; case SiteEntity::TYPE_PHP: $siteDeleter = new PhpSiteDeleter($site); goto D0136; case SiteEntity::TYPE_PYTHON: $siteDeleter = new PythonSiteDeleter($site); goto D0136; } goto f29fa; E46e9: } private function getSiteEntity(string $domainName) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByDomainName($domainName); return $siteEntity; } }
