<?php
 namespace App\EventListener; use Symfony\Component\HttpKernel\Event\RequestEvent; use Symfony\Component\EventDispatcher\EventSubscriberInterface; use Symfony\Component\Console\Event\ConsoleCommandEvent; use Symfony\Component\HttpKernel\KernelEvents; use Symfony\Component\Console\ConsoleEvents; use Twig\Environment as TwigEnvironment; use App\Entity\Manager\ConfigManager; use App\Entity\Manager\UserManager; use App\Entity\Manager\DatabaseServerManager; use App\Command\Command; use App\Util\PasswordGenerator; use App\CloudPanel\Environment as CloudPanelEnvironment; use App\CloudPanel\Aws\Instance as AwsInstance; use App\CloudPanel\Do\Instance as DoInstance; use App\CloudPanel\Gce\Instance as GceInstance; use App\CloudPanel\Hetzner\Instance as HetznerInstance; use App\CloudPanel\Vultr\Instance as VultrInstance; use App\CloudPanel\Instance; use App\Do\Client as DoClient; use App\Gce\Client as GceClient; use App\Hetzner\Client as HetznerClient; use App\Vultr\Client as VultrClient; use App\System\CommandExecutor; use App\System\Command\ChangeDatabaseUserPasswordCommand; use App\Entity\DatabaseServer; use App\Service\Crypto; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Database\Connection as DatabaseConnection; class InitializeListener implements EventSubscriberInterface { private ConfigManager $configManager; private DatabaseServerManager $databaseServerManager; private UserManager $userManager; private TwigEnvironment $twig; public function __construct(ConfigManager $configManager, DatabaseServerManager $databaseServerManager, UserManager $userManager, TwigEnvironment $twig) { goto F24f4; beb78: $this->userManager = $userManager; goto E2c2c; E2c2c: $this->twig = $twig; goto Da80a; F24f4: $this->configManager = $configManager; goto Cb7cf; Cb7cf: $this->databaseServerManager = $databaseServerManager; goto beb78; Da80a: } public function onKernelRequest(RequestEvent $event) : void { goto f019e; c0a4d: $this->initialize($event); goto D5808; C97ff: f5a4f: goto c0a4d; f019e: if (!(false === $event->isMainRequest())) { goto f5a4f; } goto E145c; E145c: return; goto C97ff; D5808: } public function onConsoleCommand(ConsoleCommandEvent $event) : void { goto C0e4c; C0e4c: $command = $event->getCommand(); goto f51e9; C7638: $this->initialize($event); goto Bd0a0; f51e9: if (!$command instanceof Command) { goto a2263; } goto C7638; Bd0a0: a2263: goto c14c4; c14c4: } private function initialize(RequestEvent|ConsoleCommandEvent $event) : void { goto B9fbc; C5c5e: $this->setEnvironment($event); goto f7588; Fcc37: $this->setCloudPanelVersion(); goto ff83d; B9fbc: $this->setTimezone(); goto b547c; e0275: $this->setLetsEncryptPrivateKey(); goto D602d; D602d: $this->setDatabaseServer($event); goto C5c5e; ff83d: $this->setCloudPanelReleaseChannel(); goto e0275; b547c: $this->setInstanceUid(); goto Fcc37; f7588: } private function setTimezone() : void { goto Eda58; Eda58: $timezone = $this->configManager->get("\164\151\x6d\145\172\x6f\156\x65"); goto Ada6c; Ea970: a356b: goto Ed794; A8fdd: $this->configManager->set("\x74\151\155\145\172\x6f\x6e\x65", "\x55\x54\103"); goto Ea970; Ada6c: if (!(true === is_null($timezone))) { goto a356b; } goto A8fdd; Ed794: } private function setInstanceUid() : void { goto Abbf7; C51bc: $instanceUid = substr(sha1(uniqid(mt_rand(), true)), 0, 16); goto dc0e7; dc0e7: $this->configManager->set("\151\x6e\x73\164\141\156\143\145\x5f\x75\151\x64", $instanceUid); goto f81e8; f81e8: E7433: goto E74d8; Abbf7: $instanceUid = $this->configManager->get("\151\156\163\164\141\156\143\145\137\x75\151\144"); goto a1134; a1134: if (!(true === is_null($instanceUid))) { goto E7433; } goto C51bc; E74d8: } private function setCloudPanelVersion() : void { goto C4432; e1fdc: C9d24: goto d7da8; C4432: $appVersion = $_ENV["\x41\x50\x50\x5f\126\x45\x52\123\111\x4f\x4e"] ?? null; goto da3a4; Fa68f: $this->configManager->set("\x61\x70\160\x5f\x76\145\x72\x73\x69\x6f\156", trim($appVersion)); goto e1fdc; da3a4: if (!(false === is_null($appVersion))) { goto C9d24; } goto Fa68f; d7da8: } private function setCloudPanelReleaseChannel() : void { goto b2145; D84e7: if (!(true === is_null($releaseChannel))) { goto D642f; } goto b508b; b508b: $this->configManager->set("\x72\x65\154\x65\141\x73\x65\x5f\x63\x68\141\x6e\x6e\145\x6c", CloudPanelEnvironment::RELEASE_CHANNEL_STABLE); goto b1f62; b1f62: D642f: goto B89d3; b2145: $releaseChannel = $this->configManager->get("\x72\145\154\x65\x61\x73\x65\x5f\143\x68\141\x6e\x6e\145\154"); goto D84e7; B89d3: } private function setLetsEncryptPrivateKey() { goto edaef; A7e87: F4ab4: goto Decad; da0cf: $this->configManager->set("\154\145\x5f\x70\162\x69\x76\x61\x74\x65\x5f\x6b\145\171", $privateKey->getPEM()); goto A7e87; d1282: if (!(true === is_null($letsEncryptPrivateKey))) { goto F4ab4; } goto B49e1; A4eab: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto da0cf; edaef: $letsEncryptPrivateKey = $this->configManager->get("\154\145\137\x70\162\151\166\141\x74\145\137\153\x65\171"); goto d1282; B49e1: $rsaKeyGenerator = new RsaKeyGenerator(); goto A4eab; Decad: } private function setDatabaseServer(RequestEvent|ConsoleCommandEvent $event) : void { goto De9eb; B548a: $commandExecutor = new CommandExecutor(); goto ba032; D9280: $databaseServers = $this->databaseServerManager->findAll(); goto cc927; cad15: $tmpDatabaseServer = clone $databaseServer; goto a5f9e; a5f9e: $tmpDatabaseServer->setPassword("\x72\x6f\x6f\164"); goto B548a; e4cda: $databaseConnection = new DatabaseConnection($databaseServer); goto Ee1a6; a79a2: $commandExecutor->execute($changeDatabaseUserPasswordCommand); goto A9f8a; ba032: $changeDatabaseUserPasswordCommand = new ChangeDatabaseUserPasswordCommand(); goto ec117; E8130: if (!("\x64\145\x76" != $_ENV["\101\x50\x50\137\105\x4e\x56"])) { goto f9cc4; } goto cad15; E4188: $password = $passwordGenerator->generate(); goto A3cbb; cc927: if (!(0 < $numberOfUsers && 0 == count($databaseServers))) { goto f438f; } goto a3fd8; A95f0: $databaseServer->setIsDefault(true); goto e4cda; c6481: $databaseServer = $this->databaseServerManager->createEntity(); goto Cb49f; d2937: $databaseServer->setUserName("\x72\157\x6f\164"); goto c8c5f; Cb49f: $databaseServer->setHost("\x31\x32\x37\x2e\60\56\x30\x2e\x31"); goto d2937; Ee1a6: $databaseServer->setEngine($databaseConnection->getEngine()); goto b3015; a3fd8: if ("\x64\x65\x76" == $_ENV["\101\x50\x50\x5f\105\x4e\x56"]) { goto f8573; } goto A47ba; ef857: f8573: goto e5f9e; Ee63d: $this->databaseServerManager->updateEntity($databaseServer); goto fff02; b3015: $databaseServer->setVersion($databaseConnection->getVersion()); goto fd67e; A9f8a: f9cc4: goto Ee63d; Be66e: Ebc17: goto E38e8; A3cbb: goto Ebc17; goto ef857; c8c5f: $databaseServer->setPassword(Crypto::encrypt("\162\157\157\x74")); goto b59bd; E38e8: $encryptedPassword = Crypto::encrypt($password); goto c6481; fff02: f438f: goto d8c01; ec117: $changeDatabaseUserPasswordCommand->setUserName("\x72\157\157\164"); goto Cfab5; b59bd: $databaseServer->setPort(DatabaseServer::DEFAULT_PORT); goto A161f; A161f: $databaseServer->setIsActive(true); goto A95f0; f6f1e: $changeDatabaseUserPasswordCommand->setDatabaseServer($tmpDatabaseServer); goto a79a2; A47ba: $passwordGenerator = new PasswordGenerator(); goto E4188; Cfab5: $changeDatabaseUserPasswordCommand->setNewPassword($password); goto f6f1e; fd67e: $databaseServer->setPassword($encryptedPassword); goto E8130; e5f9e: $password = "\162\157\x6f\x74"; goto Be66e; De9eb: $numberOfUsers = $this->userManager->countAll(); goto D9280; d8c01: } private function setEnvironment(RequestEvent|ConsoleCommandEvent $event) : void { goto ae6da; a6185: $instance->setHostname($hostname); goto be8bb; Dd390: $instance->setIpv4PublicIp($ipv4PublicIp); goto Befbf; Ef9f4: $this->twig->addGlobal("\151\x6e\163\164\x61\156\x63\x65", $instance); goto aa693; Ca526: $instance->setEnvironment($environment); goto e8683; e5b70: switch ($cloud) { case CloudPanelEnvironment::CLOUD_PROVIDER_AWS: goto ae8af; de681: f73b9: goto F0a78; a8d96: $region = $_ENV["\x44\x45\126\x5f\101\127\x53\x5f\x52\105\107\111\x4f\116"] ?? ''; goto B512a; B512a: $instance->setInstanceId($instanceId); goto Ba083; b1830: if (!("\144\145\x76" == $_ENV["\101\120\x50\x5f\x45\x4e\x56"])) { goto f73b9; } goto B96de; B96de: $instanceId = $_ENV["\104\105\x56\137\101\127\x53\x5f\111\x4e\x53\124\101\116\x43\x45\x5f\x49\104"] ?? ''; goto a8d96; Ba083: $instance->setInstanceType("\164\x33\56\x78\154\x61\162\147\145"); goto b038b; Bc0c0: $instance = new AwsInstance(); goto b1830; F0a78: goto Ce5d8; goto B2133; b038b: $instance->setRegion($region); goto de681; ae8af: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_AWS); goto Bc0c0; B2133: case CloudPanelEnvironment::CLOUD_PROVIDER_DO: goto Caf7c; A2bcd: $dropletId = $_ENV["\104\105\x56\137\x44\117\x5f\x44\122\x4f\120\114\105\124\137\x49\x44"] ?? ''; goto b54fa; C94e6: $token = $this->configManager->get("\x64\x6f\x5f\141\x63\x63\x65\x73\163\x5f\x74\157\153\145\156"); goto a5dba; C313c: $instance->setDropletId($dropletId); goto B7483; ceb7f: $instance = new DoInstance($doClient); goto Bd207; aed94: if (!("\144\x65\x76" == $_ENV["\x41\x50\x50\137\x45\x4e\126"])) { goto Ae63e; } goto A2bcd; e86c3: $doClient->setToken($token); goto Fbcb3; Ccbb0: $instance->setFloatingIp("\x31\x32\67\56\60\56\60\x2e\x31"); goto A3d8b; Caf7c: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_DO); goto B24d6; Fbcb3: c3a5f: goto ceb7f; Bd207: $doClient->setInstance($instance); goto aed94; f3f28: goto Ce5d8; goto Acff2; a5dba: if (!(false === is_null($token))) { goto c3a5f; } goto e86c3; A3d8b: $instance->setIpv4PublicIp("\x31\62\x37\x2e\x30\x2e\x30\x2e\61"); goto Dc605; b54fa: $region = $_ENV["\104\x45\126\137\x44\117\137\122\x45\107\111\x4f\116"] ?? ''; goto C313c; B24d6: $doClient = new DoClient(); goto C94e6; Dc605: Ae63e: goto f3f28; B7483: $instance->setRegion($region); goto Ccbb0; Acff2: case CloudPanelEnvironment::CLOUD_PROVIDER_GCE: goto f8708; Ff28a: $instanceId = $_ENV["\x44\x45\x56\x5f\x47\103\x45\137\x49\116\x53\x54\x41\116\x43\x45\x5f\x49\104"] ?? ''; goto Becd7; Ada7c: $instance->setIpv4PublicIp("\61\x32\67\x2e\60\x2e\x30\x2e\x31"); goto d6391; d6391: $instance->setProjectId($projectId); goto B0787; D4ed7: $gceClient = new GceClient(); goto d210c; D73a5: $gceClient->setGceInstance($instance); goto C9da6; B0787: $instance->setInstanceId($instanceId); goto d961c; C0fe0: $gceClient->setAuthConfig($serviceAccountKeys); goto B9bff; Da7c9: $instance = new GceInstance($gceClient); goto D73a5; D88f4: $serviceAccountKeys = (array) json_decode($serviceAccountKeys, true); goto C0fe0; Becd7: $instanceName = $_ENV["\x44\x45\x56\137\x47\x43\105\x5f\111\x4e\123\124\x41\116\103\105\x5f\116\101\x4d\105"] ?? ''; goto Db9f2; d210c: $serviceAccountKeys = $this->configManager->get("\x67\143\145\x5f\x73\145\162\x76\x69\143\145\137\x61\143\x63\157\165\x6e\x74\137\153\x65\x79\163"); goto Cb36e; aacc7: $projectId = $_ENV["\104\x45\x56\137\x47\x43\x45\137\x50\122\117\112\x45\103\x54\137\111\x44"] ?? ''; goto Ff28a; cc98f: $zone = $_ENV["\104\105\x56\137\107\103\105\137\132\x4f\x4e\105"] ?? ''; goto Ada7c; fc0d3: $instance->setZone($zone); goto F5cfa; a8205: $instance->setMachineType($machineType); goto fc0d3; Db9f2: $machineType = $_ENV["\x44\105\x56\x5f\107\x43\105\x5f\115\x41\x43\110\x49\116\105\x5f\x54\x59\120\105"] ?? ''; goto cc98f; f8708: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_GCE); goto D4ed7; C9da6: if (!("\144\x65\166" == $_ENV["\x41\120\x50\137\x45\116\x56"])) { goto B8b94; } goto aacc7; fc25a: goto Ce5d8; goto Bccc9; Cb36e: if (!(false === is_null($serviceAccountKeys))) { goto Bf321; } goto D88f4; d961c: $instance->setInstanceName($instanceName); goto a8205; F5cfa: B8b94: goto fc25a; B9bff: Bf321: goto Da7c9; Bccc9: case CloudPanelEnvironment::CLOUD_PROVIDER_HETZNER: goto Fe6f6; B1e8b: $instance->setIpv4PublicIp("\x31\x32\x37\56\x30\56\x30\56\x31"); goto C1a95; Fe6f6: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_HETZNER); goto Cc656; A7b71: $hetznerClient->setInstance($instance); goto b7199; a8d3f: goto Ce5d8; goto eba6c; ff3e4: $instanceId = $_ENV["\x44\105\x56\137\x48\105\x54\x5a\116\x45\x52\x5f\x49\x4e\123\124\x41\116\x43\105\x5f\x49\x44"] ?? ''; goto B1e8b; b3e5c: if (!(false === is_null($apiToken))) { goto fb4f3; } goto D7669; b7199: if (!("\144\x65\166" == $_ENV["\101\x50\x50\x5f\x45\116\x56"])) { goto ea773; } goto ff3e4; f241a: ea773: goto a8d3f; d4501: fb4f3: goto dd1a7; ef52c: $apiToken = $this->configManager->get("\150\145\164\x7a\156\145\x72\x5f\x61\x70\151\x5f\164\x6f\153\x65\156"); goto b3e5c; dd1a7: $instance = new HetznerInstance($hetznerClient); goto A7b71; D7669: $hetznerClient->setToken($apiToken); goto d4501; Cc656: $hetznerClient = new HetznerClient(); goto ef52c; C1a95: $instance->setInstanceId($instanceId); goto f241a; eba6c: case CloudPanelEnvironment::CLOUD_PROVIDER_VULTR: goto d917c; D921a: if (!(false === is_null($apiKey))) { goto a254f; } goto C4c7d; d7d49: $instance->setInstanceId($instanceId); goto D5a53; a85f3: $ipv4PublicIp = $_ENV["\x44\x45\x56\137\x56\125\114\124\122\137\x49\x50\x5f\126\x34\137\x50\x55\x42\114\111\103"] ?? "\61\x32\x37\56\60\x2e\x30\56\61"; goto f5cca; c5c6e: a254f: goto B1bba; E3f5c: $apiKey = $this->configManager->get("\166\165\154\x74\162\x5f\141\x70\x69\x5f\x6b\x65\x79"); goto D921a; a3b3a: $instanceId = $_ENV["\104\x45\126\137\126\125\114\124\x52\137\111\116\x53\x54\101\116\103\105\x5f\x49\x44"] ?? ''; goto a85f3; E427f: if (!("\144\x65\x76" == $_ENV["\101\120\120\x5f\105\x4e\126"])) { goto cff5f; } goto a3b3a; c595a: $vultrClient->setVultrInstance($instance); goto E427f; Eeec2: $vultrClient = new VultrClient(); goto E3f5c; C4c7d: $vultrClient->setApiKey($apiKey); goto c5c6e; D5a53: cff5f: goto a8eb2; a8eb2: goto Ce5d8; goto F4e4f; B1bba: $instance = new VultrInstance($vultrClient); goto c595a; d917c: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_VULTR); goto Eeec2; f5cca: $instance->setIpv4PublicIp($ipv4PublicIp); goto d7d49; F4e4f: default: $instance = new Instance(); goto Ce5d8; } goto bfd84; F64da: $command = $event->getCommand(); goto Ead00; a7c74: putenv("\122\x45\123\137\x4f\x50\124\111\x4f\x4e\x53\x3d\x72\x65\164\x72\x61\x6e\x73\72\x31\x20\162\145\164\162\x79\x3a\61\x20\164\151\x6d\x65\157\165\164\72\x31\40\141\x74\x74\145\x6d\160\x74\163\x3a\61"); goto e42d2; bfd84: F2f9a: goto d87dc; A9a84: $environment = new CloudPanelEnvironment(); goto e5b70; D6254: Bb335: goto fc0ee; dc924: if (!(true === empty($ipv4PublicIp))) { goto Cfc39; } goto E6047; E6047: if (filter_var($host, FILTER_VALIDATE_IP)) { goto B9817; } goto a7c74; Aa187: $ipv4PublicIp = $instance->getIpv4PublicIp(); goto dc924; A32e8: B9817: goto E3b47; Ead00: $command->setInstance($instance); goto Da159; e8683: $hostname = gethostname(); goto a6185; D3437: if (!(false === is_null($instanceUid))) { goto ac6b8; } goto A295d; C3fe3: $request->attributes->set("\151\x6e\x73\164\x61\156\x63\145", $instance); goto Ef9f4; b9126: A5e7e: goto F43e6; F43e6: $request = $event->getRequest(); goto c3f0b; Befbf: goto Bb335; goto A32e8; aa693: A709a: goto a9825; F4e24: $instanceUid = $this->configManager->get("\151\x6e\x73\164\x61\156\x63\x65\137\x75\x69\x64"); goto D3437; A295d: $instance->setUid($instanceUid); goto e1f28; ae6da: $cloud = $this->configManager->get("\143\154\x6f\x75\144"); goto A9a84; be8bb: if ($event instanceof RequestEvent) { goto A5e7e; } goto F64da; e42d2: $ipv4PublicIp = gethostbyname($host); goto Dd390; fc0ee: Cfc39: goto C3fe3; d87dc: Ce5d8: goto F4e24; e1f28: ac6b8: goto Ca526; c3f0b: $host = $request->getHost(); goto Aa187; E3b47: $instance->setIpv4PublicIp($host); goto D6254; Da159: goto A709a; goto b9126; a9825: } public static function getSubscribedEvents() : array { return [KernelEvents::REQUEST => [["\x6f\x6e\x4b\x65\162\156\145\154\x52\x65\x71\165\145\x73\x74", 25]], ConsoleEvents::COMMAND => [["\x6f\x6e\103\x6f\x6e\x73\157\154\145\x43\157\x6d\x6d\141\156\144", 25]]]; } }
