<?php
 namespace App\Form; use Symfony\Component\Form\AbstractType; use Symfony\Component\Form\FormBuilderInterface; use Symfony\Component\OptionsResolver\OptionsResolverInterface; use Symfony\Component\Form\FormEvents; use Symfony\Component\Form\FormEvent; use Symfony\Component\Form\Extension\Core\Type\TextType; use Symfony\Component\Form\Extension\Core\Type\EmailType; use Symfony\Component\Validator\Constraints as Assert; use Symfony\Bridge\Doctrine\Form\Type\EntityType; use Symfony\Component\Form\Extension\Core\Type\ChoiceType; use Doctrine\ORM\EntityManagerInterface; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Repository\TimezoneRepository as TimezoneEntityRepository; use App\Entity\User as UserEntity; use App\Entity\Timezone as TimezoneEntity; use App\Validator\Constraints\UserSites as UserSitesConstraint; class AdminUserType extends AbstractType { private SiteEntityManager $siteEntityManager; private TimezoneEntityRepository $timezoneEntityRepository; public function __construct(SiteEntityManager $siteEntityManager, EntityManagerInterface $entityManager) { $this->siteEntityManager = $siteEntityManager; $this->timezoneEntityRepository = $entityManager->getRepository(TimezoneEntity::class); } public function buildForm(FormBuilderInterface $builder, array $options) : void { goto E32b1; fec1b: $roleChoices = ["\101\x64\155\151\156" => UserEntity::ROLE_ADMIN, "\125\163\145\x72" => UserEntity::ROLE_USER, "\123\151\x74\x65\x20\115\x61\x6e\141\147\x65\162" => UserEntity::ROLE_SITE_MANAGER]; goto aa013; E6364: $builder->add("\163\x74\x61\x74\x75\163", ChoiceType::class, ["\x72\145\x71\165\x69\162\145\144" => true, "\141\x74\x74\162" => ["\143\154\x61\x73\163" => "\146\x6f\162\x6d\x2d\163\x65\154\x65\x63\x74\40\146\157\162\155\55\163\145\x6c\145\143\164\x2d\x6c\147"], "\x6c\x61\x62\x65\154" => "\x53\x74\x61\164\165\x73", "\143\x68\157\151\143\145\x73" => $statusChoices]); goto fec1b; f302e: $builder->add("\163\x69\164\145\163", TextType::class, ["\154\x61\142\x65\x6c" => "\123\x69\164\x65\x73", "\x61\x74\164\x72" => ["\143\154\x61\163\x73" => "\144\55\x6e\157\156\145"], "\155\141\x70\x70\x65\x64" => false, "\x72\145\x71\x75\x69\x72\145\144" => false, "\143\x6f\x6e\x73\x74\x72\141\x69\x6e\x74\163" => [new UserSitesConstraint()]]); goto Fc080; aa013: $builder->add("\x72\x6f\x6c\145", ChoiceType::class, ["\162\x65\161\165\x69\162\145\144" => true, "\141\x74\164\x72" => ["\x63\154\x61\163\163" => "\146\x6f\162\155\x2d\x73\145\x6c\x65\x63\x74\40\x66\x6f\162\155\x2d\163\145\154\x65\x63\164\x2d\x6c\x67"], "\154\141\x62\x65\154" => "\x52\157\154\145", "\x63\x68\x6f\151\x63\145\163" => $roleChoices]); goto ccb61; e4d6e: $builder->add("\164\x69\x6d\x65\x7a\x6f\x6e\145", EntityType::class, ["\x72\x65\x71\x75\151\x72\x65\x64" => true, "\x61\x74\x74\162" => ["\x63\x6c\141\163\x73" => "\x66\x6f\162\155\55\x73\x65\x6c\145\143\164\x20\146\157\162\155\55\x73\145\x6c\x65\143\164\x2d\154\x67"], "\x6c\x61\142\x65\x6c" => "\x54\151\x6d\145\x7a\157\156\145", "\x63\x6c\141\163\163" => TimezoneEntity::class, "\x71\x75\145\162\x79\x5f\142\x75\151\x6c\x64\x65\x72" => function ($timezoneEntityRepository) { return $timezoneEntityRepository->createQueryBuilder("\x74")->orderBy("\164\56\151\x64", "\x41\x53\103"); }, "\143\x68\x6f\151\143\145\137\154\141\x62\145\154" => "\x6e\141\x6d\145"]); goto f302e; E32b1: $userEntity = $options["\144\x61\x74\141"]; goto cb942; E242a: $builder->add("\x6c\x61\163\164\x4e\141\x6d\x65", TextType::class, ["\x72\x65\x71\x75\151\x72\145\144" => true, "\141\x74\164\162" => ["\143\154\141\163\x73" => "\x66\x6f\x72\x6d\x2d\143\157\x6e\x74\x72\157\154\x20\146\157\162\x6d\x2d\143\x6f\156\164\x72\x6f\154\x2d\154\147"], "\x6c\141\142\145\154" => "\x4c\141\x73\x74\x20\x4e\141\x6d\145"]); goto Ad194; cb942: $userEntity->setPassword(''); goto B6a3e; f4d08: $statusChoices = ["\x41\x63\164\151\x76\145" => UserEntity::STATUS_ACTIVE, "\x4e\x6f\x74\40\x41\143\x74\x69\166\x65" => UserEntity::STATUS_NOT_ACTIVE]; goto E6364; Affef: $builder->add("\146\151\162\x73\x74\x4e\x61\x6d\145", TextType::class, ["\162\145\161\x75\x69\162\x65\x64" => true, "\141\164\164\162" => ["\x63\154\141\x73\163" => "\146\157\162\x6d\x2d\x63\x6f\156\164\162\157\x6c\x20\146\x6f\162\x6d\55\x63\157\156\164\162\x6f\154\x2d\x6c\x67"], "\x6c\x61\142\x65\154" => "\106\x69\162\x73\x74\x20\116\x61\x6d\x65"]); goto E242a; B52a9: $builder->add("\x65\155\141\151\154", EmailType::class, ["\x72\x65\161\165\x69\x72\x65\x64" => true, "\x61\x74\164\162" => ["\143\154\141\163\163" => "\x66\x6f\x72\155\55\143\x6f\x6e\x74\x72\157\154\x20\146\157\162\155\55\x63\x6f\156\164\162\157\x6c\55\x6c\x67"], "\x6c\x61\x62\145\154" => "\x45\x2d\115\141\151\154"]); goto Affef; ccb61: $timezoneEntityRepository = $this->timezoneEntityRepository; goto e4d6e; Fc080: $builder->addEventListener(FormEvents::PRE_SUBMIT, function (FormEvent $event) use($userEntity) { goto f74c6; D7be7: $data["\x66\151\x72\x73\164\x4e\141\x6d\145"] = true === isset($data["\146\x69\x72\x73\x74\x4e\x61\155\x65"]) ? ucfirst($data["\x66\x69\162\163\164\x4e\x61\x6d\145"]) : ''; goto Efe8a; eb28d: $data["\165\x73\145\x72\116\141\x6d\x65"] = true === isset($data["\165\163\145\x72\x4e\141\155\x65"]) ? strtolower($data["\165\163\145\x72\x4e\x61\x6d\145"]) : ''; goto D7be7; De456: $event->setData($data); goto af334; Efe8a: $data["\x6c\141\163\x74\116\141\x6d\x65"] = true === isset($data["\x6c\141\163\x74\116\x61\155\145"]) ? ucfirst($data["\x6c\x61\x73\x74\x4e\141\155\x65"]) : ''; goto De456; f74c6: $data = $event->getData(); goto eb28d; af334: }); goto E9ab2; Ad194: $builder->add("\160\154\x61\x69\156\120\141\x73\163\167\x6f\162\x64", TextType::class, ["\x72\x65\x71\165\x69\162\x65\144" => true, "\141\164\x74\162" => ["\143\x6c\x61\163\x73" => "\146\x6f\x72\155\x2d\x63\157\156\164\162\157\x6c\x20\x66\157\x72\155\55\143\157\156\x74\x72\157\x6c\x2d\154\147"], "\154\141\142\145\x6c" => "\x50\141\163\x73\x77\x6f\x72\x64", "\145\x6d\160\x74\171\x5f\x64\x61\164\x61" => null, "\x63\157\x6e\163\x74\x72\x61\151\156\x74\x73" => [new Assert\Length(["\x6d\x69\x6e" => UserEntity::PASSWORD_MIN_LENGTH, "\155\x61\170" => UserEntity::PASSWORD_MAX_LENGTH])]]); goto f4d08; B6a3e: $builder->add("\x75\x73\145\x72\x4e\141\155\145", TextType::class, ["\162\x65\x71\165\151\x72\x65\144" => true, "\x61\x74\164\162" => ["\x63\154\141\163\163" => "\146\157\162\x6d\x2d\x63\x6f\x6e\164\162\x6f\154\40\x66\x6f\x72\x6d\55\x63\157\x6e\x74\x72\x6f\154\55\154\x67"], "\x6c\x61\x62\145\x6c" => "\125\x73\x65\x72\40\116\x61\155\x65"]); goto B52a9; E9ab2: } public function setDefaultOptions(OptionsResolverInterface $resolver) : void { $resolver->setDefaults(["\x64\141\x74\141\137\143\x6c\141\163\163" => "\101\x70\160\134\x45\x6e\x74\x69\164\x79\134\125\163\145\162"]); } public function getName() : string { return "\143\154\x70\x5f\x61\144\155\x69\x6e\137\x75\163\x65\162"; } }
