<?php
 namespace App\Site\Nginx\Vhost; use App\Site\Site; use App\Site\Nginx\Vhost\Processor\Processor; use App\Site\Nginx\Vhost\Processor\RootDirectory as RootDirectoryProcessor; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; use App\Site\Nginx\Vhost\Processor\NginxAccessLog as NginxAccessLogProcessor; use App\Site\Nginx\Vhost\Processor\NginxErrorLog as NginxErrorLogProcessor; use App\Site\Nginx\Vhost\Processor\SslCertificateKey as NginxCertificateKeyProcessor; use App\Site\Nginx\Vhost\Processor\SslCertificate as NginxCertificateProcessor; use App\Site\Nginx\Vhost\Processor\Settings as SettingsProcessor; class Template { protected Site $site; protected ?string $content = null; protected array $placeholders = []; protected array $processors = []; public function __construct(Site $site) { $this->site = $site; $this->init(); } protected function init() : void { goto c9cb4; d8496: $nginxErrorLogProcessor = new NginxErrorLogProcessor(); goto e0abc; C53a7: $this->addProcessor($redirectDomainProcessor); goto C9b33; B9a5e: $nginxAccessLogProcessor = new NginxAccessLogProcessor(); goto d8496; bc405: $certificateProcessor = new NginxCertificateProcessor(); goto eaa3d; E9048: $this->addProcessor($rootDirectoryProcessor); goto E4fb0; a1365: $this->addProcessor($settingsProcessor); goto Aeb6f; c9cb4: $rootDirectoryProcessor = new RootDirectoryProcessor(); goto c6ab9; B16c8: $this->addProcessor($certificateKeyProcessor); goto ab87c; E4fb0: $this->addProcessor($serverNameProcessor); goto d44bb; d44bb: $this->addProcessor($redirectServerNameProcessor); goto C53a7; e0abc: $certificateKeyProcessor = new NginxCertificateKeyProcessor(); goto bc405; eaa3d: $settingsProcessor = new SettingsProcessor(); goto E9048; E616e: $this->addProcessor($nginxErrorLogProcessor); goto B16c8; ab87c: $this->addProcessor($certificateProcessor); goto a1365; c6ab9: $serverNameProcessor = new ServerNameProcessor(); goto b86d0; Fd26e: $redirectDomainProcessor = new RedirectDomainProcessor(); goto B9a5e; b86d0: $redirectServerNameProcessor = new RedirectServerNameProcessor(); goto Fd26e; C9b33: $this->addProcessor($nginxAccessLogProcessor); goto E616e; Aeb6f: } public function getSite() : Site { return $this->site; } public function setContent(string $content) : void { $this->content = $content; } public function getContent() : ?string { return $this->content; } public function build() : void { goto E12d9; Bad3b: $placeholders = $this->getPlaceholders(); goto f3bdd; E12d9: $processors = $this->getProcessors(); goto Bad3b; f3bdd: foreach ($placeholders as $placeholder) { goto a00b6; f4d7a: B7d66: goto c94ce; Bb6a7: $this->content = $processor->process($this->content); goto E60e6; E60e6: $this->removePlaceholder($placeholder); goto f4d7a; c3f58: $processor->setSite($this->site); goto Bb6a7; A8560: $processor = $processors[$placeholder]; goto c3f58; cc92d: if (!(true === $hasProcessor)) { goto B7d66; } goto A8560; c94ce: c4467: goto F9d36; a00b6: $hasProcessor = $this->hasProcessor($placeholder); goto cc92d; F9d36: } goto d7961; d7961: c468a: goto acf5f; acf5f: } public function removeEmptyPlaceholders() : void { goto e0897; bf3fa: foreach ($placeholders as $placeholder) { $this->content = str_replace($placeholder, '', $this->content); B01d0: } goto F2a24; e0897: $placeholders = $this->getPlaceholders(); goto bf3fa; F2a24: Fd4be: goto b275f; b275f: } protected function hasProcessor(string $placeholder) : bool { return isset($this->processors[$placeholder]); } protected function getProcessors() : array { return $this->processors; } public function addProcessor(Processor $processor) : void { $this->processors[$processor->getPlaceholder()] = $processor; } public function resetProcessors() : void { $this->processors = []; } public function getPlaceholders() : array { goto B2116; b8ace: return $this->placeholders; goto e4d21; adfc7: preg_match_all("\x2f\133\173\173\135\x7b\x32\175\x28\133\134\163\x61\55\172\101\55\x5a\60\55\x39\x5f\x5d\x2b\x29\x5b\175\x7d\x5d\173\x32\x7d\x2f", $this->content, $placeholders); goto C90b3; e332e: C7458: goto f611c; F1642: $placeholders = $placeholders[0]; goto A3526; A3526: foreach ($placeholders as $placeholder) { goto D7e45; F6666: if (!(false === empty($placeholder))) { goto ef096; } goto e74db; e74db: $this->addPlaceholder($placeholder); goto Eae97; Eae97: ef096: goto Ab157; D7e45: $placeholder = trim($placeholder); goto F6666; Ab157: Acbce: goto c23b9; c23b9: } goto e332e; B2116: if (!(true === empty($this->placeholders))) { goto F7d92; } goto adfc7; C90b3: if (!(true === isset($placeholders[0]) && count($placeholders[0]))) { goto C10d1; } goto F1642; f611c: C10d1: goto D2b6e; D2b6e: F7d92: goto b8ace; e4d21: } private function addPlaceholder(string $placeholder) : void { $this->placeholders[$placeholder] = $placeholder; } private function removePlaceholder(string $placeholder) : void { goto a6536; a6536: if (!(true === isset($this->placeholders[$placeholder]))) { goto e65a2; } goto Bad68; Bad68: unset($this->placeholders[$placeholder]); goto c90ee; c90ee: e65a2: goto ce1b6; ce1b6: } }
