<?php
 namespace App\Site; use App\System\Command\CopyFileCommand; use App\System\Command\DeleteFileCommand; use App\System\Command\NginxConfigTestCommand; use App\System\CommandExecutor; use App\System\Command\ChownCommand; use App\System\Command\FindChmodCommand; use App\System\Command\WriteFileCommand; use App\System\Command\CreateDirectoryCommand; use App\System\Command\DeleteDirectoryCommand; use App\System\Command\ChangeUserHomeDirectoryCommand; use App\System\Command\CreateUserCommand; use App\System\Command\DeleteUserCommand; use App\System\Command\ChangeUserPasswordCommand; use App\System\Command\CreateSymlinkCommand; use App\System\Command\ServiceReloadCommand; use App\Entity\BasicAuth as BasicAuthEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\FtpUser as FtpUserEntity; use App\Entity\SshUser as SshUserEntity; use App\Entity\Site as SiteEntity; use App\Site\Ssl\LetsEncrypt\CertificateOrder; use App\Site\Nginx\Exception\InvalidVhostException; use App\Site\Nginx\Vhost\StaticTemplate; use App\Site\Nginx\Vhost\NodejsTemplate; use App\Site\Nginx\Vhost\PhpTemplate; use App\Site\Nginx\Vhost\PythonTemplate; abstract class Updater { public const NGINX_BASIC_AUTH_DIRECTORY = "\57\145\x74\143\57\x6e\147\x69\156\170\x2f\x62\141\x73\x69\x63\x2d\141\x75\164\x68\x2f"; public const NGINX_VHOST_DIRECTORY = "\57\145\164\143\57\x6e\147\151\156\170\57\x73\151\164\x65\163\55\145\156\141\142\154\x65\144\x2f"; public const NGINX_SSL_CERTIFICATES_DIRECTORY = "\x2f\145\x74\143\57\x6e\147\151\x6e\170\x2f\163\163\154\x2d\143\145\162\164\x69\146\151\143\x61\x74\145\x73\57"; public const CRON_DIRECTORY = "\x2f\145\x74\143\57\143\162\157\x6e\56\144\57"; protected Site $site; protected CommandExecutor $commandExecutor; public function __construct(Site $site) { $this->site = $site; $this->commandExecutor = new CommandExecutor(); } public function domainSettings() : void { $this->updateNginxVhost(); $this->reloadNginxService(); } public function updateNginxVhost() : void { goto ce215; ce215: $domainName = $this->site->getDomainName(); goto Ff140; Cd48d: $vhostContent = $vhostTemplate->getContent(); goto Cb8e4; c860b: $vhostTemplate->build(); goto C4a65; Cb8e4: $writeVhostFileCommand = new WriteFileCommand(); goto E9c76; b0559: $vhostTemplate->setContent($vhostFileContent); goto bd024; E1dae: f5ef8: goto b0559; abed7: $writeVhostFileCommand->setContent($vhostContent); goto e7105; e7105: $this->commandExecutor->execute($writeVhostFileCommand); goto B9153; E9c76: $writeVhostFileCommand->setFile($vhostFile); goto abed7; eda57: B4c67: goto E1dae; dabaf: switch ($this->site->getType()) { case SiteEntity::TYPE_PHP: $vhostTemplate = new PhpTemplate($this->site); goto f5ef8; case SiteEntity::TYPE_NODEJS: $vhostTemplate = new NodejsTemplate($this->site); goto f5ef8; case SiteEntity::TYPE_STATIC: $vhostTemplate = new StaticTemplate($this->site); goto f5ef8; case SiteEntity::TYPE_PYTHON: $vhostTemplate = new PythonTemplate($this->site); goto f5ef8; } goto eda57; C4a65: $vhostTemplate->removeEmptyPlaceholders(); goto Cd48d; bd024: $vhostFile = sprintf("\x25\x73\x2f\45\163\x2e\x63\x6f\x6e\146", rtrim(self::NGINX_VHOST_DIRECTORY, "\x2f"), $domainName); goto c860b; Ff140: $vhostFileContent = $this->site->getVhostTemplate(); goto dabaf; B9153: } public function updateNginxVhostWithRollback() : void { try { goto d200a; D24bc: $writeVhostFileCommand->setFile($vhostFile); goto a5fa3; D31d3: $deleteVhostBackupFileCommand = new DeleteFileCommand(); goto E6ad9; ffaf1: $writeVhostFileCommand = new WriteFileCommand(); goto D24bc; ee5af: if (!("\144\145\x76" != $_ENV["\x41\x50\120\137\105\x4e\x56"])) { goto c1216; } goto ed103; F39f4: $nginxConfigTestCommand = new NginxConfigTestCommand(); goto D31d3; A2cde: $this->commandExecutor->execute($nginxConfigTestCommand); goto ee5af; Cb181: $vhostFileContent = $this->site->getVhostTemplate(); goto A3633; cce7c: $vhostTemplate->removeEmptyPlaceholders(); goto C3312; cc637: $copyVhostBackupFileCommand->setSourceFile($vhostFile); goto B5453; c2ea2: Dbaca: goto c5e9e; B5453: $copyVhostBackupFileCommand->setDestinationFile($vhostBackupFile); goto ffaf1; d200a: $domainName = $this->site->getDomainName(); goto Cb181; c5e9e: $vhostTemplate->setContent($vhostFileContent); goto baa40; B63c0: $vhostBackupFile = sprintf("\x25\163\57\45\163\56\x63\157\156\146\x2e\x62\141\153", rtrim(self::NGINX_VHOST_DIRECTORY, "\x2f"), $domainName); goto Ed093; B8211: c1216: goto E7c33; baa40: $vhostFile = sprintf("\45\163\x2f\x25\x73\x2e\x63\x6f\156\146", rtrim(self::NGINX_VHOST_DIRECTORY, "\57"), $domainName); goto a5e39; ed103: $reloadNginxServiceCommand = new ServiceReloadCommand(); goto b497e; E7c33: $this->commandExecutor->execute($deleteVhostBackupFileCommand); goto D37b4; b497e: $reloadNginxServiceCommand->setServiceName("\x6e\147\x69\x6e\x78"); goto Ffa8e; be1a7: $this->commandExecutor->execute($copyVhostBackupFileCommand); goto B01b0; E6ad9: $deleteVhostBackupFileCommand->setFile($vhostBackupFile); goto be1a7; Ed093: $copyVhostBackupFileCommand = new CopyFileCommand(); goto cc637; a5e39: $vhostTemplate->build(); goto cce7c; a5fa3: $writeVhostFileCommand->setContent($vhostContent); goto F39f4; C3312: $vhostContent = $vhostTemplate->getContent(); goto B63c0; A3633: switch ($this->site->getType()) { case SiteEntity::TYPE_PHP: $vhostTemplate = new PhpTemplate($this->site); goto Dbaca; case SiteEntity::TYPE_NODEJS: $vhostTemplate = new NodejsTemplate($this->site); goto Dbaca; case SiteEntity::TYPE_STATIC: $vhostTemplate = new StaticTemplate($this->site); goto Dbaca; case SiteEntity::TYPE_PYTHON: $vhostTemplate = new PythonTemplate($this->site); goto Dbaca; } goto Cc99d; Ffa8e: $this->commandExecutor->execute($reloadNginxServiceCommand); goto B8211; Cc99d: B0edd: goto c2ea2; B01b0: $this->commandExecutor->execute($writeVhostFileCommand); goto A2cde; D37b4: } catch (\Exception $e) { goto a2273; da06b: if (!(true === isset($reloadNginxServiceCommand))) { goto e7dd9; } goto d2ec3; Fb546: $restoreBackupFileCommand->setDestinationFile($vhostFile); goto Bfb57; E0739: throw new InvalidVhostException($errorMessage); goto E8fbe; F9209: if (!(true === isset($nginxConfigTestCommand))) { goto B2259; } goto afa0d; a7c65: $this->commandExecutor->execute($deleteVhostBackupFileCommand); goto E0739; Bfb57: $this->commandExecutor->execute($restoreBackupFileCommand); goto da06b; afa0d: $errorMessage = $nginxConfigTestCommand->getOutput(); goto dc032; a2273: $errorMessage = $e->getMessage(); goto F9209; B6321: e7dd9: goto a7c65; dc032: B2259: goto Ba9b4; Ba9b4: $restoreBackupFileCommand = new CopyFileCommand(); goto B5cb0; d2ec3: $this->commandExecutor->execute($reloadNginxServiceCommand); goto B6321; B5cb0: $restoreBackupFileCommand->setSourceFile($vhostBackupFile); goto Fb546; E8fbe: } } public function createSshUser(SshUserEntity $sshUserEntity) : void { goto e3f16; B7d57: $createUserCommand->setGroup($siteUser); goto F2334; C38a3: $createUserCommand->setHomeDirectory($homeDirectory); goto F6c74; ea46d: $sshUserName = $sshUserEntity->getUserName(); goto Efb2a; c2089: $sshDirectory = sprintf("\x2f\x68\x6f\x6d\x65\x2f\45\x73\x2f\x2e\x73\x73\150", $sshUserName); goto e7e0c; F2334: $createUserCommand->setShell("\x2f\x62\151\156\57\142\x61\x73\150"); goto aa7cf; F2fa9: E0ae7: goto c2089; B9de2: $siteUser = $site->getUser(); goto ea46d; Fa97f: foreach ($symlinkDirectories as $symlinkDirectory) { goto A0220; ebb1e: $symlinkCommand->setDestination($destination); goto d71d0; A0220: $source = sprintf("\57\150\x6f\x6d\145\57\x25\163\x2f\45\163", $siteUser, $symlinkDirectory); goto db50e; c344d: $symlinkCommand = new CreateSymlinkCommand(); goto eb6d5; dbd64: $this->commandExecutor->execute($symlinkCommand); goto faf34; d71d0: if (!("\144\145\x76" != $_ENV["\x41\120\120\x5f\105\116\x56"])) { goto bf46a; } goto dbd64; E8c72: f72cd: goto E1719; db50e: $destination = sprintf("\x2f\x68\x6f\155\145\57\x25\163\x2f\x25\163", $sshUserName, $symlinkDirectory); goto c344d; eb6d5: $symlinkCommand->setRunAsUser($sshUserName); goto D169c; D169c: $symlinkCommand->setSource($source); goto ebb1e; faf34: bf46a: goto E8c72; E1719: } goto F2fa9; b6481: $this->commandExecutor->execute($createUserCommand); goto e859c; e7e0c: $sshDirectoryChmodCommand = new FindChmodCommand(); goto A21b5; A21b5: $sshDirectoryChmodCommand->setFile($sshDirectory); goto D37bb; D1c6d: $createUserCommand = new CreateUserCommand(); goto Faea0; f4a2e: $createUserCommand->setPassword($sshUserPassword); goto B7d57; F9bff: $sshDirectoryChmodCommand->setFileChmod(600); goto D1cf4; Faea0: $createUserCommand->setUserName($sshUserName); goto f4a2e; D17d9: $skeletonDirectory = realpath(dirname(__FILE__) . "\57\x2e\56\x2f\56\56\57\x72\145\x73\x6f\165\162\143\145\x73\x2f\145\x74\143\x2f\163\153\x65\154\57\x73\x73\150\x2d\165\x73\145\162\x2f"); goto D1c6d; e859c: $symlinkDirectories = ["\142\141\143\153\x75\x70\x73", "\150\x74\144\157\143\x73", "\154\x6f\x67\x73"]; goto Fa97f; aa7cf: $createUserCommand->setSkeletonDirectory($skeletonDirectory); goto C38a3; e3f16: $site = $sshUserEntity->getSite(); goto B9de2; F6c74: $createUserCommand->createHomeDirectory(true); goto b6481; D1cf4: $this->commandExecutor->execute($sshDirectoryChmodCommand); goto D676d; bc5c3: $homeDirectory = sprintf("\x2f\x68\x6f\155\145\57\45\x73", $sshUserName); goto D17d9; D37bb: $sshDirectoryChmodCommand->setDirectoryChmod(700); goto F9bff; Efb2a: $sshUserPassword = $sshUserEntity->getPassword(); goto bc5c3; D676d: } public function createFtpUser(FtpUserEntity $ftpUserEntity) : void { goto f7dc7; b911c: $createUserCommand->setUserName($ftpUserName); goto Dc8e0; d2b6c: $createUserCommand->setHomeDirectory($homeDirectory); goto B469e; Dc8e0: $createUserCommand->setPassword($ftpUserPassword); goto d2346; B469e: $createUserCommand->createHomeDirectory(false); goto c6c33; ab793: $createUserCommand->setShell("\57\x62\x69\x6e\57\146\141\154\163\x65"); goto d2b6c; f7dc7: $site = $ftpUserEntity->getSite(); goto ad2af; e56b4: $createUserCommand = new CreateUserCommand(); goto b911c; d2346: $createUserCommand->setGroup($siteUser); goto F30da; d5711: $ftpUserPassword = $ftpUserEntity->getPassword(); goto Dcff4; b9fb6: $ftpUserName = $ftpUserEntity->getUserName(); goto d5711; ad2af: $siteUser = $site->getUser(); goto b9fb6; Dcff4: $homeDirectory = $ftpUserEntity->getHomeDirectory(); goto e56b4; c6c33: $this->commandExecutor->execute($createUserCommand); goto F0d68; F30da: $createUserCommand->setGroups(["\x66\x74\x70\x2d\165\163\145\x72"]); goto ab793; F0d68: } public function deleteUser(string $userName, $removeHomeDirectory = true) : void { goto B3f8f; Cfbb5: $deleteUserCommand->setUserName($userName); goto C1996; B8ad5: $this->commandExecutor->execute($deleteUserCommand); goto C0828; C1996: $deleteUserCommand->setRemoveHomeDirectory($removeHomeDirectory); goto B8ad5; B3f8f: $deleteUserCommand = new DeleteUserCommand(); goto Cfbb5; C0828: } public function installCertificate(CertificateEntity $certificateEntity) : void { goto C54e0; C54e0: $domainName = $this->site->getDomainName(); goto A05ab; C6df4: $writePrivateKeyFileCommand = new WriteFileCommand(); goto D6081; Bedac: $this->commandExecutor->execute($writeCertificateFileCommand); goto bc9f5; F1011: fdd39: goto C6df4; B18c9: if (!(false === empty($certificateEntity->getCertificateChain()))) { goto fdd39; } goto fe9d1; D6081: $writePrivateKeyFileCommand->setFile($privateKeyFile); goto Dfe2e; e1166: $writeCertificateFileCommand->setFile($certificateFile); goto dfc39; d7c18: $writeCertificateFileCommand = new WriteFileCommand(); goto e1166; e549e: $this->commandExecutor->execute($writePrivateKeyFileCommand); goto Bedac; dbfc3: $certificateFile = sprintf("\45\163\57\x25\x73\x2e\143\162\164", rtrim(self::NGINX_SSL_CERTIFICATES_DIRECTORY, "\x2f"), $domainName); goto F6475; bc9f5: $this->reloadService("\156\147\x69\x6e\x78"); goto Ea75f; fe9d1: $certificate .= sprintf("\x25\163\45\x73", PHP_EOL, trim($certificateEntity->getCertificateChain())); goto F1011; A05ab: $privateKeyFile = sprintf("\x25\163\57\x25\x73\x2e\x6b\x65\x79", rtrim(self::NGINX_SSL_CERTIFICATES_DIRECTORY, "\x2f"), $domainName); goto dbfc3; dfc39: $writeCertificateFileCommand->setContent($certificate); goto e549e; F6475: $certificate = $certificateEntity->getCertificate(); goto B18c9; Dfe2e: $writePrivateKeyFileCommand->setContent($certificateEntity->getPrivateKey()); goto d7c18; Ea75f: } public function deleteLetsEncryptChallengeDirectory() { goto B1380; B1380: $rootDirectory = $this->getRootDirectory(); goto b8422; C4664: $this->commandExecutor->execute($deleteAcmeChallengeDirectoryCommand); goto E0588; b0349: $deleteAcmeChallengeDirectoryCommand = new DeleteDirectoryCommand(); goto e2c44; b8422: $acemeChallengeDirectory = sprintf("\45\163\x2f\x2e\167\145\x6c\154\x2d\x6b\x6e\x6f\x77\156\x2f", rtrim($rootDirectory, "\57")); goto b0349; e2c44: $deleteAcmeChallengeDirectoryCommand->setDirectory($acemeChallengeDirectory); goto C4664; E0588: } public function createBasicAuthFile(BasicAuthEntity $basicAuthEntity) { goto c6c4e; c6c4e: $basicAuthFile = sprintf("\x25\x73\57\45\163", rtrim(self::NGINX_BASIC_AUTH_DIRECTORY, "\x2f"), $this->site->getDomainName()); goto Dda97; beeda: $writeBasicAuthFileCommand = new WriteFileCommand(); goto D47d5; D9039: $writeBasicAuthFileCommand->setContent($basicAuthFileContent); goto e6dc5; e6dc5: $this->commandExecutor->execute($writeBasicAuthFileCommand); goto Ae48a; D47d5: $writeBasicAuthFileCommand->setFile($basicAuthFile); goto D9039; Dda97: $basicAuthFileContent = sprintf("\x25\x73\72\x25\x73", $basicAuthEntity->getUserName(), crypt($basicAuthEntity->getPassword(), base64_encode($basicAuthEntity->getPassword()))); goto beeda; Ae48a: } public function createLetsEncryptChallengeFiles(CertificateOrder $certificateOrder) : void { goto D57b3; d236f: $rootDirectory = $this->getRootDirectory(); goto ce2b7; Af694: $acemeChallengeDirectory = sprintf("\45\163\57\56\x77\145\x6c\x6c\x2d\153\156\x6f\167\156\x2f\141\143\x6d\x65\55\x63\150\141\x6c\x6c\145\x6e\x67\145\x2f", rtrim($rootDirectory, "\x2f")); goto Ed730; a61cd: $this->commandExecutor->execute($chmodWellKnownDirectoryCommand); goto f4fff; Ef429: $chmodWellKnownDirectoryCommand->setDirectoryChmod(750); goto Ea40c; D57b3: $siteUser = $this->site->getUser(); goto d236f; Ed730: $challenges = $certificateOrder->getAuthorizationsChallenges(); goto fb205; F67cc: $chownWellKnownDirectoryCommandCommand->setRecursive(true); goto fc188; F738b: $this->commandExecutor->execute($createAcmeChallengeDirectoryCommand); goto C1380; bf6f8: $chownWellKnownDirectoryCommandCommand->setFile($wellKnownDirectory); goto F67cc; acb6f: c3afa: goto C29cf; fb205: $createAcmeChallengeDirectoryCommand = new CreateDirectoryCommand(); goto c36aa; a5307: $chmodWellKnownDirectoryCommand->setFile($wellKnownDirectory); goto Ef429; C29cf: $chownWellKnownDirectoryCommandCommand = new ChownCommand(); goto bf6f8; f7011: foreach ($challenges as $challenge) { goto b4fdb; C79c2: $challengeFile = sprintf("\x25\x73\x2f\45\163", rtrim($acemeChallengeDirectory, "\x2f"), $token); goto b00dd; b00dd: $challengeWriteFileCommand = new WriteFileCommand(); goto fce6c; D1844: if (!(false === is_null($token) && false === is_null($verificationContent))) { goto abe94; } goto C79c2; F1d26: B36aa: goto Be142; fce6c: $challengeWriteFileCommand->setFile($challengeFile); goto a9be8; db05c: abe94: goto F1d26; b7453: $verificationContent = $challenge["\166\145\x72\x69\x66\151\143\141\x74\151\157\x6e\x43\x6f\x6e\x74\145\x6e\164"] ?? null; goto D1844; b8f26: $this->commandExecutor->execute($challengeWriteFileCommand); goto db05c; b4fdb: $token = $challenge["\x74\x6f\153\x65\156"] ?? null; goto b7453; a9be8: $challengeWriteFileCommand->setContent($verificationContent); goto b8f26; Be142: } goto b1b82; Ea40c: $chmodWellKnownDirectoryCommand->setFileChmod(770); goto ce546; fc534: $chownWellKnownDirectoryCommandCommand->setGroup($siteUser); goto B45a8; b1b82: B7d38: goto acb6f; C1380: if (!count($challenges)) { goto c3afa; } goto f7011; fc188: $chownWellKnownDirectoryCommandCommand->setUser($siteUser); goto fc534; c36aa: $createAcmeChallengeDirectoryCommand->setDirectory($acemeChallengeDirectory); goto F738b; ce2b7: $wellKnownDirectory = sprintf("\45\x73\57\56\x77\145\154\154\x2d\x6b\x6e\x6f\167\156\57", rtrim($rootDirectory, "\57")); goto Af694; B45a8: $chmodWellKnownDirectoryCommand = new FindChmodCommand(); goto a5307; ce546: $this->commandExecutor->execute($chownWellKnownDirectoryCommandCommand); goto a61cd; f4fff: } public function updateUserCrontab() : void { goto E23e9; f7a9a: $writeCrontabFileCommand = new WriteFileCommand(); goto Fab1a; a06d1: C555c: goto a7360; E23e9: $siteUser = $this->site->getUser(); goto Cb442; B7d7b: foreach ($cronJobs as $cronJob) { $crontabEntries[] = $cronJob->getCrontabExpression(); ab4c9: } goto b03bb; b03bb: cf5e6: goto a06d1; Bc32e: $writeCrontabFileCommand->setContent($crontabContent); goto d9471; Fab1a: $writeCrontabFileCommand->setFile($crontabFile); goto Bc32e; c1ea5: $crontabEntries = ["\x4d\x41\x49\114\x54\117\75\42\42"]; goto b9a91; a7360: $crontabContent = implode(PHP_EOL, $crontabEntries); goto f7a9a; b9a91: $cronJobs = $this->site->getCronJobs(); goto e2073; e2073: if (!count($cronJobs)) { goto C555c; } goto B7d7b; d9471: $this->commandExecutor->execute($writeCrontabFileCommand); goto D26e4; Cb442: $crontabFile = sprintf("\45\x73\x2f\45\163", rtrim(self::CRON_DIRECTORY, "\57"), $siteUser); goto c1ea5; D26e4: } public function purgePageSpeedCache() : void { goto f90c9; C0042: $cacheDirectory = sprintf("\x2f\x68\x6f\x6d\x65\57\x25\163\x2f\164\x6d\160\x2f\x70\x61\147\145\x73\160\x65\x65\x64\x5f\143\x61\x63\150\145\57\x2a", $siteUser); goto af42a; f90c9: $siteUser = $this->site->getUser(); goto C0042; a4dd8: $this->commandExecutor->execute($purgePageSpeedCacheFilesCommand, 300); goto A9aae; af42a: $purgePageSpeedCacheFilesCommand = new DeleteDirectoryCommand(); goto Cdec2; Cdec2: $purgePageSpeedCacheFilesCommand->setDirectory($cacheDirectory); goto a4dd8; A9aae: } public function updateUserSShKeys(string $userName, $sshKeys) : void { goto E3c5b; E3c5b: $authorizedKeysFile = sprintf("\57\x68\x6f\x6d\x65\57\45\163\57\x2e\163\163\x68\57\141\x75\x74\x68\157\x72\151\x7a\145\144\137\x6b\145\x79\x73", $userName); goto Dcea9; Dcea9: $writeAuthorizedKeysFileCommand = new WriteFileCommand(); goto De71f; Fd579: $this->commandExecutor->execute($writeAuthorizedKeysFileCommand); goto b8fc2; De71f: $writeAuthorizedKeysFileCommand->setFile($authorizedKeysFile); goto C5b62; C5b62: $writeAuthorizedKeysFileCommand->setContent($sshKeys); goto Fd579; b8fc2: } public function changeUserHomeDirectory(string $userName, string $homeDirectory) : void { goto c8e70; Bcb0f: $changeUserHomeDirectoryCommand->setUserName($userName); goto a77e8; bad95: $this->commandExecutor->execute($changeUserHomeDirectoryCommand); goto Ac2e3; c8e70: $changeUserHomeDirectoryCommand = new ChangeUserHomeDirectoryCommand(); goto Bcb0f; a77e8: $changeUserHomeDirectoryCommand->setHomeDirectory($homeDirectory); goto bad95; Ac2e3: } public function changeUserPassword(string $userName, string $password) : void { goto dee11; c84ed: $changeUserPasswordCommand->setPassword($password); goto faee2; faee2: $this->commandExecutor->execute($changeUserPasswordCommand); goto e9810; b8922: $changeUserPasswordCommand->setUserName($userName); goto c84ed; dee11: $changeUserPasswordCommand = new ChangeUserPasswordCommand(); goto b8922; e9810: } protected function getRootDirectory() : string { goto cdc60; cdc60: $siteUser = $this->site->getUser(); goto D519f; eb2e9: return $rootDirectory; goto Cd334; ae660: $rootDirectory = sprintf("\57\x68\x6f\x6d\x65\x2f\45\x73\x2f\150\x74\144\157\x63\x73\57\45\x73", $siteUser, $rootDirectory); goto eb2e9; D519f: $rootDirectory = $this->site->getRootDirectory(); goto ae660; Cd334: } public function reloadNginxService() : void { $this->reloadService("\x6e\x67\x69\x6e\170"); } public function reloadService($serviceName) { goto b070f; d9132: $this->commandExecutor->execute($reloadServiceCommand); goto Cae72; b070f: if (!("\144\x65\166" != $_ENV["\x41\x50\120\137\x45\116\126"])) { goto D4ea4; } goto a960e; Cae72: D4ea4: goto B4e68; f0581: $reloadServiceCommand->setServiceName($serviceName); goto d9132; a960e: $reloadServiceCommand = new ServiceReloadCommand(); goto f0581; B4e68: } }
